#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5;
const int M = 3e5;

int n, m;

int par[N], sz[N];
int ans[M];
int ptr;

int find_set(int x) {
    if(par[x] == x) return x;
    else return par[x] = find_set(par[x]);
}

bool unite_sets(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if(a == b) {
        return 0;
    }
    if(sz[a] > sz[b]) swap(a, b);
    sz[b] += sz[a];
    par[a] = b;
    return 1;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    fr(i, 0, n - 1) par[i] = i, sz[i] = 1;

    fr(i, 0, n - 1) ans[i] = i;
    ptr = n;

    ve<pii> e;

    fr(i, 0, m - 1) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if(unite_sets(a, b)) {
            e.pb({a, b});
        } else {
            ans[ptr] = b;
            e.pb({a, ptr});
            ptr++;
        }
    }

    cout << m + 1 << "\n";
    fr(i, 0, m) {
        cout << ans[i] + 1 << " ";
    }
    cout << "\n";

    fe(x, e) {
        cout << x.fi + 1 << " " << x.se + 1 << "\n";
    }

    return 0;
}
