#include <bits/stdc++.h>

using namespace std;

const long long M = 1e9 + 6, INF = 2e18 + 9;

long long div_ceil(long long a, long long b) {
	return (a + b - 1) / b;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	
	long long n; cin >> n;
	
	long long ans = INF;
	
	for(long long i = 1; i * i <= n; i++) {
		if(n % i == 0) {
			ans = min(ans, abs((n / i) - i));
		}
	} 
	
	long long low = 1, high = M, x = INF;
	
	while(low <= high) {
		long long mid = low + (high - low) / 2;
		if(mid * mid + (mid - 1) * (mid - 1) >= n) {
			high = mid - 1;
			x = mid;
		}
		else {
			low = mid + 1;
		}
	}
	
	cout << min(ans, abs(div_ceil(n, x) - x));
	
	return 0;
}
