#include<iostream>
#include<unordered_map>
#include<fstream>
#include<algorithm>
#include <string>
#include<unordered_set>
#include<stack>
using namespace std;
#define ll long long

vector<vector<int>> graph;
int res = 0;
unordered_set<int> vertices;
void dfs(int v, int krat,vector<bool> used) {
	used[v] = true;
	if (krat > 3) return;
	if (krat == 3) {
		if (vertices.find(v) != vertices.end()) {
			res++;
		}
		return;
	}
	for (auto i : graph[v]) {
		if(!used[i])
			dfs(i, krat + 1,used);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m;
	cin >> n >> m;
	graph = vector<vector<int>>(n,vector<int>(0));

	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		graph[u].push_back(v);
		graph[v].push_back(u);
	}
	vertices = unordered_set<int>();
	for (int i = 0; i < graph[0].size(); i++) {
		vertices.insert(graph[0][i]);
	}
	vector<bool> used(n,false);
	dfs(0, 0,used);
	cout << res;
	return 0;
}