/// two to the one from the one to the three 

#pragma GCC optimize("O3")
//#pragma comment(linker, "/STACK:36777216")

#include<bits/stdc++.h>

#define x first
#define y second
#define pb push_back
#define sz(x) (int) x.size()
#define all(z) (z).begin(), (z).end()
 
using namespace std;

using ll = long long;
using pii = pair<int, int>;                                   

const int MOD = 1e9 + 7;
const int INF = 1e9 + 1e2;
  
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fin() {
#ifdef AM
    freopen(".in", "r", stdin);
#endif        
}                   

const bool flag = 0;

const int N = 1e6+10;

struct pt {
    double x, y;
};

bool cmp (pt a, pt b) {
    return a.x < b.x || a.x == b.x && a.y < b.y;
}

bool cw (pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}

bool ccw (pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

void convex_hull (vector<pt> & a) {
    if (a.size() == 1)  return;
    sort (a.begin(), a.end(), &cmp);
    pt p1 = a[0],  p2 = a.back();
    vector<pt> up, down;
    up.push_back (p1);
    down.push_back (p1);
    for (size_t i=1; i<a.size(); ++i) {
        if (i==a.size()-1 || cw (p1, a[i], p2)) {
            while (up.size()>=2 && !cw (up[up.size()-2], up[up.size()-1], a[i]))
                up.pop_back();
            up.push_back (a[i]);
        }
        if (i==a.size()-1 || ccw (p1, a[i], p2)) {
            while (down.size()>=2 && !ccw (down[down.size()-2], down[down.size()-1], a[i]))
                down.pop_back();
            down.push_back (a[i]);
        }
    }
    a.clear();
    for (size_t i=0; i<up.size(); ++i)
        a.push_back (up[i]);
    for (size_t i=down.size()-2; i>0; --i)
        a.push_back (down[i]);
}

const int DX[] = {+1, -1, 0, 0};
const int DY[] = {0, 0, +1, -1};

double sq(double x) {
    return x*x;
}

double dist(pt a, pt b) {
    return sqrt(sq(a.x-b.x) + sq(a.y-b.y));
}

void ma1n() {
    int n, l;
    cin >> n >> l;
    vector<pt> a(n);
    for (pt& x : a) {
        cin >> x.x >> x.y;
    }
    vector<pt> b;
    for (pt& r : a) {
        int x = r.x, y = r.y;
        for (int i = 0; i < 4; ++i) {
            double ux = x + DX[i]*l;
            double uy = y + DY[i]*l;
            b.pb({ux, uy});
        }
    }
    convex_hull(b);
    double ans = 0;
    for (int i = 1; i < sz(b); ++i) {
        ans += dist(b[i-1], b[i]);
    }      
    ans += dist(b[0], b.back());
    cout << setprecision(10) << fixed << ans;
}                                                  

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr), fin();
    int ts = 1;
    if (flag) {
        cin >> ts;
    }
    while (ts--) {
        ma1n(); 
    }
    return 0;
}