#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;

const int N = 2e5;

int sz[N], p[N], c[N];
vector<pair<int, int>> e;

int get(int v) {
	return (p[v] == v ? v : p[v] = get(p[v]));
}

void unite(int u, int v) {
	u = get(u);
	v = get(v);
	if (sz[u] < sz[v]) swap(u, v);
	sz[u] += sz[v];
	p[v] = u;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);     
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		sz[i] = 1;
		p[i] = i;
	}
	int cnt = n + 1;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		c[u] = u;
		if (get(u) == get(v)) {
			e.pb({u, cnt});
			c[cnt] = v;
			++cnt;
			continue;
	   	}
	   	c[v] = v;
	   	e.pb({u, v});
	   	unite(u, v);
	}
	cout << m + 1 << "\n";
	for (int i = 1; i <= m + 1; i++) cout << c[i] << ' ';
	cout << "\n";
	for (auto x : e) cout << x.first << ' ' << x.second << "\n";
	return 0;
}