#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

mt19937 gen(time(0));

//#define int ll
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)(x.size())
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int N = 1e3 + 5;
vector<int> g[N], gr[N];
int dp[(int)1e4 + 5][(int)1e4 + 5];

inline int calc(string a, string b) {
  int n = size(a), m = size(b);
  a += "#";
  b += "#";
  for(int i = 0; i < n + 5; i++) {
    fill(dp[i], dp[i] + m + 5, 1e9);
  }
  dp[0][0] = 0;
  for(int i = 0; i <= n; i++) {
    for(int j = 0; j <= m; j++) {
      chkmin(dp[i][j + 1], dp[i][j] + 1);
      chkmin(dp[i + 1][j], dp[i][j] + 1);
      if (a[i] == b[j]) {
        chkmin(dp[i + 1][j + 1], dp[i][j]);
      }
      chkmin(dp[i + 1][j + 1], dp[i][j] + 1);
    }
  }
  return dp[n][m];
}

int used[N];
vector<int> ord;
void dfs(int v) {
  used[v] = 1;
  for(int to : gr[v]) {
    if (!used[to]) {
      dfs(to);
    }
  }
  ord.push_back(v);
}

int p[N];
int dpe[N];

void run() {
  string s, t;
  cin >> s >> t;
  int n;
  cin >> n;
  vector<string> a(n + 2);
  a[0] = s;
  a[n + 1] = t;
  for(int i = 1; i <= n; i++) {
    cin >> a[i];
  }
  vector<int> dist(n + 2);
  for(int i = 0; i < size(a); i++) {
    dist[i] = calc(a[i], t);
  }
  for(int i = 0; i < size(a); i++) {
    for(int j = 0; j < size(a); j++) {
      if (i == j) continue;
      if (dist[i] - calc(a[i], a[j]) == dist[j]) {
        g[i].push_back(j);
        gr[j].push_back(i);
      }
    }
  }
  for(int i = 0; i < size(a); i++) {
    if (!used[i]) {
      dfs(i);
    }
  }
  fill(dpe, dpe + N, -1e9);
  dpe[0] = 0;
  for(int i : ord) {
    for(int x : g[i]) {
      int r = dpe[i];
      if (x != n + 1) r++;
      if (dpe[x] < r) {
        dpe[x] = r;
        p[x] = i;
      }
      chkmax(dpe[x], r);
    }
  }
  cout << dist[0] << ' ' << dpe[n + 1] << endl;
  vector<int> de;
  int v = p[n + 1];
  while (v) {
    de.push_back(v);
    v = p[v];
  }
  reverse(all(de));
  for(int x : de) cout << a[x] << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  run();
}
