#include <bits/stdc++.h>

using namespace std;

int n, m;
vector < vector <int> > g;
vector < set <int> > e;
int ans = 0;

void search(int v, int num, int par) {
	if (num > 3) return;
	if (num == 3) {
		if (e[v].find(0) != e[v].end()) 
			ans++;
		return;
	}
	
	for (int i = 0; i < g[v].size(); i++) {
		int to = g[v][i];
		if (to != par) 
			search(to, num + 1, v);
	}
} 

int main() {
	cin >> n >> m;
	g.resize(n, vector <int> (0));
	e.resize(n);
	
	vector <int> nei;
	vector <bool> is(n + 1, false);
	
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
		
		if (u == 0) is[v] = true;
		if (v == 0) is[u] = true;
		
		e[u].insert(v);
		e[v].insert(u);
	}
	long long ans = 0;
	vector <int> nn(n + 1, 0);
	for (int i = 1; i < n; i++) {
		long long kol = 0;
		for (int j = 0; j < g[i].size(); j++) {
			int to = g[i][j];
			if (to != 0 && is[to]) kol++;
		}
		nn[i] = kol;
	}
	for (int i = 1; i < n; i++) {
		if (is[i]) {
			long long kol = 0;
			for (int j = 0; j < g[i].size(); j++) {
				int to = g[i][j];
				if (to != 0 && is[to]) kol += nn[to] - 1;
			}
			ans += kol;
			continue;
		} 
		ans += nn[i] * (nn[i] - 1);
	} 
	cout << ans << endl;
	
	
	
	
	
	return 0;
}
