#include <bits/stdc++.h>

#define int long long
using namespace std;
int n, m;
const int maxn = 4e5;
vector<int> g[maxn];
set<pair<int, int>> ans;
set<pair<int, int>> edges;
vector<int> vs;
bool used[maxn];

void dfs(int v) {
    used[v] = true;
    for (int to : g[v]) {
        if (!used[to]) {
            ans.insert({v, to});
            edges.insert({min(v, to), max(v, to)});
            dfs(to);
        } else if (!edges.count({min(v, to), max(v, to)})) {
            ans.insert({v, vs.size()});
            edges.insert({min(v, to), max(v, to)});
            vs.push_back(to);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int from;
        int to;;
        cin >> from >> to;
        from--;
        to--;
        g[from].push_back(to);
        g[to].push_back(from);
    }
    for (int i = 0; i < n; i++)
        vs.push_back(i);
    dfs(0);
    cout << (vs.size()) << '\n';
    for (int v : vs) {
        cout << (v + 1) << " ";
    }
    cout << "\n";
    for (auto a : ans) {
        cout << (a.first + 1) << " " << (a.second + 1) << '\n';
    }
}
