#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <string>
#include <limits.h>
#include <iterator>
#include <queue>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int cnt = 0;

bool find(vector <vector<int>> &g, int x) {
	for (int i = 0; i < g[1].size(); i++) {
		if (g[1][i] == x)
			return true;
	}
	return false;
}

void dfs(vector <vector<int>> &g, vector <bool> &used,int v, int count) {
	used[v] = false;
	if (count == 3) {
		if (find(g, v)) {
			cnt++;
			//cout << v << " ";
		}
		return;
	}
	for (auto now : g[v]) {
		if (!used[now])
			continue;
		dfs(g, used, now, count + 1);
		used[now] = true;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector <vector<int>> g(n + 1);
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	int count = 0;
	vector <bool> used(n + 1, true);
	dfs(g, used, 1, count);
	cout << cnt;
	return 0;
}