#include <bits/stdc++.h>
using namespace std;
typedef long long s64;


double u, v;

double getTime(double a1, double a2, double t){
    a1 = a1 - t * (u + v);
    a2 = a2 - t * v;
    return max(a1 / v, a2 / (v + u)) + t;
}

int main() {
    //ifstream cin("input.txt");
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n;
    cin >> n;

    cin >> u >> v;

    vector<double> A(n);
    for(int i = 0; i < n; i++){
        cin >> A[i];
    }

    sort(A.begin(), A.end());

    double time = 0;
    for(int i = 0; i < n - 1; i++){
        A[i] -= time * v;
        A[i + 1] -= time * v;


        double l = 0, r = 100;
        while(l < r - 1e-9){
            double t1 = (2 * l + r) / 3;
            double t2 = (l + 2 * r) / 3;
            if(getTime(A[i], A[i + 1], t1) >= getTime(A[i], A[i + 1], t2)){
                l = t1;
            }
            else{
                r = t2;
            }
        }
        time += getTime(A[i], A[i + 1], l);
    }

    if(n % 2 == 1){
        A.back() -= time * v;
        time += A.back() / (u + v);
    }

    cout << fixed << setprecision(6);
    cout << time << "\n";

    return 0;
}
