#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
//#pragma optimize("", off)
/*
#pragma GCC target("avx2")
#pragma GCC optimization("unroll-loops")
#pragma GCC optimize("O2")
#pragma GCC optimize("O3")
*/
#define FOR(i,a) for (int i=0;i<(a);++i)
#define FORD(i,a) for (int i=(a)-1;i>=0;i--)
#define FORT(i,a,b) for (int i=(a);i<=(b);++i)
#define FORTD(i,b,a) for (int i=(b);i>=(a);--i)
#define trav(i,v) for (auto i : v)
#define all(v) v.begin(),v.end()
#define ad push_back
#define fr first
#define sc second
#define mpr(a,b) make_pair(a,b)
#define pir pair<int,int>
#define make_unique(v) v.erase(unique(all(v)),v.end())
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); //cout.tie(0);
#define srng mt19937 rng(chrono::steady_clock::now().time_since_epoch().count())
#define y1 EsiHancagorcRepa
const int N=2e6+4;
const ll MOD=998244353;
const ll MX=(ll)1e18;


int n,q;

struct node{
    int col,sk,sz,dl;
    node(){
        col=0;
        sk=0;
        dl=0;
    }
} sgx[N],sgy[N];

void build(int v,int tl,int tr,node sg[]){
    sg[v].col=-1;
    if (tl==tr){
        sg[v].col=tl+1;
        return;
    }
    int tm=(tl+tr)/2;
    build(v+v,tl,tm,sg);
    build(v+v+1,tm+1,tr,sg);
}

void push(int v,node sg[]){
    if (sg[v].col!=-1){
        sg[v+v+1].col=sg[v+v].col=sg[v].col;
        sg[v+v].sk=sg[v+v].dl=sg[v+v+1].sk=sg[v+v+1].dl=0;
    }
    sg[v+v].sk+=sg[v].sk;
    sg[v+v].dl+=sg[v].dl;
    sg[v+v+1].dl+=sg[v].dl;
    int bzm=sg[v].sz-(sg[v].sz/2);
    sg[v+v+1].sk+=sg[v].sk+bzm*sg[v].dl;
    sg[v].sk=0;
    sg[v].dl=0;
    sg[v].col=-1;
}


void update1(int v,int tl,int tr,int l,int r,int pox,node sg[]){

    sg[v].sz=(tr-tl+1);
    if (l>r)return;

    //cout<<tl<<" f "<<tr<<endl;
    if (tl==l && tr==r){
        sg[v].col=pox;
        sg[v].sk=sg[v].dl=0;
        return;
    }
    push(v,sg);
    int tm=(tl+tr)/2;
    update1(v+v,tl,tm,l,min(tm,r),pox,sg);
    update1(v+v+1,tm+1,tr,max(l,tm+1),r,pox,sg);
}

int update2(int v,int tl,int tr,int l,int r,int sk,node sg[]){

    sg[v].sz=(tr-tl+1);


    if (l>r)return sk;
    //cout<<tl<<" "<<tr<<endl;
    if (tl==l && tr==r){
        sg[v].sk+=sk;
        sg[v].dl++;
        return sk+(tr-tl+1);
    }
    push(v,sg);
    int tm=(tl+tr)/2;
    sk=update2(v+v,tl,tm,l,min(tm,r),sk,sg);
    return update2(v+v+1,tm+1,tr,max(l,tm+1),r,sk,sg);
}

int query(int v,int tl,int tr,int ind,node sg[]){

    sg[v].sz=(tr-tl+1);
    if (tl==tr){
       // cout<<sg[v].col<<" "<<sg[v].sk<<endl;
        return sg[v].col+sg[v].sk;
    }
    push(v,sg);
    int tm=(tl+tr)/2;
    if (ind<=tm)return query(v+v,tl,tm,ind,sg);
    return query(v+v+1,tm+1,tr,ind,sg);
}

pir get(int ind,bool tp=false){
    pir ans;
    ans.fr=query(1,0,n-1,ind,sgx);

    ans.sc=query(1,0,n-1,ind,sgy);
    if (tp)cout<<ans.fr<<" "<<ans.sc<<endl;
    return ans;
}


int main(){
    fastio;
    cin>>n>>q;
    build(1,0,n-1,sgx);
    //get(5,true);
    FOR(i,q){
        int tp;
        cin>>tp;
        if (tp==1){
            int l,r;
            cin>>l>>r;
            l--;
            r--;
            pir a=get(l),b=get(r);
            if (a.fr==b.fr){
                update1(1,0,n-1,l,r,a.sc,sgy);
                update2(1,0,n-1,l,r,0,sgx);
            }
            else{
                update1(1,0,n-1,l,r,a.fr,sgx);
                update2(1,0,n-1,l,r,0,sgy);
            }

        }
        else{
            int ind;
            cin>>ind;
            ind--;
            get(ind,true);
        }
        //cout<<"heu ";
    //get(5,true);
    }
    return 0;
}

