#include <iostream>
#include <algorithm>
#include <string>
#include <map>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
using namespace std;

#define _CRT_SECURE_NO_WARNINGS
#define fastio ios_base::sync_with_stdio(false); cin.tie(0);
#define ll long long
#define add push_back
#define fr first
#define sc second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define plb pair<long long, bool>
#define filein(a) freopen(a, "r", stdin);
#define fileout(a) freopen(a, "w", stdout);

const int N = 100005;

vector<int> g[N];
pii color[N];
vector<int> ver;

void bfs(int u){
	queue<int> q;
	color[u]=pii(1, 0);
	q.push(u);
	while(!q.empty()){
		u=q.front();
		q.pop();
		for(int i=0; i<g[u].size(); i++){
			int h=g[u][i];
			if(color[u].fr == 2){
				color[h].sc++;
			}
			if(!color[h].fr){
				color[h].fr = color[u].fr + 1;
				if(color[h].fr == 2 || color[h].fr == 3){
					ver.add(h);
				}
				q.push(h);
			}
		}
	}
}

int main(){
	fastio

	int n, m;
	ll ans = 0;
	cin >> n >> m;
	for(int i = 0; i < m; i++){
		int v, w;
		cin >> v >> w;
		g[v].add(w);
		g[w].add(v);
	}
	bfs(1);
	for(int i : ver){
		ans += color[i].sc * (color[i].sc - 1);
	}
	cout << ans;
	return 0;
}