﻿#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <stack>
#include <unordered_set>
using namespace std;

const int N = 100002;

int n, m;
vector<int> g[N];
long long ans = 0;
long long dp[4][N];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dp[0][1] = 1;
    for (int i = 1; i <= 3; i++) {
        for (int v = 1; v <= n; v++) {
            for (int to = 0; to < g[v].size(); to++) {
                if (i > 1) {
                    dp[i][v] += max((long long)0, dp[i - 1][g[v][to]] - dp[i - 2][v]);
                }
                else {
                    dp[i][v] += dp[i - 1][g[v][to]];
                }
            }
        }
    }
    for (int to = 0; to < g[1].size(); to++) {
        ans += dp[3][g[1][to]];
    }
    cout << ans << endl;
}

int main(){
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}