#define AIDAR ASSADULLIN

//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;
#define int ll
#define pii pair<int, int>
#define vi vector<int>
#define f first
#define s second
#define fst first
#define snd second
#define pb push_back
mt19937_64 rnd(time(0));

//#define LOCAL

const int maxn = 2e5 + 50;

int t[maxn * 4];
int a[maxn * 4];

void push(int v, int tl, int tr) {
	if (tr - tl >= 1) {
		t[v] += a[v] * (tr - tl);
		if (tr - tl > 1) {
			a[v * 2] += a[v];
			a[v * 2 + 1] += a[v];
		}
		a[v] = 0;
	}
}


int get(int l, int r, int v = 1, int tl = 0, int tr = maxn) {
	push(v, tl, tr);
	if (l <= tl && tr <= r) return t[v];
	if (tr <= l || tl >= r) return 0;
	int m = (tl + tr) / 2;
	return get(l, r, v * 2, tl, m) + get(l, r, v * 2 + 1, m, tr);
}

int get_x(int i) {
	return get(0, i) + 1;
}

pair<int, int> get_coord(int i) {
	int x = get_x(i);
	return {x, (i + 1) - get_x(i) + 1};
}


void update(int l, int r, int c, int v = 1, int tl = 0, int tr = maxn) {
	push(v, tl, tr);
	if (l <= tl && tr <= r) {
		a[v] += c;
		push(v, tl, tr);
		return;
	}
	if (tr <= l || tl >= r) return;
	int m = (tl + tr) / 2;
	update(l, r, c, v * 2, tl, m);
	update(l, r, c, v * 2 + 1, m, tr);
	t[v] = t[v * 2] + t[v * 2 + 1];
}

void update_one(int i, int c, int v = 1, int tl = 0, int tr = maxn) {
	push(v, tl, tr);
	if (tr - tl == 1) {
		t[v] += c;
		return;
	}
	int m = (tl + tr) / 2;
	if (i < m)
		update_one(i, c, v * 2, tl, m);
	else
		update_one(i, c, v * 2 + 1, m, tr);
	t[v] = t[v * 2] + t[v * 2 + 1];
}

void add_seq(int l, int r, int c) {
	update(l, r, c);
	int len = r - l ;
	int added = len * -c;
	update_one(r, added);
}



void build(int v = 1, int tl = 0, int tr = maxn) {
	if (tr - tl == 1) {
		t[v] = 1;
		return;
	}
	int m = (tl + tr) / 2;
	build(v * 2, tl, m);
	build(v * 2 + 1, m, tr);
	t[v] = t[v * 2] + t[v * 2 + 1];
}


void solve() {
	int n, q;
	cin >> n >> q;
	build();
	for (int i = 0; i < q; ++i) {
		int ty;
		cin >> ty;
		if (ty == 1) {
			int l, r;
			cin >> l >> r;
			--l, --r;
			if (l != r) {
				if (get_x(l) == get_x(r)) {
					add_seq(l, r, 1);
				} else {
					add_seq(l, r, -1);
				}
			}
		} else {
			int i;
			cin >> i;
			--i;
			auto ans = get_coord(i);
			cout << ans.first << " " << ans.second - 1 << "\n";
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.precision(16);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}
