#include <bits/stdc++.h>
#define int long long
using namespace std;
 
int S(int x) {
  int l = 0, r = 1e9;
  while (r - l > 1) {
    int mid = (l + r) >> 1;
    if (mid * mid >= x) {
      r = mid;
    } else {
      l = mid;
    }
  }
  return r;
}

bool ok(int x, int y, int n) {
  return (x * y == n || x * y - ((y + 1) / 2) == n || x * y - (y / 2) == n);
}

signed main() {
  int n;
  cin >> n;
  int ans = INT64_MAX;
  for (int i = 1; i * i <= n; i++) {
    if (n % i == 0) {
      int x = i;
      int y = n / i;
      ans = min(ans, abs(x - y));
    }
  }
  for (int x = 1; x <= sqrt(n); x++) {
    int l = 1, r = 1e18 / x;
    while (r - l > 1) {
      int mid = (l + r) >> 1;
      if (x * mid - (mid / 2) >= n) {
        r = mid;
      } else {
        l = mid;
      }
    }
    if (x * r - (r / 2) == n) {
      ans = min(ans, abs(x - r));
    }
    l = 1, r = 1e18 / x;
    while (r - l > 1) {
      int mid = (l + r) >> 1;
      if (x * mid - ((mid + 1) / 2) >= n) {
        r  = mid;
      } else {
        l = mid;
      }
    }
    if (x * r - ((r + 1) / 2) == n) {
      ans = min(ans, abs(x - r));
    }
  }
  for (int y = 1; y <= sqrt(n); y++) {
    int l = 1, r = 1e18 / y;
    while (r - l > 1) {
      int mid = (l + r) >> 1;
      if (mid * y - (y / 2) >= n) {
        r = mid;
      } else {
        l = mid;
      }
    }
    if (r * y - (y / 2) == n) {
      ans = min(ans, abs(r - y));
    }
    l = 1, r = 1e18 / y;
    while (r - l > 1) {
      int mid = (l + r) >> 1;
      if (mid * y - ((y + 1) / 2) >= n) {
        r = mid;
      } else {
        l = mid;
      }
    }
    if (r * y - (y / 2) == n) {
      ans = min(ans, abs(r - y));
    }
  }
  int root = S(n);
  for (int x = max(1ll, root - 5ll); x <= root + 5; x++) {
    for (int y = max(1ll, root - 5ll); y <= root + 5; y++) {
      if (ok(x, y, n)) {
        ans = min(ans, abs(x - y));
      }
    }
  }
  cout << ans;
}
