#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
    cout.precision(1000);
    int n;
    double v, u;
    double sum = 0;
    cin >> n >> v >> u;

    vector<double> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        sum += arr[i];
    }

    double l = 0, r = sum;
    while (r - l > 1e-9){
        double mid = (l + r) / 2.0;
        double p = 0;
        for (int i = 0; i < n; ++i)
            p += max(.0, arr[i] - (v * mid) / u);
        if (p > mid)
            l = mid;
        else
            r = mid;
    }
    cout << r;
}

