#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> g;
vector<bool> used;

int dfs(int u, int cnt){
    if (cnt == 0){
        for (int i : g[u])
            if (i == 1)
                return 1;
        return 0;
    }

    int ans = 0;
    used[u] = true;
    for (int v : g[u])
        if (!used[v])
            ans += dfs(v, cnt - 1);
    used[u] = false;
    return ans;
}

int main() {
    int n, m;
    cin >> n >> m;
    g.resize(n + 1);
    used.resize(n + 1);

    for (int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    cout << dfs(1, 3);
}

