#include <iostream>
#include <vector>
#include <algorithm>

#define int long long


using namespace std;

int n, m;

const int INF = -1e9;


signed main() {
    vector<int> arr(1e8);

    cin >> n >> m;
    vector<pair<int, int>> g;

    for (int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        g.push_back({u, v});
    }

    vector<vector<int>> dp(4, vector<int>(n + 1));
    dp[0][1] = 1;

    for (int s = 1; s <= 3; ++s)
        for (auto p : g){
            dp[s][p.first] += max(0LL, dp[s - 1][p.second] - dp[max(0LL, s - 2)][p.first]);
            dp[s][p.second] += max(0LL, dp[s - 1][p.first] - dp[max(0LL, s - 2)][p.second]);

        }




    int ans = 0;
    for (auto i : g){
        if (i.first == 1)
            ans += max(0LL, dp[3][i.second]);
        if (i.second == 1)
            ans += max(0LL, dp[3][i.first]);
    }
    cout << ans;
}

