#include <iostream>
#include <functional>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <set>
#define fi first
#define se second
#define mp make_pair
#define sz(a) (int) a.size()
#define len(s) (int) s.length()
#define vi vector<int>
#define pi pair<int, int>
#define fori(a, b) for (int i = a; i < b; ++i)
#define forj(a, b) for (int j = a; j < b; ++j)
#define fork(a, b) for (int k = a; k < b; ++k)
typedef long long ll;
using namespace std;
#define MULTITASK ELT


vector<vi> graph;


void solve() {
  int n, m; cin >> n >> m;
  graph.assign(n, vi());
  for (int i = 0; i < m; i++)
  {
    int a, b; cin >> a >> b; a--; b--;
    graph[a].push_back(b);
    graph[b].push_back(a);
  }

  queue<int> q;
  vector<set<int>> ls(2, set<int>());
  vector<bool> visited(n, false);
  visited[0] = true;
  vi l(n, 0);
  q.push(0);
  while (!q.empty()) {
    int v = q.front();
    if (l[v] == 2) break;
    q.pop();
    for (int u : graph[v])
    {
      if (!visited[u]) {
        q.push(u);
        l[u] = l[v] + 1;
        ls[l[v]].insert(u);
        visited[u] = true;
      }
    }
  }
  ll res = 0;
  for (auto& v : ls[1])
  {
    int in = 0;
    for (auto& e : graph[v]) {
      if (ls[0].find(e) != ls[0].end()) {
        in++;
      }
    }
    res += (ll)in * (in - 1);
  }

  for (auto& v: ls[0]) {
    int in = 0;
    for (auto& e: graph[v]) {
      if (ls[0].find(e) != ls[0].end()) {
        in++;
      }
    }
    res += (ll)in * (in - 1);
  }

  cout << res << "\n";
}


int main() {
#if ELT
  freopen("input.txt", "r", stdin);
#endif
#if MULTITASK
  int q; cin >> q; while (q--) { solve(); }
#else
  solve();
#endif

  return 0;
}
