#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2 * 1e5;

vector<int> g[MAXN];
vector<int> cnt(MAXN);

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int n, m;
    cin >> n >> m;
    while (m--){
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<int> dist(n);
    vector<bool> used(n);

    queue<int> q;

    q.push(0);
    dist[0] = 0;
    used[0] = true;

    while (!q.empty()){
        int v = q.front();
        q.pop();
        for(int to : g[v]){
            if(!used[to]){
                used[to] = true;
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }

    for(int i = 0; i < n; i++){
        if(dist[i] == 1){
            for(int to : g[i]){
                if(to != 0) cnt[to]++;
            }
        }
    }

    int ans = 0;
    for(int i = 0; i < n; i++){
        ans += (cnt[i] * (cnt[i] - 1));
    }
    cout << ans;

    return 0;
}

