//follow God
 
//#pragma optimization_level 3
 
//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
 
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <chrono>
#include <ctime>
#include <queue>
#include <math.h>
#include <deque>
#include <stack>
#include <iomanip>
#include <assert.h>
#include <stdio.h>
#include <cstring>
#include <random>
 
using namespace std;
 
#define int long long
#define ll long long
#define ull unsigned long long
#define ld long double
#define pii pair<int, int>
#define pld pair<ld, ld>
#define ti tuple<int, int, int>
#define vi vector <int>
#define vpi vector <pii>
#define vld vector <ld>
#define try tr
#define left left11
#define right right11
#define lb lower_bound
#define ub upper_bound
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define pb push_back
#define pf push_front
#define sqr(a) ((a) * (a))
#define dbg(x) cout << #x << " : " << x << endl;
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
 
#define x first
#define y second
 
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
 
clock_t START;
 
inline ld TIME() {
    return (ld) (clock() - START) / CLOCKS_PER_SEC;
}
 
void SHOW() {
    cout << fixed << setprecision(10);
    cout << TIME() << " SECONDS FROM START\n";
}
 
ld TL = 2.0;
int calls = 0;
 
inline bool IS() {
    if (TL - TIME() < 0.1)
        return true;
    return false;
}
 
template<typename T1, typename T2>
inline bool amin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
 
template<typename T1, typename T2>
inline bool amax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
 
template<typename T1, typename T2>
ostream &operator<<(ostream &os, pair<T1, T2> &p) {
    os << p.first << ' ' << p.second;
    return os;
}
 
template<typename T1, typename T2>
istream &operator>>(istream &is, pair<T1, T2> &p) {
    is >> p.first >> p.second;
    return is;
}
 
template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &u : v) is >> u;
    return is;
}
 
template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &u : v) os << u << ' ';
    return os;
}
 
int hash_mod[4] = {1000000007, 998244353, 1000000009, 999999937}, mod = hash_mod[rnd() % 4];
int hash_pows[4] = {179, 239, 1007, 2003}, P = hash_pows[rnd() % 4];
 
int binpow(int x, int p) {
    int res = 1;
    while (p) {
        if (p % 2)
            res = (res * x) % mod;
        x = (x * x) % mod;
        p /= 2;
    }
    return res;
}
 
const int N = 1e6 + 7, NS = 2e3 + 7, lg = 20, sq = 550, inf = 2e9 + 7;
const ld eps = 1e-7, pi = 3.14159265359;

struct st{
    vi t, s, d, add;
    // s- начало
    // d - шаг
    int sz;
    void build(int v, int l, int r, vi &a) {
        if(l == r - 1) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
    void init(vi &a) {
        add = t = s = d = vi(4 * a.size(), -inf);
        sz = a.size();
        build(1, 0, sz, a);
    }
    void push(int v, int l, int r) {
        if(add[v] != -inf) {
            t[v] = add[v] * (r - l);
            if(l != r - 1) {
                add[2 * v] = add[2 * v + 1] = add[v];
                s[2 * v] = s[2 * v + 1] = -inf;
                d[2 * v] = d[2 * v + 1] = -inf;
            }
            add[v] = -inf;
            s[v] = d[v] = -inf;
        }
        if(s[v] != -inf || d[v] != -inf) {
            int len = r - l;
            t[v] = len * (s[v] + s[v] + (len - 1) * d[v]) / 2;
            if(l != r - 1) {
                s[2 * v] = s[v];
                d[2 * v] = d[v];
                int m = (l + r) / 2;
                s[2 * v + 1] = s[v] + d[v] * (m - l);
                d[2 * v + 1] = d[v];
                add[2 * v] = -inf;
                add[2 * v + 1] = -inf;
            }
            s[v] = d[v] = add[v] = -inf; 
        }
    }
    void updateadd(int v, int l, int r, int vl, int vr, int val) {
        push(v, l, r);
        if(l >= vr || vl >= r)
            return;
        if(l >= vl && r <= vr) {
            add[v] = val;
            s[v] = d[v] = -inf;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        updateadd(2 * v, l, m, vl, vr, val);
        updateadd(2 * v + 1, m, r, vl, vr, val);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
    void updateadd(int l, int r, int val) {
        updateadd(1, 0, sz, l, r + 1, val);
    }
    void update(int v, int l, int r, int vl, int vr, int S, int D) {
        push(v, l, r);
        if(l >= vr || vl >= r)
            return;
        if(l >= vl && r <= vr) {
            //cout << l + 1 << ' ' << r << endl;
           // cout << S << ' ' << D << endl << endl;
            s[v] = S + (l - vl) * D;
            d[v] = D;
            add[v] = -inf;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v, l, m, vl, vr, S, D);
        int cnt = max(m - vl, 0ll);
        update(2 * v + 1, m, r, vl, vr, S, D);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
    void update(int l, int r, int S, int D) {
        update(1, 0, sz, l, r + 1, S, D);
    }
    int get(int v, int l, int r, int pos) {
        push(v, l, r);
        if(l == r - 1)
            return t[v];
        int m = (l + r) / 2;
        if(pos >= m)
            return get(2 * v + 1, m, r, pos);
        else
            return get(2 * v, l, m, pos);
    }
    int get(int pos) {
        return get(1, 0, sz, pos);
    }
} X, Y;

pii get(int i) {
    int x = X.get(i), y = Y.get(i);
    return {x, y};
}

void solve() {
    int n, q;
    cin >> n >> q;
    vi x(n), y(n);
    for (int i = 0; i < n; i++) {
        y[i] = 0;
        x[i] = i + 1;
    }
    X.init(x);
    Y.init(y);
    for (int it = 0; it < q; it++) {
        int t;
        cin >> t;
        if(t == 1) {
            int l, r;
            cin >> l >> r;
            l--, r--;
            if(l == r)
                continue;
            pii p1 = get(l), p2 = get(r);
            if(p1.x == p2.x) {
                Y.updateadd(l, r, p1.y);
                X.update(l, r, p1.x, 1);
            }
            else {
                X.updateadd(l, r, p1.x);
                Y.update(l, r, p1.y, 1);
            }
        }
        else {
            int i;
            cin >> i;
            i--;
            pii p = get(i);
            cout << p.x << ' ' << p.y << endl;
        }
    }
}   
 
signed main() {
    fast
    solve();
}