//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

/*
#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/

#define x first
#define y second
//#define int long long
#define ll long long
#define ld long double
#define pb push_back

struct ST {
    vector<pair<int, int>> col;

    void push(int v) {
        if (col[v].x != -1) {
            col[2 * v] = col[v];
            col[2 * v + 1] = col[v];
            col[v] = {-1, -1};
        }
    }

    void upd(int v, int tl, int tr, int l, int r, pair<int, int> c) {
        if (tl >= r || tr <= l) return;
        if (tl >= l && tr <= r) col[v] = c; else {
            push(v);
            int tm = (tl + tr) / 2;
            upd(2 * v, tl, tm, l, r, c);
            upd(2 * v + 1, tm, tr, l, r, c);
        }
    }

    pair<int, int> get(int v, int tl, int tr, int ind) {
        if (col[v].x != -1 || tr - tl == 1) return col[v];
        int tm = (tl + tr) / 2;
        return ind < tm ? get(2 * v, tl, tm, ind) : get(2 * v + 1, tm, tr, ind);
    }

    void build(int n) {
        col = vector<pair<int, int>>(4 * n, {-1, -2});
    }

    ST() {}
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    ST stx, sty;
    stx.build(n);
    sty.build(n);
    auto get = [&](int id)->pair<int, int> {
        auto xx = stx.get(1, 0, n, id), yy = sty.get(1, 0, n, id);
        if (xx.y > yy.y) {
            return {xx.x, id - xx.x};
        }
        return {id - yy.x, yy.x};
    };
    for (int qq = 0; qq < q; ++qq) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            --l;
            --r;
            if (l == r) continue;
            auto lget = get(l);
            auto rget = get(r);
            if (lget.x == rget.x) {
                sty.upd(1, 0, n, l, r + 1, {lget.y, qq});
            } else {
                stx.upd(1, 0, n, l, r + 1, {lget.x, qq});
            }
        }
        if (type == 2) {
            int id;
            cin >> id;
            --id;
            auto g = get(id);
            cout << g.x << " " << g.y + 1 << '\n';
        }
    }
    return 0;
}
