#include<bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(),v.end()
#define sz(v) (int)v.size()
#define up_b upper_bound
#define low_b lower_bound
#define nl '\n'

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>ordered_set;

const int N=2e5+11;
const int M=1e6+1;
const int inf=2e9+1;
const ld EPS=1e-6;
const ll INF=1e18;
const ll mod=/*998244353*/1e9+7;
const int dx[4]={-1,0,1,0};
const int dy[4]={0,1,0,-1};

int n,sq,q;

int usedx[N],ax[N],ay[N],usedy[N];
int x[N],y[N];


void upd(int b){
    if(usedx[b]==0)return ;
    int l=b*sq;
    int r=min(n,l+sq);
    for(int i=l;i<r;i++){
        if(usedx[b]==1)x[i]=ax[b];
        if(usedx[b]==2)x[i]=ax[b]+i-l;
        if(usedy[b]==1)y[i]=ay[b];
        if(usedy[b]==2)y[i]=ay[b]+i-l;
    }
    usedx[b]=0,usedy[b]=0;
}

void updG(int l,int r){
    int bl=l/sq;
    int br=r/sq;
    upd(bl);
    upd(br);
    if(bl==br){
        for(int i=l;i<=r;i++){
            x[i]=x[l];
            y[i]=y[l]+i-l;
        }
        return ;
    }
    for(int i=l;i<(bl+1)*sq;i++){
        x[i]=x[l];
        y[i]=y[l]+i-l;
    }
    for(int i=bl+1;i<br;i++){
        usedx[i]=1;
        usedy[i]=2;
        ax[i]=x[l];
        ay[i]=y[l]+i*sq-l;
    }
    for(int i=br*sq;i<=r;i++){
        x[i]=x[l];
        y[i]=y[l]+i-l;
    }
}

void updV(int l,int r){
    int bl=l/sq;
    int br=r/sq;
    upd(bl);
    upd(br);
    if(bl==br){
        for(int i=l;i<=r;i++){
            x[i]=x[l]+i-l;
            y[i]=y[l];
        }
        return ;
    }
    for(int i=l;i<(bl+1)*sq;i++){
        x[i]=x[l]+i-l;
        y[i]=y[l];
    }
    for(int i=bl+1;i<br;i++){
        usedx[i]=2;
        usedy[i]=1;
        ax[i]=x[l]+i*sq-l;
        ay[i]=y[l];
    }
    for(int i=br*sq;i<=r;i++){
        x[i]=x[l]+i-l;
        y[i]=y[l];
    }
}



void solve(){
    cin>>n>>q;
    sq=sqrt(n);
    for(int i=0;i<n;i++){
        x[i]=i+1;
        y[i]=0;
    }
    for(int i=1;i<=q;i++){
        int tp,l,r;
        cin>>tp>>l;
        l--;
        if(tp==1){
            cin>>r;
            r--;
            if(l==r)continue;
            upd(l/sq);
            upd(r/sq);
            if(x[l]==x[r]){
                updV(l,r);
            }
            else{
                updG(l,r);
            }
        }
        else{
            upd(l/sq);
            cout<<x[l]<<" "<<y[l]<<nl;
        }
    }
}

int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0),cout.tie(0);
  int T=1;
  //cin>>T;
  while(T--){
    solve();
    cout<<nl;
  }
}
