#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, INF = 1e18;

int n, m, p[N];
vector < int > ans;
vector < pair < int, int > > e;
pair < int, int > a[N];

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

bool union_set(int f, int s) {
    f = get(f);
    s = get(s);
    if (f == s) return false;
    p[f] = s;
    return true;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--, a[i].second--;
    }
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }
    ans.resize(n);
    iota(ans.begin(), ans.end(), 0);
    for (int i = 0; i < m; i++) {
        if (union_set(a[i].first, a[i].second)) {
            e.push_back({a[i].first, a[i].second});
        } else {
            e.push_back({a[i].first, ans.size()});
            ans.push_back(a[i].second);
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] + 1 << " ";
    }
    cout << '\n';
    for (int i = 0; i < e.size(); i++) {
        cout << e[i].first + 1 << " " << e[i].second + 1 << '\n';
    }
}
