#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define all(_x) (_x).begin(), (_x).end()
#define F first
#define S second
#define pb push_back

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
using ll = long long;

const int maxin = 2e5 + 10;
const int inf = INT_MAX / 2;
const ll llinf = LLONG_MAX / 2;
const double eps = 1e-9;
const int MOD = 1e9 + 7;
const int dx[] = {0, 0, -1, 1, -1, 1, -1, 1, 0};
const int dy[] = {1, -1, 0, 0, 1, -1, -1, 1, 0};

template<typename T> using indexed_set = tree<T, null_type,
  less<T>, rb_tree_tag, tree_order_statistics_node_update>;

ll ans = 0;
vector<int> g[maxin];
vector<int> anc(maxin);
vector<pair<int, int>> ver;
vector<int> u(maxin);

void dfs(int v, int p = 0, int d = 0){
  if (d == 2)
    ver.pb({v, p});
  for (auto to : g[v]){
    if (to != p && d < 2){
      dfs(to, v, d + 1);
    }
  }
}

void dfs2(int v, int cur_p, int d = 0){
  if (d == 2 && v == 1)
    ans++;
  for (auto to : g[v]){
    if (d < 2){
      if (to != cur_p){
        dfs2(to, v, d + 1);
      }
    }
  }
}

int main (){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  if (fopen("shalom_vsem.in", "r")){
    freopen("shalom_vsem.in", "r", stdin);
    freopen("shalom_vsem.out", "w", stdout);
  }
  int n, m;
  cin >> n >> m;
  for (int i = 1, a, b;i <= m;++i){
    cin >> a >> b;
    g[a].pb(b);
    g[b].pb(a);
  }
  dfs(1);
  for (auto it : ver){
    dfs2(it.F, it.S);
  }
  cout << ans << "\n";
}
