#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;
#define deb(a) cerr << #a << " = " << a << '\n'
#define pb push_back
#define mp make_pair

const int INF = 2e9;
const ld EPS = 1e-7;
const int MAXN = 1e5 + 5;

ll n, m, cnt;
bool used[MAXN];
vector<ll> g[MAXN];
map<ll, bool> sd;

void dfs(int v, int depth) {
    //if (depth > 3) {
        //return;
   // }
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++) {
        if (!used[g[v][i]] && depth < 3)
            dfs(g[v][i], depth + 1);
    }
    if (depth == 3 && sd[v]) {
        cnt++;
    }
    used[v] = 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].pb(v);
        g[v].pb(u);
    }

    for (int i = 0; i < g[0].size(); i++) {
        sd[g[0][i]] = 1;
    }

    dfs(0, 0);

    cout << cnt << '\n';

    return 0;
}
