#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const double EPS = 1e-9;
const int MAXN = 5e5;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    ll n;
    cin >> n;
    ll res = INT32_MAX;
    // Однаковое количество в каждом ряду
    for (ll i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            res = min(res, abs(i - n / i));
        }
    }
    // i - кол-во рядов
    ll mx1, mx2, mx3;
    mx1 = mx2 = mx3 = INF;
    for (ll i = 1; i <= max(n, (ll) 5e7); ++i) {
        if (i % 2 == 0) {
            if (n / (i / 2) % 2 == 1) {
                res = min(res, abs(i - (n / (i / 2) / 2 + 1)));
                if (mx1 != INF && abs(i - (n / (i / 2) / 2 + 1)) > mx1) break;
                mx1 = abs(i - (n / (i / 2) / 2 + 1));
            }
        } else {
            if ((n - (i - 1) / 2) % i == 0) {
                res = min(res, ((n - (i - 1)) / 2) / i + 1);
                if (mx2 != INF && (((n - (i - 1)) / 2) / i + 1) > mx2) break;
                mx2 = ((n - (i - 1)) / 2) / i + 1;
            }
            if ((n - (i + 1) / 2) % i == 0) {
                res = min(res, abs(i - ((n - (i + 1) / 2) / i + 1)));
                if (mx3 != INF && abs(i - ((n - (i + 1) / 2) / i + 1)) > mx3) break;
                mx3 = abs(i - ((n - (i + 1) / 2) / i + 1));
            }
        }
    }
    cout << res;
}

int main() {
    fast_in_out();
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
//    freopen("err.txt", "w", stderr);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
    return 0;
}
