#include <bits/stdc++.h>

using namespace std;

vector<pair<long long, long long> > edges;
vector<long long> colors;
vector<vector<long long> > g;
vector<int> used;

void dfs(long long v, long long pr) {
    used[v] = 1;
    for (long long i = 0; i < g[v].size(); ++i) {
        if (g[v][i] == pr) {
            continue;
        }
        if (used[g[v][i]] == 1) {
            colors.push_back(colors[g[v][i]]);
            edges.push_back({v, colors.size() - 1});
        }
        else if (used[g[v][i]] == 0){
            edges.push_back({v, g[v][i]});
            dfs(g[v][i], v);
        }
    }
    used[v] = 2;
}

int main()
{
    long long n, m;
    cin >> n;
    cin >> m;
    used.resize(n, 0);
    for (long long i = 1; i <= n; ++i) {
        colors.push_back(i);
    }
    g.resize(n);
    for (long long i = 0; i < m; ++i) {
        long long a, b;
        cin >> a;
        cin >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, -1);
    cout << colors.size() << '\n';
    for (auto i: colors) {
        cout << i << ' ';
    }
    cout << '\n';
    for (auto i: edges) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
    return 0;
}
