#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#define ll long long
#define ld long double

using namespace std;

const int N = 200200;
vector < ll > g[N];
int ans;
bool check[N];

void dfs(ll, ll, int);
int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;
    for(ll i = 0; i < m; i++){
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
        if(a == 0)
            check[b] = 1;
        else if(b == 0)
            check[a] = 1;
    }

    dfs(0, 0, -1);

    cout << ans << '\n';
    return 0;
}

void dfs(ll v, ll len, int pr)
{
    if(len == 3){
        if(check[v]){
            ans++;
        }
        return;
    }

    for(int i = 0; i < g[v].size(); i++){
        if(g[v][i] != pr)
            dfs(g[v][i], len + 1, v);
    }
}
