/*
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")
ordered_set -> less -> less_equal
ordered_set find_by_order(k) -> k element
ordered_set order_of_key(k) -> returns the number of elements in a set strictly smaller than k
*/
#include <bits/stdc++.h>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>
 
using namespace std;
// using namespace __gnu_pbds;
 
//template<typename T> using ordered_set=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
 
const long long maxn = 3e5 + 123;
const long long inf = 1e9 + 123;
const long long linf = 1e18 + 123;
const long long mod = 1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1);
int dx[8] = {0, 1, -1, 0, 1, -1, 1, -1};
int dy[8] = {1, 0, 0, -1, 1, 1, -1, -1};
 
int n, m;
 
vector<int> g[maxn];
 
int ans, X[maxn];

void dfs(int v, int p, int z){
    if (z > 3){
        return;
    }
    if (z == 3){
        ans += X[v];
        return;
    }
    for (int i = 0; i < g[v].size(); i++){
        int to = g[v][i];
        if (to == p){
            continue;
        }
        dfs(to, v, z + 1);
    }
}

int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++){
        int x, y;
        cin >> x >> y;
        if (x == 1){
            X[y] = 1;
        }
        if (y == 1){
            X[x] = 1;
        }
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(1, 0, 0);
    cout << ans;
    exit(0);
}
