#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
vector<ll> vec;
set<ll> st;

void func(ll n, ll w, vector<ll> used, ll s){
    w += vec[n];
    st.insert(w);
    used[n] = 1;

    for(ll i = 0; i < s; i++){
        if(!used[i])
            func(i, w, used, s);
    }
    return;
}

#define FAST ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MULTITEST ll t; cin >> t; while (t--)
#define all(a) a.begin(), a.end()
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define filer(s) freopen(s, "r", stdin)
#define filew(s) freopen(s, "w", stdout)


void solve() {
    ll n;
    cin >> n;
    vector<ll> used(1e3 + 1, 0);
    vec.resize(n);

    for(ll i = 0; i < n; i++){
        cin >> vec[i];
    }

    for(ll i = 0; i < n; i++){
        func(i, 0, used, n);
    }

    ll sum = 0, k = st.size() + 1;
    for(auto i : st){
        sum += i;
    }

    cout << sum + (k * (k + 1) / 2);
}

signed main() {
    solve();
}