#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

#define FAST ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MULTITEST ll t; cin >> t; while (t--)
#define all(a) a.begin(), a.end()
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define filer(s) freopen(s, "r", stdin)
#define filew(s) freopen(s, "w", stdout)
vector<vector<ll>> g;
ll cnt = 0;

void dfs(ll n, ll w, ll last, vector<ll> used){
    used[n] = 1;
    if(w == 3){
        for(auto &v : g[n]){
            if(v == 0){
                cnt++;
                return;
            }
        }
    }
    for (auto &v : g[n]) {
        if (!used[v] && w < 3) {
            dfs(v, w + 1, n, used);
        }
    }
}

void solve() {
    ll n,m;
    cin >> n >> m;
    vector<ll> used(1e5 + 1);
    g.resize(n);
    for(ll i = 0 ; i < m; i++){
        ll a,b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0, -1, used);
    cout << cnt;
}

signed main() {
    solve();
}