#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
vector<ll> vec;
set<ll> st;

/*void func(ll n, ll w, vector<ll> used, ll s){
    w += vec[n];
    st.insert(w);
    used[n] = 1;

    for(ll i = 0; i < s; i++){
        if(!used[i])
            func(i, w, used, s);
    }
    return;
}*/

#define FAST ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MULTITEST ll t; cin >> t; while (t--)
#define all(a) a.begin(), a.end()
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define filer(s) freopen(s, "r", stdin)
#define filew(s) freopen(s, "w", stdout)

/*void solve() {
    ll n, sum_2 = 0;
    cin >> n;
    vector<ll> used(1e2 + 1, 0);
    vec.resize(n);

    for(ll i = 0; i < n; i++){
        cin >> vec[i];
        sum_2 += vec[i];
    }

    for(ll i = 0; i < n; i++){
        func(i, 0, used, n);
    }

    ll sum = 0, k = st.size() + 1;
    for(auto i : st){
        sum += i;
    }

    cout << (sum_2 + 2) * (sum_2 + 1) / 2 - sum_2;
} */
void solve(){
    ll n,m;
    cin >> n >> m;
    vector<vector<ll>> a(n);
    set<ll> s;
    for(ll i = 0; i < m; i++){
        ll x,y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
        if(min(x,y) == 0)
            s.insert(max(x,y));
    }
    ll ans = 0;
    for(ll i = 0; i < a[0].size(); i++){
        ll first = a[0][i];
        for(ll j = 0; j < a[first].size(); j++){
            ll second = a[first][j];
            if(second == first) continue;
            for(ll k = 0; k < a[second].size(); k++){
                ll third = a[second][k];
                if(third == second) continue;
                for(ll u = 0; u < a[third].size(); u++){
                    ll res = a[third][u];
                    if(res == third) continue;
                    if(s.find(res) != s.end())
                        ans++;
                }
            }
        }
    }
    cout << ans;
}
signed main() {
    solve();
}