﻿// ConsoleApplication5.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
using namespace std;

struct vec {
	int x, y;
};

void rotate(vec* v, int s) {
	if (s == 1)return;

	bool hor = (v[0] .y== v[1].y);

	vec t = v[0];

	if (hor) {
		for (int i = 0; i < s; i++)
		{
			v[i].x -= t.x;
			v[i].y -= t.y;

			int tt = v[i].x;
			v[i].x = -v[i].y;
			v[i].y = tt;

			v[i].x += t.x;
			v[i].y += t.y;
		}
	}
	else {
		for (int i = 0; i < s; i++)
		{
			v[i].x -= t.x;
			v[i].y -= t.y;

			int tt = -v[i].x;
			v[i].x = v[i].y;
			v[i].y = tt;

			v[i].x += t.x;
			v[i].y += t.y;
		}
	}
}

int main()
{
	vector<vec> m;
	int n, q;
	cin >> n >> q;
	m.resize(n);

	for (int i = 0; i < n; i++)
	{
		m.at(i).y = 0;
		m.at(i).x = i;
	}

	for (int i = 0, h,t; i < q; i++)
	{
		cin >> h;

		switch (h)
		{
		case 1:
			cin >> h >> t;
			--h; --t;

			rotate(&m.at(h), t - h + 1);
			break;
		case 2:
			cin >> h;

			cout << m[--h].x + 1 << ' ' << m[h].y << endl;
			break;
		}
	}
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
