#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;

vector<vector<int>> list;

int main()
{
  int n, m, u, v;
  cin >> n >> m;

  list.resize(n + 1);
  vector<int> dist(n + 1, 0), used(n + 1), cnt(n + 1);
  for (int i = 0; i < m; ++i) {
    cin >> u >> v;
    list[u].push_back(v);
    list[v].push_back(u);
  }

  queue<int> q;
  used[1] = 1;
  q.push(1);
  while (!q.empty()) {
    int u = q.front();
    q.pop();
    if (dist[u] == 2) break;
    for (auto to : list[u]) {
      if (!used[to]) {
        dist[to] = dist[u] + 1;
        used[to] = 1;
        q.push(to);
      }              
	  if (dist[u] == 1)
		cnt[to]++;
    }
  }

  long long res = 0;
  for (int i = 1; i <= n; ++i)
	  if (cnt[i])
		  res += (long long)cnt[i] * (cnt[i] - 1);

  cout << res << '\n';
}