#include <iostream>
#include <map>
#include <set>
using namespace std;

const int N = 101;
int a[N];
int n;

map<pair<int, int>, int> mp;
set<long long> st;

void subsetSums(int n)
{
	// There are totoal 2^n subsets 
	long long total = 1 << n;

	// Consider all numbers from 0 to 2^n - 1 
	for (long long i = 0; i < total; i++)
	{
		long long sum = 0;

		// Consider binary reprsentation of 
		// current i to decide which elements 
		// to pick. 
		for (int j = 0; j < n; j++)
			if (i & (1 << j))
				sum += a[j];

		// Print sum of picked elements. 
		cout << sum << " ";
	}
}

int main()
{
	int i, j, sum, sumall = 0, res = 0;
	cin >> n;
	for (i = 0; i < n; i++) {
		cin >> a[i];
		sumall += a[i];
	}
	subsetSums(n);
	for (auto i : st) {
		for (j = 0; j <= i; j++) {
			mp[make_pair(j, sumall - i)] = 1;
			mp[make_pair(sumall - i, j)] = 1;
		}
	}
	for (auto i : mp)
		if (i.second == 1)
			res++;
	cout << res << endl;
	return 0;
}