#include <bits/stdc++.h>
using namespace std;
template <class T> ostream &operator << (ostream &out, const vector<T> &a) {
     for (auto& e : a) out << e << ' ';
     return out;
}
struct dsu{
    vector<int> comp;
    vector<int> size;
    dsu(int n) : comp(n), size(n, 1){for (int i = 0; i < n; ++i) comp[i] = i;}
    int get_comp(int x){
        return comp[x] = (comp[x] == x ? x : get_comp(comp[x]));
    }
    bool same(int x, int y){
   return get_comp(x) ==  get_comp(y);}
    void merge(int x, int y){
        x = get_comp(x)
    ;
    y = get_comp(y);
    if (x == y) return;
    if (size[x] > size[y]){
        size[x] += size[y]
    ;
    comp[y] = x;
    } else {
        size[y] += size[x]
    ;
    comp[x] = y;
    }
    }
    };
signed main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<bool> used(n, false);
    cout << m + 1 << '\n';
    vector<pair<int, int>> edges(m);
    for (auto &p : edges) cin >> p.first >> p.second;
    for (auto &p : edges) --p.first, --p.second;
    vector<int> colors(n);
    iota(colors.begin(), colors.end(), 0);
    vector<pair<int, int>> out;
    dsu dsu(n);
    int cur = n;
    for (int i = 0; i < m; ++i){
            auto p = edges[i];
        int a = p.first;
        int b = p.second;

        if (!dsu.same(a, b)){
            out.emplace_back(a, b);
            dsu.merge(a, b);
        } else {
            out.emplace_back(a, cur++);
            colors.push_back(b);
        }
    }
    for (int j = 0; j < colors.size(); ++j) cout << colors[j] + 1 << ' ';cout<<'\n';
    for (int j = 0; j < out.size(); ++j){
        cout << out[j].first + 1 << ' ' << out[j].second + 1  << '\n';
    }
}
