//#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const ll INF = 1e18;

bool good[1000001];
int pref[1000001];

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;
	vector<int> l(n);
	for (int &i : l)
		cin >> i;

	for (int i = 0; i < 1e6 + 1; ++i)
		good[i] = false;
	good[0] = true;

	ll last = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = last; j >= 0; --j)
			if (good[j]) {
				good[j + l[i]] = true;
			}
		last += l[i];
	}

	ll sum = last;

	ll ans = 0;
	pref[0] = good[0];
	for (int i = 1; i <= last; ++i)
		pref[i] = pref[i - 1] + good[i];

	for (int i = 0; i <= last; ++i)
		if (good[i]) {
			ans += (sum - i + 1) * 2 - pref[sum - i];
		}

	cout << ans;

	
	return 0;
}