//#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const ll INF = 1e18;

vector<vector<int>> g;
vector<int> color, used;
int cnt;
vector<vector<int>> g1;

void dfs (int u, int p = -1) {
	used[u] = 1;
	for (int v : g[u])
		if (v != p && used[v] == 1) {
			color.push_back(v);
			g1[u].push_back(cnt++);
		} else if (!used[v]) {
			g1[u].push_back(v);
			dfs(v, u);
		}
	used[u] = 2;

}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	cnt = n;

	g.resize(n);
	used.resize(n);
	color.resize(n);
	for (int i = 0; i < n; ++i)
		color[i] = i;
	g1.resize(n);
	cnt = n;

	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	dfs(0);

	cout << cnt << '\n';
	for (int i : color)
		cout << i + 1 << ' ';
	cout << '\n';
	for (int u = 0; u < n; ++u)
		for (int v : g1[u])
			cout << u + 1 << ' ' << v + 1 << '\n';


	
	return 0;
}