//#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const ll INF = 1e18;
const ld EPS = 1e-9;

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, u, v;
	cin >> n >> u >> v;
	vector<int> a(n);
	for (int &i : a)
		cin >> i;

	ld l = 0, r = INF;
	while ((r - l) > EPS) {
		ld mid = (r + l) / 2;
		ld buf = mid * u;
		ld sum = 0;
		for (int i = 0; i < n; ++i)
			sum += std::max((ld)0, a[i] - buf);
		if (sum < mid * v)
			r = mid;
		else
			l = mid;
	}

	cout << std::fixed << std::setprecision(30) << l * v;
	return 0;
}


