#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

#define int long long
const int N = 100000 + 7;

vector<int> g[N];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    vector<bool> neigh(n, false);
    for (auto v : g[0]) {
        neigh[v] = true;
    }

    vector<int> neigh2cnt(n, 0);
    for (int v = 1; v < n; ++v) {
        for (auto u : g[v]) {
            if (neigh[u]) {
                neigh2cnt[v]++;
            }
        }
    }

    int res = 0;

    for (int v = 1; v < n; ++v) {
        res += neigh2cnt[v] * (neigh2cnt[v] - 1);
//        cerr << v << ' ' << neigh2cnt[v] * (neigh2cnt[v] - 1) << '\n';
    }

    cout << res;

    return 0;
}