#include <bits/stdc++.h>
using namespace std;
const int N = 1e5;
const int INF = 1e7;
vector<int> g[N + 1];
vector<int> used(N + 1), level(N + 1, INF), cnt(N + 1), sol(N + 1, 0);
void bfs(int s){
    level[s] = 0;
    queue<int> q;
    q.push(s);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        if(level[v] > 2) continue;
        for(int i = 0; i < g[v].size(); ++i){
            int u = g[v][i];
            if(level[u] == INF){
                level[u] = level[v] + 1;
                q.push(u);
            }
            if(level[u] == 2 && level[v] == 1){
                ++sol[u];
            }
            if(level[u] == 1 && level[v] == 1){
                ++sol[u];
            }
        }
    }
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    bfs(0);
    long long ans = 0;
    for(int i = 1; i < n; ++i){
        ans += sol[i]*(sol[i] - 1);
    }
    cout << ans;
}
