#!/usr/bin/env python3

class Magnet:
    def __init__(self, x, y):
        self.x = x
        self.y = y
        self.isHorizontal = True
    
    def rotate(self, d):
        if self.isHorizontal:
            self.x -= d
            self.y += d
        else:
            self.x += d
            self.y -= d

        self.isHorizontal = not self.isHorizontal

n, q = map(int, input().split())

magnets = {(i+1): Magnet(i+1, 0) for i in range(n)}

def qTwo(query):
    global magnets
    m = magnets[query[1]]
    print(m.x, m.y)

def qOne(query):
    global magnets
    l, r = query[1], query[2]
    for i in range(l, r+1):
        magnets[i].rotate(i-l)

for _ in range(q):
    query = list(map(int, input().split()))
    if len(query) == 2:
        qTwo(query)
    else:
        qOne(query)