#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;
#define EPS 7e-6

template <class T = int>
T next() { T x; cin >> x; return x; }

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n = next(), sum = 0;
    vector<int> arr(n);

    for (int& v : arr)
    {
        cin >> v;
        sum += v;
    }

    vector<bool> prev(sum + 1, false), curr(sum + 1, false);
    prev[0] = true;
    prev[arr[0]] = true;

    for (int i = 1; i < n; i++)
    {
        int w = arr[i];
        for (int j = 0; j < w; j++) curr[j] = prev[j];
        for (int j = w; j <= sum; j++) curr[j] = curr[j] | prev[j - w];
        prev.swap(curr);
        fill(curr.begin(), curr.end(), false);
    }

    int count = 1;
    for (int i = 0; i <= sum; i++)
        count += prev[i];

    cout << (ll)count * (ll)(sum + 1) - ((ll)count * (ll)(count - 1)) / 2 << '\n';

    return 0;
}