#include<algorithm>
#include<iostream>
#include<iomanip>
#include<vector>
#include<string>
#include<queue>
#include<cmath>
#include<map>
#include<set>

using namespace std;

#define input(a) cin >> a;
#define print(a) cout << a << "\n";
#define forn(i, l, n) for(int i = l; i < n; i++)
#define int(s, n) int s = n;
#define pb push_back

typedef long long ll;
typedef vector<vector<int> > vv;

vv g;
set<int> neigh;
vector<int> used(100003, 0);

const ll INF = 1e9 + 7;

ll cnt = 0;

void dfs(int u, int wh){
    if(wh == 1){
        for(auto &v : g[u]){
            //cout << v <<  " ";
            if(!used[v] && neigh.count(v) > 0){
                cnt++;
                //cout << "cor";
            }
            //cout << endl;
        }
        return;
    }
    for(auto &v : g[u]){
        if(v == 1) continue;
        used[v] = 1;
        //cout << v << " ";
        dfs(v, 1);
        used[v] = 0;
    }
}

void solve(){
    int n, m; cin >> n >> m;
    g.resize(n + 1);

    forn(i, 0, m){
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
        if(u == 1) neigh.insert(v);
        if(v == 1) neigh.insert(u);
    }
    used[1] = 1;
    for(auto &i : neigh){
        used[i] = 1;
        dfs(i, 0);
        used[i] = 0;
    }
    cout << cnt;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int(t, 1); //cin >> t;
    while(t--){
        solve();
    }
}
