#include <iostream>
#include <list>
#include <set>
using namespace std;

int n, m, v, u, ans, visited[100005][2];
list<int> gr[100005];

int dfs(int x, int step)
{
    if (step == 1)
    {
        for (int i : gr[x])
            if (i != 1)
                ans += dfs(i, 2);
        return 0;
    }
    if (visited[x][0] == 0)
        for (int i : gr[x])
            visited[x][0] += visited[i][1];
    return visited[x][0] - 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        cin >> v >> u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    for (int i : gr[1])
        visited[i][1] = 1;
    for (int i : gr[1])
        dfs(i, 1);
    cout << ans << "\n";
}