#include <bits/stdc++.h>
using namespace std;

map<pair<int, int>, int> used;
vector<int> bus;
vector<pair<int, int>> ans;
vector<bool> used_vertex;

void dfs(int v, vector<vector<int>>& matrix)
{
    used_vertex[v] = true;
    for (int u : matrix[v]) {
        if (!used_vertex[u]) {
            used[{v, u}] = 1;
            used[{u, v}] = 1;
            dfs(u, matrix);
        }
    }
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> matrix(n);
    vector<pair<int, int>> segms(m);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        segms[i] = {u, v};
        matrix[v].push_back(u);
        matrix[u].push_back(v);
    }
    used_vertex.resize(n, false);
    dfs(0, matrix);

    for (int i = 0; i < n; i++) {
        bus.push_back(i + 1);
    }
    //cout << endl;
    for (pair<int, int> p : segms) {
        int v = p.first;
        int u = p.second;
        //cout << v << ' ' << u << endl;
        if (!used[{v, u}]) {
            bus.push_back(u + 1);
            ans.push_back({v + 1, bus.size()});
        }
        else {
            ans.push_back({v + 1, u + 1});
        }
    }
    cout << bus.size() << endl;
    for (int b : bus)
        cout << b << ' ';
    cout << endl;
    for (auto p : ans)
        cout << p.first << ' ' << p.second << endl;

    return 0;
}
