#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "---"; cerr.flush()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)2e5 + 5;
const ll mod = (ll)1e9 + 7;

void operator delete(void*);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n, u, v;

vector<ll> vc;

bool check(ld x) {
    ld res = 0.0;
    for (ll& i : vc) {
        if (i < x) continue;
        res += (i - x) / (ld)u;
    }
    return res >= (x / ld(v));
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> v >> u;
    vc.resize(n);
    for (ll& i : vc) cin >> i;
    sort(all(vc));
    ld l = 0.0, r = vc.back();
    for (ll _ = 0; _ < 200; _++) {
        ld m = (l + r) / 2;
        if (check(m)) l = m;
        else r = m;
    }
    ld res = 0.0;
    for (ll& i : vc) {
        if (i < l) continue;
        res += (i - l);
    }
    cout.precision(10);
    cout << fixed << res;
    return 0;
}
