#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "---"; cerr.flush()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)2e5 + 5;
const ll mod = (ll)1e9 + 7;

void operator delete(void*);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n;

vector<string> vc;

ll dist(const string& a, const string& b) {
    vector<vector<ll>> dp(a.size() + 1, vector<ll>(b.size() + 1, inf));
    dp[0][0] = 0;
    for (ll i = 1; i <= a.size(); i++) {
        for (ll j = 1; j <= b.size(); j++) {
            if (a[i - 1] == b[j - 1]) dp[i][j] = dp[i - 1][j - 1];
            dp[i][j] = min(dp[i][j], dp[i - 1][j] + 1);
            dp[i][j] = min(dp[i][j], dp[i - 1][j - 1] + 1);
            dp[i][j] = min(dp[i][j], dp[i][j - 1] + 1);
        }
    }
    return dp[a.size()][b.size()];
}

string s;

ll d[1010];
ll back[1010];

vector<pair<ll, ll>> g[cst];

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> s;
    vc.push_back(s);
    cin >> s;
    vc.push_back(s);
    cin >> n;
    while (n--) {
        cin >> s;
        vc.push_back(s);
    }
    n = vc.size();
    for (ll i = 0; i < 1010; i++) {
        d[i] = inf;
        back[i] = -1;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            ll x = dist(vc[i], vc[j]);
            x = x * 10000 - 1;
            g[i].push_back({ j, x });
            g[j].push_back({ i, x });
        }
    }
    set<pair<ll, ll>> st;
    d[0] = 0;
    st.insert({ 0, 0 });
    while (!st.empty()) {
        ll v = st.begin()->second;
        st.erase(st.begin());
        for (auto i : g[v]) {
            ll u = i.first;
            if (d[u] > d[v] + i.second) {
                st.erase({ d[u], u });
                d[u] = d[v] + i.second;
                back[u] = v;
                st.insert({ d[u], u });
            }
        }
    }
    cout << dist(vc[0], vc[1]) << " ";
    ll curr = 1;
    vector<ll> ans;
    while (curr > -1) {
        ans.push_back(curr);
        curr = back[curr];
    }
    reverse(all(ans));
    cout << ans.size() - 2 << endl;
    for (ll i = 1; i < ans.size() - 1; i++) cout << vc[ans[i]] << endl;
    return 0;
}