//#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
         
#define ll long long
#define ull unsigned ll
#define vi vector<ll>
#define vvi vector<vi>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ld long double
#define pll pair<ll, ll>
#define mt make_tuple
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define base complex<ld>
 
using namespace std;
const ll INF = (ll)2e9;
const ll inf = (ll)4e18;
const ld eps = (ld)1e-12;
const ll mod = (ll)1e9 + 7; 
const ll mod2 = (ll)1e9 + 9;
const ll MAXN = (ll)1e7 + 11;
const ll MAXC = (ll)1e6 + 10;
const ll MAXE = (ll)1000;
const ll MAXLOG = (ll)19;
const ll maxlen = (ll)1e5;
const ll asci = (ll)256;
const ll block = 512;
const ld PI = acos(-1LL);
const ld e = 2.7182818284;
         
/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<
pii,
null_type,
less<pii>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;*/
         
template <class T>
istream& operator >>(istream &in, vector<T> &arr){
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


struct seg {
    int l, r;
    int px, py, orient;
};


pll getOnSeg(seg x, int q) {
    if (x.orient == 0) {
        return {x.px + q - x.l, x.py};
    } else {
        return {x.px, x.py + q - x.l};
    }
}


struct node {
    ll y;
    seg cnt;
    node *l, *r;

    node(seg c) {
        cnt = c;
        l = nullptr;
        r = nullptr;
        for (int i = 0; i < 4; i++) {
            y += rand();
            if (i != 3) {
                y <<= 15LL;
            }
        }
    }
};


node* merge(node *a, node *b) {
    if (!a) {
        return b;
    }
    if (!b) {
        return a;
    }
    if (a->y < b->y) {
        a->r = merge(a->r, b);
        return a;
    } else {
        b->l = merge(a, b->l);
        return b;
    }
}


pair<node*, node*> split1(node *t, int x) {
    if (!t) {
        return {nullptr, nullptr};
    }
    if (t->cnt.r < x) {
        auto r = split1(t->r, x);
        t->r = r.first;
        return {t, r.second};
    } else {
        auto l = split1(t->l, x);
        t->l = l.second;
        return {l.first, t};
    }
}


pair<node*, node*> split2(node *t, int x) {
    if (!t) {
        return {nullptr, nullptr};
    }
    if (t->cnt.l < x) {
        auto r = split2(t->r, x);
        t->r = r.first;
        return {t, r.second};
    } else {
        auto l = split2(t->l, x);
        t->l = l.second;
        return {l.first, t};
    }
}


pll query(node *t, int x) {
    if (t->cnt.l <= x and t->cnt.r >= x) {
        return getOnSeg(t->cnt, x);
    }
    if (t->cnt.r < x) {
        return query(t->r, x);
    } else {
        return query(t->l, x);
    }
}


vector<seg> res;


void dfs(node *t) {
    if (!t) {
        return;
    }
    dfs(t->l);
    res.pb(t->cnt);
    dfs(t->r);
}


vector<seg> sSeg(seg s, int l, int r) {
    if (l == s.l and s.r == r) {
        s.orient ^= 1;
        return {s};
    }
    if (l == s.l) {
        seg s1 = {l, r, s.px, s.py, s.orient ^ 1};
        pll p = getOnSeg(s, r + 1);
        seg s2 = {r + 1, s.r, p.first, p.second, s.orient};
        return {s1, s2};
    }
    if (r == s.r) {
        pll p = getOnSeg(s, l);
        seg s1 = {s.l, l, s.px, s.py, s.orient};
        seg s2 = {l, r, p.first, p.second, s.orient ^ 1};
    }
    pll p1 = getOnSeg(s, l), p2 = getOnSeg(s, r + 1);
    seg s1 = {s.l, l, s.px, s.py, s.orient}, 
        s2 = {l, r, p1.first, p1.second, s.orient ^ 1},
        s3 = {r + 1, s.r, p2.first, p2.second, s.orient};
    return {s1, s2, s3};
}


void addSeg(vector<seg> &um, seg nS) {
    um.pb(nS);
    while (um.size() > 1 and um.back().orient == um[um.size() - 2].orient) {
        auto t1 = um.back(), t2 = um[um.size() - 2];
        if (t1.orient == 0 and 
                (t1.py != t2.py or t2.px + (t2.r - t2.l) != t1.px)) {
            break;
        } 
        if (t1.orient == 1 and (t1.px != t2.px or t2.py + (t2.r - t2.l) != t1.py)) {
            break;
        } 

        seg b = um.back();
        um.pop_back();
        seg t = um.back();
        um.pop_back();
        um.pb({t.l, b.r, t.px, t.py, t.orient});  
    }
}


node* rotate(node *t, int l, int r) {
    auto x1 = split1(t, l);
    node *beforeL = x1.first;
    auto x2 = split2(x1.second, r);
    node *need = x2.first, *afterR = x2.second;
    dfs(need);
    vector<seg> unmerged;
    for (auto s : res) {
        if (s.l <= l and r <= s.r) {
            auto jjj = sSeg(s, l, r);
            for (auto uuu : jjj) {
                addSeg(unmerged, uuu);
            }
        } else {
            addSeg(unmerged, s);
        }
    }
    node *kek = nullptr;
    for (auto s : unmerged) {
        kek = merge(kek, new node(s));
    }
    res.clear();
    return merge(merge(beforeL, kek), afterR);
}


void debSeg(seg s) {
    cout << s.l << " " << s.r << " " << s.px << " " << s.py << " " << s.orient << "\n";
}


void dfs1(node *t) {
    if (!t) {
        return;
    }
    dfs1(t->l);
    debSeg(t->cnt);
    dfs1(t->r);
}

 
void solve() {
    ll n, q;
    cin >> n >> q;
    node *treap = new node({1, n, 1, 0, 0});
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r;
            cin >> l >> r;
            treap = rotate(treap, l, r);
            //dfs1(treap);
        } else {
            ll x;
            cin >> x;
            auto p = query(treap, x);
            cout << p.first << " " << p.second << "\n";
        }
    }
}
  
signed main() {
    srand(time(0LL));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr); 
#endif
    cout.precision(30);
     
    solve();
  
    return 0LL;
}