#include <bits/stdc++.h>

using namespace std;

#define DIM 20007

typedef long double ld;
typedef long long ll;

struct point{
    long long x,y;
};

point p[DIM], res[DIM];
ld px,py,z;
long long all;

ld vproduct(ld x, ld y, ld x1, ld y1, ld x2, ld y2) {
    return (x1-x)*(y2-y) - (x2-x)*(y1-y);
}

bool cmp(point p1, point p2) {
    return p1.x < p2.x || (p1.x == p2.x && p1.y < p2.y);
}

ll n = 0,l;
void add(ll x,ll y){
    p[++n] = {x-l,y};
    p[++n] = {x+l,y};
    p[++n] = {x,y-l};
    p[++n] = {x,y+l};
}
void solve(){
    ll n;
    cin>>n>>l;
    for(ll i = 1;i<=n;++i){
        ll x,y;
        cin>>x>>y;
        add(x,y);
    }
}
ld dist(point a,point b){
    ll d1 = a.x-b.x;
    ll d2 = a.y-b.y;
    return sqrt(d1*d1+d2*d2);
}
int main()
{
    solve();

    sort(p+1, p+1+n, cmp);
    all = 1;
    res[1] = p[1];
    for(int i = 1; i <= n; i++) {
        while(all > 1 && vproduct(res[all-1].x, res[all-1].y, res[all].x, res[all].y, p[i].x, p[i].y) >= 0)
            all--;
        all++;
        res[all] = p[i];
    }

    long long tmp = all;
    for(int i = n-1; i >= 1; i--) {

        while(all > tmp && vproduct(res[all-1].x, res[all-1].y, res[all].x, res[all].y, p[i].x, p[i].y) >= 0)
            all--;
        all++;
        res[all] = p[i];
    }



    all --;
    if(all == 2 && res[1].x == res[2].x && res[1].y == res[2].y) all--;

    if(n % 2 == 0) reverse(res+1, res+1+all);


    ld r = 0;
    for(int i = 2; i <= all; i++) r+=dist(res[i],res[i-1]);
    r+=dist(res[1],res[all]);
    cout<<fixed<<setprecision(10)<<r<<endl;
    return 0;
}
