#include <iostream>
#include <vector>

using namespace std;

struct Edge {
	int u, v;
	Edge() {}
	Edge(int init_u, int init_v) {
		u = init_u;
		v = init_v;
	}
};

const int maxn = (int)(1e5) + 3, maxm = (int)(2e6) + 7;
int n, m;
long long ans;
bool to[maxn];
vector <int> g[maxn];

int main() {

	cin >> n >> m;
	for (int i = 1; i <= m; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
		if (u == 1) to[v] = true;
		if (v == 1) to[u] = true;	
	}

	for (int v = 2; v <= n; v++) {
		int cnt = 0;
		for (size_t it = 0; it < g[v].size(); it++) {
			int to_v = g[v][it];
			if (to[to_v])
				cnt++;
		}
		ans += (cnt * 1ll * (cnt - 1));
	}

	cout << ans;
	return 0;
}