#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <set>
#include <iomanip>
#include <queue>
#include <math.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define int long long
#define ff first
#define ss second

const int INF = 1e18;

///mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
struct Point
{
	double x, y;
	Point() {};
	Point(double x, double y): x(x), y(y) {};
	Point operator-(Point a) { return Point(x - a.x, y - a.y); }
};

double dist(Point a, Point b)
{
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int cros(Point a, Point b)
{
	return a.x * b.y - a.y * b.x;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int n, l; cin >> n >> l;
	vector <Point> q(n); for (int i = 0;i < n; ++i) { cin >> q[i].x >> q[i].y; }
	vector <Point> w;
	int x=q[0].x - l, y=q[0].y, ind = 0;
	for (int o = 0 ; o < n; ++o)
	{
		Point i = q[o];
		w.push_back({ i.x, i.y + l });
		w.push_back({ i.x, i.y - l });
		w.push_back({ i.x + l, i.y });
		w.push_back({ i.x - l, i.y });
		if (x > i.x - l)
		{
			x = i.x - l; y = i.y;
		}
	}
	set <pair <int, int>> p;
	for (auto i : w)
	{
		p.insert({i.x, i.y});
	}
	w.clear();
	int o = -1;
	for (auto i : p)
	{
		o++;
		w.emplace_back(i.first, i.second);
		if (x == i.first && y == i.second)
		{
			ind = o;
		}
	}
	swap(w[0], w[ind]);
	sort(w.begin() + 1, w.end(), [&w](Point a, Point b) {if (cros(a - w[0], b - w[0]) != 0) { return cros(a - w[0], b - w[0]) > 0; } else { return dist(w[0], a) < dist(w[0], b); }});

	vector < Point > st;
	w.push_back(w[0]);
	for (int i = 0; i < w.size(); ++i)
	{
		if (st.size() < 2)
		{
			st.push_back(w[i]);
			continue;
		}
		int ls = st.size() - 1;
		Point o = st[ls - 1], a = st[ls], b = w[i];
		while (cros(a - o, b - o) <= 0 && ls > 0)
		{
			st.pop_back(); ls--;
			if (ls > 0) 
			{
				o = st[ls - 1]; a = st[ls]; b = w[i];
			}
		}
		st.push_back(w[i]);
	}

	double res = 0;
	for (int i = 0; i < st.size() - 1; ++i)
	{
		res += dist(st[i], st[i + 1]);
	}
	cout << fixed << setprecision(15) << res << "\n";


	
	



}