#include<bits/stdc++.h>

#define ll long long
#define ld long double
#define fi first
#define y1 firssadt
#define se second
#define pb push_back
#define pk pop_back

using namespace std;

struct pt
{
    double x, y;
};
ld get_dlina(ld x1, ld y1,ld x2, ld y2){
    ld a = abs(x1 - x2),
            b = abs(y1 - y2);

    return sqrt(pow(a, 2) + pow(b, 2));
}

bool cmp (pt a, pt b)
{
    return a.x < b.x || a.x == b.x && a.y < b.y;
}
bool cw (pt a, pt b, pt c)
{
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}
bool ccw (pt a, pt b, pt c)
{
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}
void convex_hull (vector<pt> & a)
{
    if (a.size() == 1) return;
    sort (a.begin(), a.end(), &cmp);
    pt p1 = a[0], p2 = a.back();
    vector<pt> up, down;
    up.push_back (p1);
    down.push_back (p1);
    for (size_t i=1; i<a.size(); ++i)
    {
        if (i==a.size()-1 || cw (p1, a[i], p2))
        {
            while (up.size()>=2 && !cw (up[up.size()-2], up[up.
                                        size()-1], a[i]))
                up.pop_back();
            up.push_back (a[i]);
        }
        if (i==a.size()-1 || ccw (p1, a[i], p2))
        {
            while (down.size()>=2 && !ccw (down[down.size()-2],
                                           down[down.size()-1], a[i]))
                down.pop_back();
            down.push_back (a[i]);
        }
    }
    a.clear();
    for (size_t i=0; i<up.size(); ++i)
        a.push_back (up[i]);
    for (size_t i=down.size()-2; i>0; --i)
        a.push_back (down[i]);
}
int main(){
    int n, z = 0;
    ld asd, dasd, l;
    cin >> n >> l;
    vector<pt> a(n * 4 );
    ld ans = 0;
    for(int i = 0; i < n; i++){
        cin >> asd >> dasd;
        a[z].x = (asd + l);
        a[z].y = (dasd);
        z++;
        a[z].x = (asd - l);
        a[z].y = (dasd);
        z++;
        a[z].x = (asd);
        a[z].y = (dasd + l);
        z++;
        a[z].x = (asd);
        a[z].y = (dasd - l);
        z++;

    }
    convex_hull( a);
    for(int i = 0; i < a.size() - 1; i++){
        ans += get_dlina(a[i].x, a[i].y, a[i + 1].x, a[i + 1].y);
    }
    ans += get_dlina(a[a.size() - 1].x, a[a.size() - 1].y, a[0].x, a[0].y);
    cout << setprecision(15) << ans;
    return 0;
}

