#include<unordered_set>
#include<algorithm>
#include<iostream>
#include<iomanip>
#include<vector>
#include<string>
#include<queue>
#include<stack>
#include<tuple>
#include<cmath>
#include<set>
#include<map>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;

const int INF = 1e9 + 9;

ll n, m, cnt, ans;
map<ll, vector<ll>> edge;
vector<bool> used;
vector<bool> an;

void dfs(ll i) {
    if (cnt == 2) {
        for (auto u : edge[i]) {
            if (used[u] && an[u] && i != 0) {
                ans++;
            }
        }
        return;
    }
    for (auto u: edge[i]) {
        if (used[u]) {
            used[u] = false;
            cnt++;
            dfs(u);
            cnt--;
            used[u] = true;
        }
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    used.resize(n + 1, true);
    an.resize(n + 1, false);
    used[0] = false;
    for (int i = 0; i < m; ++i) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        edge[x].push_back(y);
        edge[y].push_back(x);
        if (x == 0)
            an[y] = true;
        if (y == 0)
            an[x] = true;
    }
    dfs(0);
    cout << ans << "\n";
    return 0;
}