
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        String f = s.nextLine();
        int n = Integer.parseInt(f.split("\\s")[1]);
        if (n < 4) {
            System.out.println(0);
            System.exit(0);
        }
        HashMap<Integer, ArrayList<Integer>> place2neighbor = new HashMap<>();
        for (int i = 0; i < n; i++) {
            String coord = s.nextLine();
            int p1 = Integer.parseInt(coord.split("\\s")[0]);
            int p2 = Integer.parseInt(coord.split("\\s")[1]);

            ArrayList<Integer> places = new ArrayList();
            places.add(p2);
            if (place2neighbor.containsKey(p1)) {
                places.addAll(place2neighbor.get(p1));
            }
            place2neighbor.put(p1, places);

            ArrayList<Integer> places2 = new ArrayList();
            places2.add(p1);
            if (place2neighbor.containsKey(p2)) {
                places2.addAll(place2neighbor.get(p2));
            }
            place2neighbor.put(p2, places2);

        }

        ArrayList<Integer> neighbors2one = place2neighbor.get(1);
        int answer = 0;
        ArrayList<ArrayList<Integer>> used = new ArrayList<>();
        for (int i = 0; i < neighbors2one.size(); i++) {
            ArrayList<Integer> nei2nei = place2neighbor.get(neighbors2one.get(i));
            for (Integer j : nei2nei) {
                if (neighbors2one.contains(j)) {
                    if (used.size() == 0 || !used.get(i).contains(j) && !used.get(i).contains(neighbors2one.get(i))) {
                        ArrayList<Integer> usedPath = new ArrayList<>();
                        usedPath.add(j);
                        usedPath.add(neighbors2one.get(i));
                        used.add(usedPath);
                        answer++;
                    }
                }
            }
            used.clear();
        }
        System.out.println(answer);
    }
}
