#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

int cnt = 0;
map<int, set<int>> g;
vector<int> used;

void dfs(int u, int l, int p) {
	if (l == 3) {
		if (g[0].find(u) != g[0].end()) {
			//cout << u << cnt;
			cnt++;
		}
		return;
	}
	for (auto v : g[u]) {
		if (v != p) dfs(v, l + 1, u);
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	used.resize(n);
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].insert(v);
		g[v].insert(u);
	}
	dfs(0, 0, -1);
	cout << cnt;
	return 0;
}