#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <bitset>
using namespace std;

typedef long long ll;
const int N = 1e6 + 100;
bitset<N>dp;

int l[200];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	dp[0] = 1;
	int n;
	cin >> n;
	int S = 0;
	for (int i = 0; i < n; i++) {
		cin >> l[i];
		dp |= dp << l[i];
		S += l[i];
	}
	ll ans = 2 * S + 1;
	vector<int>xs;
	vector<int>ys;
	for (int i = 1; i < S; i++) {
		if (dp[i]) {
			xs.push_back(i);
			ys.push_back(S - i);
			ans += i;
		}
	}
	reverse(ys.begin(), ys.end());
	for (int i = 1; i < S; i++) {
		if (dp[i]) {
			int x = i;
			int y = S - i;
			ans += x;
			int bx = upper_bound(xs.begin(), xs.end(), x) - xs.begin();
			int by = ys.size() - (lower_bound(ys.begin(), ys.end(), y) - ys.begin());
			ans -= min(bx, by);
		}
	}
	cout << ans;
	return 0;
}