// #pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt")
// #pragma GCC target("avx,avx2")
// #define INTER

#include <bits/stdc++.h>

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef std::pair<ll, ll> pll;
typedef std::pair<int, int> pii;

std::random_device rd;
std::mt19937 Random(rd());
const int inf = 0x3f3f3f3f;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ld eps = 1e-10;
const ll mod = 998244353;

//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0), std::cerr.tie(0);
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define PROBLEM "task"
#define mp std::make_pair

template<typename T, typename T1>
inline T mx(T &a, T1 b) { return (a > b ? a : a = b); }
template<typename T, typename T1>
inline T mn(T &a, T1 b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------

using namespace std;

int32_t main() {
#ifndef DEBUG
    #ifndef INTER
    fast_io;
#endif
#else
    freopen(PROBLEM".in", "r", stdin);
#endif

    std::cout << std::setprecision(15) << std::fixed;
    std::cerr << std::setprecision(15) << std::fixed;
    long double START_TIME = clock();
    
    // int n;
    // std::cin >> n;
    // int a[n];
    // // for(int i = 0; i < n; i++) a[i] = i + 1;
    // for(auto &i : a) std::cin >> i;
    // std::set<int> numbers;
    // for(int i = 0; i < n; i++) {
    //     debug(i);
    //     std::set<int> tmp;
    //     tmp.insert(a[i]);
    //     for(auto &j : numbers) tmp.insert(a[i] + j);
    //     if(tmp.size() > numbers.size()) std::swap(tmp, numbers);
    //     for(auto &j : tmp) numbers.insert(j);
    // }
    int n, v, u;
    std::cin >> n >> v >> u;
    int a[n];
    for(auto &i : a) std::cin >> i;
    std::sort(a, a + n);
    ld l = 0, r = 0;
    for(int i = n - 1; i >= 0; i--) {
        ld ost = a[i] - r * v;
        r += ost / (0. + v + u);
    }
//    r = 100. / 3;
    for(int _ = 0; _ < 300; _++) {
        ld mid1 = (l + r) / 2;
        ld sum1 = 0;
        for(int i = 0; i < n; i++) sum1 += (a[i] - mid1 * v) / u;
        // debug(sum);
        // debug(mid);
        // debug(std::fabs(sum - mid) < eps);
        if(sum1 > mid1) {
            l = mid1;
        }
        else {
            r = mid1;
        }
        // break;
    }
    std::cout << l * u;

    std::cerr << '\n';
    long double TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    // debug(TIME);
    return 0;
}