#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<vector<int> > v;



int main() {
    int n, m;
    cin >> n >> m ;
    v.resize(n);
    for(int i = 0;i < m;i++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    vector<int> dist(n, 1e9);
    queue<int> q;
    dist[0] = 0;
    q.push(0);
    while(q.size()){
        int now = q.front();
        q.pop();
        for(auto f: v[now]){
            if(dist[f] == 1e9){
                dist[f] = dist[now] + 1;
                q.push(f);
            }
        }
    }

    vector<long long> dp11(n, 0);
    vector<long long> dp21(n, 0);
    vector<long long> dp31(n, 0);
    vector<long long> dp22(n, 0);
    vector<int> one;
    for(int i = 0;i < n;i++){
        if(dist[i] == 1){
            one.push_back((i));
            dp11[i] = 1;
        }
    }
    for(auto f: one){
        for(auto g: v[f]){
            if(dist[g] == 1)
                dp21[g]++;
            if(dist[g] == 2)
                dp22[g]++;
        }
    }
    long long ans = 0;
    for(auto f: one){
        for(auto g: v[f]){
            if(dist[g] == 1)
                dp31[f] += dp21[g] - 1;
            if(dist[g] == 2)
                dp31[f] += dp22[g] - 1;

        }
        ans += dp31[f];
    }
    cout << ans << '\n';





    return 0;
}
/*
10 14
1 5
2 5
5 6
2 3
1 3
2 4
4 6
1 6
1 7
7 8
8 1
1 10
9 10
9 8
*/
