import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class I {
    private static StringTokenizer st = null;
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        PrintWriter out = new PrintWriter(System.out);
        int n = nextInt();
        int m = nextInt();
        LinkedList<Integer>[] graph = new LinkedList[n];
        for (int i = 0; i < n; i++) graph[i] = new LinkedList<>();
        for (int i = 0; i < m; i++) {
            int a = nextInt(), b = nextInt();
            graph[a - 1].add(b - 1);
            graph[b - 1].add(a - 1);
        }
        boolean[] da = new boolean[n];
        for (int u : graph[0]) da[u] = true;
        int[] depth = new int[n];
        depth[0] = 0;
        for (int u : graph[0]) {
            depth = new int[n];
            dfs(graph, u, 1, depth, da);
        }
        out.println(g);
        out.close();
    }

    private static int g = 0;

    private static void dfs(LinkedList<Integer>[] graph, int v, int d, int[] depth, boolean[] da) {
        if (d == 3) {
            if (da[v]) g++;
            return;
        }
        depth[v] = d;
        for (int u : graph[v]) {
            if (depth[u] == 0 && u != 0) {
                dfs(graph, u, d + 1, depth, da);
            } else if (depth[u] < depth[v]) continue;
        }
    }
}
