import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class I {
    private static StringTokenizer st = null;
    private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    private static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    private static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        LinkedList<Integer>[] graph = new LinkedList[n];
        for (int i = 0; i < n; i++) graph[i] = new LinkedList<>();
        for (int i = 0; i < m; i++) {
            int a = nextInt(), b = nextInt();
            graph[a - 1].add(b - 1);
            graph[b - 1].add(a - 1);
        }
        int[] arr = new int[n];
        for (int u : graph[0]) dfs(graph, u, 1, arr);
        for (int i = 1; i < n; i++) {
            if (arr[i] > 1) {
                g += arr[i] * (arr[i] - 1);
            }
        }
        System.out.println(g);
    }

    private static int g = 0;

    private static void dfs(LinkedList<Integer>[] graph, int v, int d, int[] arr) {
        if (d == 2) {
            arr[v]++;
            return;
        }
        for (int u : graph[v]) {
            dfs(graph, u, d + 1, arr);
        }
    }
}
