#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string.h>
#include <sstream>
#include <stack>
#include <stdio.h>
#include <vector>
#include <bitset>
#include <queue>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef set<ll> sll;


void acceleration () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void formatting () {
    cout << fixed;
    cout.precision(12);
    cout << setprecision(11);
}

void solve();

int main () {
    acceleration();
    formatting();
    solve();
}
ll const N = 1e6 + 10, mod = 1e9+ 7;
vll a;
bool dp[N];

ll GCD (ll n, ll m) {
    if (!m) return n;
    return GCD(m, n % m);
}

ll Bin_Pow(ll n, ll k){
    if (k == 0) return 1;
    if (k % 2 == 0) return (Bin_Pow(n, k / 2) * Bin_Pow(n, k / 2)) % mod;
    else return (n * Bin_Pow(n, k - 1)) % mod;
}

void funk(ll idx, ll pos){
    if(dp[pos + a[idx]]) return;
    dp[pos + a[idx]] = true;
    funk(idx + 1, pos);
    funk(idx + 1, + a[idx]);
}

void solve () {
    ll n, x, v, u, sum = 0, idx, k, m = 1e18, t, ans = 0, o = 0;
    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> x;
        a.push_back(x);
        sum += x;
    }
    dp[0] = true;
    dp[sum] = true;
    funk(0,0);
    for(int i = 0; i <= sum; i++){
        if(!dp[i]) o++;
    }
    ans = (sum + 2) * (sum + 1) / 2 - o * (o + 1) / 2;
    cout << ans << '\n';
}