#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string.h>
#include <sstream>
#include <stack>
#include <stdio.h>
#include <vector>
#include <bitset>
#include <queue>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef set<ll> sll;


void acceleration () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void formatting () {
    cout << fixed;
    cout.precision(12);
    cout << setprecision(11);
}

void solve();

int main () {
    acceleration();
    formatting();
    solve();
}
ll const N = 510, mod = 1e9+ 7;
vll a;

ll GCD (ll n, ll m) {
    if (!m) return n;
    return GCD(m, n % m);
}

ll Bin_Pow(ll n, ll k){
    if (k == 0) return 1;
    if (k % 2 == 0) return (Bin_Pow(n, k / 2) * Bin_Pow(n, k / 2)) % mod;
    else return (n * Bin_Pow(n, k - 1)) % mod;
}

void solve () {
    ll n, x, v, u, sum = 0, idx, k, l;
    double m, t, ans, o;
    cin >> n >> v >> u;
    a.push_back(0);
    for(int i = 1; i <= n; i++){
        cin >> x;
        a.push_back(x);
        sum += x;
    }
    m = 1.0 * sum / u;
    sort(a.begin(), a.end());
    for(int i = 1; i <= n; i++) {
        m = m - 1.0 * (n + 1 - i) * (a[i] - a[i - 1]) / u;
        t = a[i] / v;
        if (m == t) {
            cout << m * u << '\n';
            return;
        }
        if (m < t) {
            idx = i;
            break;
        }
    }
    o = (1.0 * a[idx] - m * v) * u / (1.0 * u + (n - idx + 1.0) * v);
    ans = m * u + 1.0*(n - idx + 1) * o;
    cout << ans << '\n';
}