#include <iostream>
#include <vector>

using namespace std;

int n;
int q;

class Magnite
{
	public:
		
		Magnite(int x, int y)
		{
			this -> x = x;
			this -> y = y;
		}
	
	int x;
	int y;
	
};

vector<Magnite> magnites;
vector<pair<int, int>> toPrint;

void Revert(int from, int to)
{
	if (from == to)
		return;

	if (magnites[from - 1].y == magnites[to - 1].y)
	{
		int temp = 1;

		for (int i = from; i <= to -1; i++)
		{
			magnites[i].x = magnites[from -1].x;
			magnites[i].y = magnites[from - 1].y + temp;
			temp++;
		}
	}
	else if (magnites[from - 1].x == magnites[to - 1].x)
	{
		int temp = 1;

		for (int i = from; i <= to -1; i++)
		{
			magnites[i].y = magnites[from - 1].y;
			magnites[i].x = magnites[from - 1].x + temp;
			temp++;
		}
	}
}

void AddToPrint(int n)
{
	pair<int, int> pair;
	pair.first = magnites[n-1].x;
	pair.second = magnites[n-1].y;

	toPrint.push_back(pair);
}

void Print()
{
	for (int i = 0; i < toPrint.size(); i++)
		cout << toPrint[i].first << " " << toPrint[i].second << endl;
}

int main()
{
	cin >> n >> q;

	for (int i = 0; i < n; i++)
	{
		Magnite magnite(i + 1, 0);
		magnites.push_back(magnite);
	}

	for(int i = 0; i < q; i++)
	{
		int l;
		cin >> l;

		if (l == 1)
		{
			int from, to;
			cin >> from >> to;

			Revert(from, to);
		}
		else if (l == 2)
		{
			cin >> n;
			AddToPrint(n);
		}
	}

	Print();
		
	return 0;
}