﻿#include <iostream>
#include <math.h>

using namespace std;

#define EPS 1e-11
#define PI acos(-1.0)
double sqr(double x) { return x*x; }

int i, n;
double fi, Left, Right, Middle;

int main() {

 scanf("%d", &n);
 Left = n / 2; Right = n * n;

 while (fabs(Right - Left) > EPS)
 {
 
  Middle = (Left + Right) / 2;
  for (fi = 0, i = 1; i <= n; i++)
  {
   double angle = (2 * sqr(Middle) - sqr(i)) / (2 * sqr(Middle));

   if (angle < -1.0 || angle > 1.0)
   {
    fi = 100;
    break;
   }
   fi += acos(angle);
  }
  //В зависимости от найденной суммы углов fi, корректируем отрезок поиска.
  if (fi > 2 * PI) Left = Middle;
  else Right = Middle;
 }
 printf("%.8lf\n", Left);
 return 0;
}