#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <queue>


using namespace std;


vector <int> g[100010];
queue <int> q;
vector <int> new_g[100010];
int color[200010];
bool used[200010];


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if (a > b)
            swap(b, a);
        g[a].push_back(b);
    }
    cout << m + 1 << endl;
    int inq = 0;
    for (int j = 1; j <= n; j++) {
        if (!used[j]) {
            q.push(j);
            inq++;
            for (int k = inq; k <= m + 1; k++) {
                if (q.size() == 0) {
                    break;
                }
                color[k] = q.front();
                q.pop();
                int a = color[k];
                if (!used[a])
                    for (int i = 0; i < g[a].size(); i++) {
                        q.push(g[a][i]);
                        inq++;
                        new_g[k].push_back(inq);
                    }
                used[a] = 1;
            }
        }
    }
    for (int i = 1; i <= m + 1; i++) {
        cout << color[i] << " ";
    }
    cout << endl;
    for (int i = 1; i <= m; i++) {
        for (int j = 0; j < new_g[i].size(); j++) {
            cout << i << " " << new_g[i][j] << endl;
        }
    }
    return 0;
}