#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

vector < vector <bool> > matrix;
vector<bool> isVisited;
size_t ans = 0;

void DFS(int, int, int);

int main() {
	int n, m, p1, p2;
	cin >> n >> m;

	matrix.resize(n, vector < bool >(n, false));
	isVisited.resize(n, false);

	for (int i = 0; i < m; i++) {
		cin >> p1 >> p2;
		matrix[--p1][--p2] = true;
		matrix[p2][p1] = true;
	}

	DFS(0, 0, -1);

	cout << ans;

	return 0;
}

void DFS(int currentVertex, int counter, int pred) {
	isVisited[currentVertex] = true;

	if (counter == 3) {
		if (matrix[currentVertex][0])
			ans++;
		return;
	}

	for (int i = 0; i < matrix.size(); i++) {
		if ((matrix[currentVertex][i] && !isVisited[i]) ||
			(matrix[currentVertex][i] && matrix[i][0] && i != pred)) { //
			DFS(i, counter + 1, currentVertex);
		}
	}

	for (int i = 0; i < isVisited.size(); i++) {
		if (isVisited[i] && i != pred && i != 0) {
			isVisited[i] = false;
		}
	}
}
