#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <bitset>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <stack>
#include <queue>

using namespace std;
using namespace __gnu_pbds;


/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define mp make_pair
#define f first
#define s second
#define deb(a) cerr << #a << " = " << a << '\n';
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(20); \
    cerr << fixed << setprecision(11); \
}

template < typename firstType, typename secondType = null_type, class compare = less < firstType > >
struct sett {
    typedef tree <
        firstType,
        secondType,
        compare,
        rb_tree_tag,
        tree_order_statistics_node_update
    > _ ;
};


const int INF = 1e18 + 7;
const ld EPS = 1e-8;
const int MAXI = 350;
const int MOD = 998244353;
const int MOD1 = 1e9 + 7;
const int MAXST = 2000000;
const int P = 31;
const int P1 = 37;
const ld PI = 3.14159265358979323;


ostream &operator<<(ostream &stream, const pair <int, int> &p) {
    stream << p.first << ' ' << p.second << ' ';
    return stream;
}

int bpow(int a){
    if (a == 0)
        return 1;
    else if (a % 2)
        return bpow(a - 1) * 2 % MOD1;
    else {
        int b = bpow(a / 2);
        return b * b % MOD1;
    }
}

bool comp(pair < int, int > a, pair < int, int > b){
    return a.f > b.f || (a.f == b.f && a.s < b.s);
}

vector < int > ve[300000];

signed main(){
    fast();
    int n, m;
    cin >> n >> m;
    set < int > s;
    int kol = 0;
    for (int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        ve[x].eb(y);
        ve[y].eb(x);
        if (x == 0)
            s.insert(y);
        else if (y == 0)
            s.insert(x);
    }
    queue < pair < pair < int, int >, set < pair < int, int > > > > q;
    set < pair < int, int > > d;
    q.push({{0, 0}, d});
    while (q.size()){
        int v = q.front().f.f;
        int k = q.front().f.s;
        set < pair < int, int > > u = q.front().s;
        q.pop();
        if (k == 3 && s.find(v) != s.end()){
            kol++;
        }
        else if (k < 3){
            for (auto it : ve[v]){
                if (u.find({v, it}) == u.end() && u.find({it, v}) == u.end()){
                    u.insert({it, v});
                    u.insert({v, it});
                    q.push({{it, k + 1}, u});
                    u.erase({it, v});
                    u.erase({v, it});
                }
            }
        }
    }
    cout << kol << '\n';
    return 0;
}