#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
const int N = 1e5, M = 1e9 + 7;
vector <int> g[N];
vector <pair <int, int>> ea;
set <pair <int, int>> e;
int a[N * 2];
bool us[N] = { false };
void dfs(int v)
{
	us[v] = true;
	a[v] = v + 1;
	for (auto r : g[v])
		if (!us[r])
		{
			ea.push_back({ v + 1, r + 1 });
			dfs(r);
			e.erase({ v, r });
			e.erase({ r, v });
		}
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[b].push_back(a);
		g[a].push_back(b);
		e.insert({ a, b });
	}
	dfs(0);
	int k = n;
	while (e.size())
	{
		pair <int, int> p = *e.begin();
		e.erase(e.begin());
		a[k++] = a[p.second];
		ea.push_back({ p.first + 1, k });
	}
	cout << k << "\n";
	for (int i = 0; i < k; ++i)
		cout << a[i] << " ";
	cout << "\n";
	for (auto r : ea)
		cout << r.first << " " << r.second << "\n";
}
/*#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <algorithm>
using namespace std;
const int N = 2e5, M = 1e9 + 7;
struct Vec
{
	long long x, y;
	Vec(int a, int b)
	{
		x = a;
		y = b;
	}
	friend long long operator*(Vec a, Vec b)
	{
		return a.x * b.y - b.x * a.y;
	}
};
vector <Vec> h, g;
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, l;
	cin >> n >> l;
	int xp, yp;
	for (int i = 0; i < n; ++i)
	{
		int x, y;
		cin >> x >> y;
		Vec a(x, y);
		h.push_back(a);
	}
	for (int i = 0; i < n; ++i)
	{
		int pr = (n + i - 1) % n;
		int nx = (i + 1) % n;
		if (h[pr].y > h[i].y)
		{
			if (h[nx].x < h[i].x)
			{
				Vec nzh(h[i].x, h[i].y - l);
				Vec lf(h[i].x + l, h[i].y);
				g.push_back(lf);
				g.push_back(nzh);
			}
		}
		else
		{
			if (h[pr].y < )
		}
	}
}*/