﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <queue>
#include <string>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <ctime>  

using namespace std;

typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else return bin_pow(a, n - 1) * a;
}
ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
long long bin1(vector<long long>& a, long long z)
{
	long long l = 0;
	long long r = a.size();
	while (l != r - 1)
	{
		long long m = (l + r) / 2;
		if (a[m] > z)
			r = m;
		else
			l = m;
	}
	return l;
}
int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	vector<long long>a;
	set<long long>a1;
	long long n;
	cin >> n;

	a1.insert(0);
	for (long long i = 0; i < n; i++)
	{
		long long q;
		cin >> q;
		for (auto k : a1)
			a.push_back(k+ q);
		for (auto k : a)
			a1.insert(k);
		a.clear();
	}
	ll sum=0;
	a1.erase(0);

	for (auto i : a1)
	{
		a.push_back(i);
		sum += i;
	}

	ll sum1 = a[a.size() - 1];
	ll count = 0;
	for (long long i = 0; i < a.size(); i++)
	{
		count += a.size()-bin1(a, sum1 - a[i]);
	}
	cout << sum * 2+(a.size())*2 - count;
	return 0;
}