﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <queue>
#include <string>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <ctime>  

using namespace std;

typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else return bin_pow(a, n - 1) * a;
}
ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}



int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	/*long long n;
	cin >> n;
	long long ans = 1e9;
	for (long long i = 1; i <= min(long long(1e7), n); i++) {
		long long ans1 = ans;
		if (n % (i * 2) == 0 || n % (i * 2) == i) {
			if (n % (i * 2) == i) ans = min(ans, abs(i - (n / i + 1)));
			else ans = min(ans, abs(i - n / i));
		}
		if (n % (i * 2 - 1) == 0 || n % (i * 2 - 1) == i - 1 || n % (i * 2 - 1) == i) {
			if (n % (i * 2 - 1) == i - 1 || n % (i * 2 - 1) == i) {
				ans = min(ans, abs(i - (n / (i * 2 - 1) * 2 + 1)));
			}
			else ans = min(ans, abs(i - n / (i * 2 - 1) * 2));
		}
		if (n % (i * 2 + 1) == 0 || n % (i * 2 + 1) == i + 1 || n % (i * 2 - 1) == i) {
			if (n % (i * 2 - 1) == i + 1 || n % (i * 2 - 1) == i) {
				ans = min(ans, abs(i + 1 - (n / (i * 2 + 1) * 2 + 1)));
			}
			else ans = min(ans, abs(i + 1 - n / (i * 2 + 1) * 2));
		}
		if (ans < ans1) cout << ans << ' ' << i << "\n";
	}
	cout << ans;*/
	long long n;
	cin >> n;
	vector<long long>ans;
	ll q1 = sqrt(n);
	ll q2 = q1 + 1;

	for (long long i = 0; i < 1000000; i++)
	{
		ll now1 = n / q1;
		ll now2 = n / q2;
		if (n % q1 == 0)
		{
			ans.push_back(abs(q1 - now1));
		}
		else
		{
			if (q1 % 2 == 0)
			{
				if (q1 / 2 * now1 + q1 / 2 * (now1 + 1) == n)
					ans.push_back(abs(q1 - now1 - 1));
			}
			else
			{
				if(q1/2*now1+(q1/2+1)*(now1+1)==n || (q1/2+1)*now1+(q1/2)*(now1+1)==n)
					ans.push_back(abs(q1 - now1 - 1));
			}
		}
		if (n % q2 == 0)
		{
			ans.push_back(abs(q2- now2));
		}
		else
		{
			if (q2 % 2 == 0)
			{
				if (q2 / 2 * now2 + q2 / 2 * (now2 + 1) == n)
					ans.push_back(abs(q2 - now2 - 1));
			}
			else
			{
				if (q2 / 2 * now2 + (q2 / 2 + 1) * (now2 + 1) == n || (q2/2+1)*now2 + q2/2*(now2+1)==n)
					ans.push_back(abs(q2 - now2 - 1));
			}
		}
		if(q1>1)
		q1--;
		if(q2<n)
		q2++;
		
	}
	sort(ans.begin(), ans.end());
	cout << ans[0];
	return 0;
}