﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <set>
#include <queue>
#include <string>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <ctime>  

using namespace std;

typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;

	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else return bin_pow(a, n - 1) * a;
}
ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}



int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	int n, m;
	cin >> n >> m;
	vector<vector<int>>g(n);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	set<int>s;
	map<int, int>points;
	int ans = 0;
	for (auto i : g[0]) {
		for (auto j : g[i]) {
			if (j != 0) {
				int freeze_s = s.size();
				s.insert(j);
				if (freeze_s == s.size()) {
					points[j]++;
				}
			}
		}
	}
	for (auto i : points) {
		ans += i.second * (i.second + 1);
	}
	cout << ans;
	return 0;
}