#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;

const int N = 300001;

vector < int > g[N];

bool used[N];

vector < int > ans[N];

int cnt;

int col[N];

void dfs(int v, int p) {
    used[v] = true;
    for (int to : g[v]) {
        if (to == p)
            continue;
        if (used[to]) {
            if (v > to)
                continue;
            ++cnt;
            ans[cnt].push_back(to);
            col[cnt] = v;
        }
        else {
            ans[v].push_back(to);
            dfs(to, v);
        }

    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;

    cnt = n;

    for (int i = 0; i < m; ++i) {
        int v, to;
        cin >> v >> to;
        g[v].push_back(to);
        g[to].push_back(v);
    }

    for (int i = 1; i <= n; ++i) {
        col[i] = i;
    }

    dfs(1, 1);

    cout << cnt << '\n';

    for (int i = 1; i <= cnt; ++i) {
        cout << col[i] << ' ';
    }

    cout << '\n';

    for (int i = 1; i <= cnt; ++i) {
        for (int to : ans[i]) {
            cout << i << ' ' << to << '\n';
        }
    }
    
}