#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;

const int N = 200010;

bool has1[N];

vector < int > g[N];

ll p[N], q[N];

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int v, to;
        cin >> v >> to;
        if (v > to)
            swap(v, to);
        if (v == 1) {
            has1[to] = true;
        }
        else {
            g[v].push_back(to);
            g[to].push_back(v);
        }
    }
    for (int i = 2; i <= n; ++i) {
        for (int to : g[i]) {
            if (!has1[i] && has1[to])
                ++p[i];
            if (has1[i] && has1[to])
                q[i]++;
        }
    }
    ll ans = 0;
    for (int i = 2; i <= n; ++i) {
        ans += p[i] * (p[i] - 1ll);
        ans += q[i] * (q[i] - 1ll);
    }
    cout << ans;
}