#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
	// #ifdef LOCALRUN
	// freopen("C++/input.txt", "r", stdin);
	// freopen("C++/output.txt", "w", stdout);
	// #endif

#ifndef LOCALRUN
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
}

int re[100];
int pref[1000001], height[1000001];
bool can[1000001];
int n;

void rec(int now, int need, int from, int sum = 0) {
	for (int i = from; i < n - (need - now); ++i) {
		if (now == need) {
			can[sum + re[i]] = true;
		}
		else {
			rec(now + 1, need, i + 1, sum + re[i]);
		}
	}
}

inline void solve() {
	int summ = 0;
	ll ans = 0;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> re[i];
		summ += re[i];
	}
	sort(re, re + n);
	for (int i = 0; i < n; ++i) {
		rec(0, i, 0, 0);
	}
	ans = summ + summ + 1;
	int w = 0;
	for (int i = 1; i < summ; ++i) {
		if (can[i]) {
			ans += summ - 1 - w;
			++w;
		}
	}
	cout << ans;
}

int main()
{
	prepare();
	once
		return 0;
}