#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
#ifdef LOCALRUN
    freopen("C++/input.txt", "r", stdin);
    freopen("C++/output.txt", "w", stdout);
#endif
    
#ifndef LOCALRUN
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}
intp arr[100000];
intp arr2[200000];

inline void solve() {
    int n;
    int l;
    cin >> n >> l;

    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }

    int pos = 0;

    for (int i = 0; i < n; i++) {
        if (arr[i].first != arr[(i + 1) % n].first) {
            if (arr[(i + 2) % n].first < arr[(i + 1) % n].first) {
                arr2[pos++] = {arr[i].first, arr[i].second - l};
                arr2[pos++] = {arr[(i + 1) % n].first, arr[(i + 1) % n].second - l};
            } else {
                arr2[pos++] = {arr[i].first, arr[i].second + l};
                arr2[pos++] = {arr[(i + 1) % n].first, arr[(i + 1) % n].second + l};
            }
        } else {
            if (arr[(i + 2) % n].second < arr[(i + 1) % n].second) {
                arr2[pos++] = {arr[i].first - l, arr[i].second};
                arr2[pos++] = {arr[(i + 1) % n].first - l, arr[(i + 1) % n].second};
            } else {
                arr2[pos++] = {arr[i].first + l, arr[i].second};
                arr2[pos++] = {arr[(i + 1) % n].first + l, arr[(i + 1) % n].second};
            }
        }
    }

    // for (int i = 0; i < pos; i++) {
    //     cout << arr2[i].first << ' ' << arr2[i].second << nl;
    // }

    ld sm = 0;
    for (int i = 0; i < n; i++) {
        int dx = arr2[i].first - arr2[(i + 1) % n].first;
        int dy = arr2[i].second - arr2[(i + 1) % n].second;
        sm += sqrtl(dx * dx + dy * dy);
    }
    cout << sm;
}

int main()
{
    prepare();
    once
    return 0;
}
