#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
// #ifdef LOCALRUN
//     freopen("C++/input.txt", "r", stdin);
//     freopen("C++/output.txt", "w", stdout);
// #endif
    
#ifndef LOCALRUN
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

inline void solve() {
    ll n;
    cin >> n;
    ll ans = 1e12;
    if(n == 1) {
        cout << 0;
        return;
    }
    for(ll i = 1; i * i <= n; ++i){
        ll b = i - 1;
        ll c = i + 1;
        ll d = n / (i + b) * 2, e = n / (i + c) * 2;
        ll f = n % (i + b), g = n % (i + c);
        if ((f == i || f == b) && f != 0){
            ans = min(ans, abs(d + 1 - i));

        }
        if(f == 0){
            ans = min(ans, abs(d - i));
        }
        if(g == 0){
            ans = min(ans, abs(e - c));
        }
        else if(g == i || g == c){
            ans = min(ans, abs(e + 1 - c));
        }
    }
    cout << ans;
}

int main()
{
    prepare();
    once
    return 0;
}
