#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
    // #ifdef LOCALRUN
    //     freopen("C++/input.txt", "r", stdin);
    //     freopen("C++/output.txt", "w", stdout);
    // #endif

#ifndef LOCALRUN
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

inline void solve() {
    ll n;
    cin >> n;
    ll ans = 1e12;
    for (ll i = 1; i * i <= n * 2; ++i) {
        ll a = n / i, b = n % i;
        if (b == 0) {
            ans = min(ans, abs(a - i));
        }
        else {
            if (b == (i + 1) / 2 || b == i / 2) {
                ans = min(ans, abs(a + 1 - i));
            }
        }
    }
    cout << ans;
}

int main()
{
    prepare();
    once
        return 0;
}
