#include <bits/stdc++.h>
#include <stdio.h>
#define clear cin.tie(NULL); cout.tie(NULL); ios_base::sync_with_stdio(false);
#define MAXN 200002

using namespace std;

int dfs(std::vector<std::vector<int> >& gr, set<int>& fir, int u, int v, int dep) {
    if (dep == 3) return fir.count(u);
    int res = 0;
    for (auto to : gr[u]) {
        if (to != u) res += dfs(gr, fir, v, to, dep+1);
    }
    return res;
}

int main(int argc, char const *argv[]) {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int> > gr(n);
    set<int> fir;
    for (size_t i = 0; i < m; i++) {
        int u, v;
        std::cin >> u >> v;
        --u; --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
        if (u == 0) fir.insert(v);
        if (v == 0) fir.insert(u);
    }
    std::cout << dfs(gr, fir, -1, 0, 0) << '\n';
}
