#define _USE_MATH_DEFINES
#include<iostream>
#include<algorithm>
#include<tuple>
#include<vector>
#include<deque>
#include<queue>
#include<stack>
#include<string>
#include<map>
#include<unordered_map>
#include<set>
#include<unordered_set>
#include<iomanip>
#include<math.h>
#include<functional>
#include<list>
#include<bitset>

using namespace std;

long long n, m, ans;
vector <long long> g[200000];

void bfs(long long v) {
    vector <long long> distf(n, 0);
    queue <tuple<long long, long long, long long>> q;
    for (auto i : g[0]) {
        q.emplace(i, 0, 1);
        distf[i] = 1;
    }
    while (q.size()) {
        auto [v, p, d] = q.front();
        q.pop();
        for (auto i : g[v]) {
            if (i != p) {
                if (d == 3)
                    break;
                q.emplace(i, v, d + 1);
                if (distf[i] == 0)
                    distf[i] = d + 1;
                if (d == 2 && distf[i] == 1) {
                    ans += 1;
                }
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (long long i = 0, u, v; i < m; i++) {
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    bfs(0);
    cout << ans << '\n';
}