#include <bits/stdc++.h>
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define all(x) begin(x), end(x)
#define OK cout << "OK" << endl
#define print(x) cout << x << endl
#pragma GCC optimize ("O3")
//#pragma GCC target ("avx,avx2,sse,sse2")
//#pragma GCC optimize ("O2")
#define endl '\n'
//#define int long long

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n, m, lst;
int used_edge[200007], used_node[100007];
vector<pii> g[100007], edges;
int colours[200007];

void dfs(int v)
{
    used_node[v] = 1;
    colours[v] = v;
    for(pii to : g[v])
    {
        if (used_node[to.first] == 0)
        {
            edges.pb({v, to.first});
            used_edge[to.second] = 1;
            dfs(to.first);
        }
        if (used_edge[to.second] == 0)
        {
            colours[lst] = to.first;
            edges.pb({v, lst});
            used_edge[to.second] = 1;
            lst++;
        }
    }
}

main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> m;
    for(int i = 0, v, u; i < m; i++)
    {
        cin >> v >> u;
        g[v].pb({u, i});
        g[u].pb({v, i});
    }
    lst = n + 1;
    dfs(1);
    cout << m + 1 << endl;
    for(int i = 1; i <= m + 1; i++)
    {
        cout << colours[i] << " ";
    }
    cout << endl;
    for(pii i : edges)
    {
        cout << i.first << " " << i.second << endl;
    }
}
