# include <bits/stdc++.h>
# define speed ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0)
# define int long long
# define double long double

using namespace std;

const int N = 1e6 + 7;
const int mod = 1e9 + 7;

bool used[N];
int d[N];
vector < int > adj[N];

void solve() {
    int n, m;
    cin >> n >> m;
    for ( int i = 1; i <= m; i++ ) {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    queue < int > q;
    q.push(1);
    used[1] = 1;
    d[1] = 0;
    while ( !q.empty() ) {
        int v = q.front();
        q.pop();
        for ( auto u: adj[v] ) {
            if ( !used[u] && d[v] < 2 ) {
                d[u] = d[v] + 1;
                used[u] = 1;
                q.push(u);
            }
        }
    }
    int ans = 0;
    for ( int i = 1; i <= n; i++ ) {
        if ( d[i] == 2 ) {
            int cnt = 0;
            for ( auto u: adj[i] ) {
                if ( used[u] && d[u] == 1 ) {
                    cnt++;
                }
            }
            ans += cnt * (cnt - 1);
        }
    }
    cout << ans;
}

int32_t main() {
    speed;
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int T = 1;
    //cin >> T;
    while ( T-- ) {
        solve();
    }
}
