#include <bits/stdc++.h>
#define double long double

using namespace std;
using ll = long long;

const int N = 5e5 + 5;
const double eps = 1e-7;

int n;

double u, v;

double a[N];

bool check(double x) {
	double sum = 0, sum1 = 0;
	for (int i = 1; i <= n; ++i) {
		if (u * x >= a[i])
			continue;
		double t = a[i] - u * x;
		t /= v;
		sum += t;
	}
	return sum <= x;
}

bool check2(double x) {
	double sum = 0, sum1 = 0;
	for (int i = 1; i <= n; ++i) {
		if (u * x >= a[i])
			continue;
		double t = a[i] - u * x;
		t /= v;
		sum += t;
	}
	return sum >= x;
}

int main() {
	ios :: sync_with_stdio(0), cin.tie(0);
	cin >> n >> u >> v;
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	double L = 0, R = 2e9, ans = -1;
	while (R - L > eps) {
		double M = (L + R) / 2;
		if (check(M)) {
			ans = M;
			R = M;
		}
		else {
			L = M;
		}
	}
	L = 0, R = 2e9;
	double ans2 = -1;
	while (R - L > eps) {
		double M = (L + R) / 2;
		if (check2(M)) {
			ans2 = M;
			L = M;
		}
		else {
			R = M;
		}
	}
	ans = min(ans, ans2);
	cout << fixed << setprecision(12) << ans2 * v;
	return 0;
}