#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <cstdlib>
#include <cstdio>
#include <utility>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int MAXSIZE = 1e6 + 1;

bool dp[MAXSIZE];
int dppref[MAXSIZE];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    for(int i = 1; i < MAXSIZE; ++i){
        dp[i] = false;
    }
    dp[0] = true;
    int n;
    cin >> n;
    int sum = 0;
    for(int i = 0; i < n; ++i){
        int l;
        cin >> l;
        sum += l;
        for(int j = MAXSIZE - 1; j >= l; --j){
            dp[j] |= dp[j - l];
        }
    }
    long long ans = 0;
    for(int i = 0; i <= sum; ++i){
        if(dp[i]) {
            ans += (long long) (sum - i + 1);
            if(i == 0){
                dppref[i] = 1;
            }
            else{
                dppref[i] = dppref[i - 1] + 1;
            }
        }
        else {
            ans++;
            dppref[i] = dppref[i - 1];
        }
    }
    for(int i = 1; i <= sum; ++i){
        if(dp[i]){
            ans += (long long)(sum - i + 1 - dppref[sum - i]);
        }
    }
    cout << ans;

    return 0;
}