#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define mp make_pair
#define f first
#define s second
#define sz size()
#define ll long long
#define ld long double
#define all(_v) _v.begin(), _v.end()
#define pii pair <int, int>
#define pll pair <ll, ll>
#define veci vector <int>
#define vecll vector <ll>


const int dx[4] = {1, -1, 0, 0};
const int dy[4] = {0, 0, -1, 1};
const double PI = 3.1415926535897932384626433832795;
const double eps = 1e-9;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;


const int MAXN = 3e5 + 10;
int p[MAXN];
int col[MAXN];
vector <pii> ans;

int get(int v) {
    return (v == p[v] ? v : p[v] = get(p[v]));
}

bool unite(int v, int u) {
    v = get(v),u = get(u);
    if(v == u) return 0;
    if(rand() & 1) p[v] = u;
    else p[u] = v;
    return 1;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= n; ++i) p[i] = i, col[i] = i;
    int cnt = n;
    for(int i = 1; i <= m; ++i) {
        int u, v;
        cin >> u >> v;
        if(unite(u, v)) {
            ans.pb(mp(u, v));
        } else {
            col[++cnt] = col[v];
            ans.pb(mp(u, cnt));
        }
    }
    cout << cnt << '\n';
    for(int i = 1; i <= cnt; ++i) cout << col[i] << ' ';
    cout << '\n';
    for(auto it : ans) cout << it.f << ' ' << it.s << '\n';
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    ///cin >> T;
    while(T--) solve(), cout << '\n';
    return 0;
}
