#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define mk make_pair
using namespace std;


struct point {
    int x, y;

    point() {}

    point(int x, int y) : x(x), y(y) {}
};

point m;

inline int operator*(point a, point b) {
    return a.x * b.y - b.x * a.y;
}

inline point operator-(point a, point b) {
    point c;
    c.x = a.x - b.x;
    c.y = a.y - b.y;
    return c;
}

inline bool operator==(point a, point b) {
    return a.x == b.x && a.y == b.y;
}

long double len(point a, point b) {
    return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

bool comp(point a, point b) {
    point u, v;
    v = a - m;
    u = b - m;
    if (u * v != 0) {
        return u * v > 0;
    }
    return len(a, m) < len(b, m);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, l;
    cin >> n >> l;
    m.x = 1000000000, m.y = 1000000000;
    vector<point> a;
    int x1, y1;
    for (int i = 0; i < n; ++i) {
        cin >> x1 >> y1;
        a.pb(point(x1 - l, y1));
        a.pb(point(x1 + l, y1));
        a.pb(point(x1, y1 - l));
        a.pb(point(x1, y1 + l));
    }
    n = 4 * n;
    for (int i = 0; i < n; ++i) {
        if (a[i].y < m.y || (a[i].y == m.y && a[i].x < m.x)) {
            m.x = a[i].x;
            m.y = a[i].y;
        }
    }
    a.erase(find(a.begin(), a.end(), m));
    sort(a.begin(), a.end(), comp);
    vector<point> st;
    st.pb(m);
    for (int i = 0; i < n - 1; ++i) {
        point x = a[i];
        while (st.size() >= 2) {
            point b = st[st.size() - 2];
            point c = st.back();
            if ((c - b) * (x - b) >= 0)
                st.pop_back();
            else
                break;
        }
        st.pb(x);
    }
    long double p = 0;
    //cout << st.size()<< '\n';
    int m = st.size();
    for (int i = 1; i < m; ++i) {
        p += len(st[i], st[i - 1]);
    }
    p += len(st[m - 1], st[0]);
    cout << fixed << setprecision(9) << p;
}