#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <queue>
#include <iomanip>
#include <cstdlib>
#include <fstream>

#define int long long

using namespace std;

vector < int > pred, l, r, ans, lans, rans, a;
vector < bool > used;
int cnt;

int find_set(int u)
{
    if(u == pred[u])
        return u;
    return pred[u] = find_set(pred[u]);
}

void unite(int u, int v)
{
    u = find_set(u);
    v = find_set(v);
    if(u != v)
    {
        pred[v] = u;
        cnt--;
    }
    return;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    used.resize(m);
    l.resize(m);
    r.resize(m);
    pred.resize(n);
    for(int i = 0; i < n; i++)
        pred[i] = i;
    for(int i = 0; i < m; i++)
        cin >> l[i] >> r[i];
    cnt = n;
    int sz = n;
    for(int i = 0; i < m; i++)
    {
        int cur = cnt;
        l[i]--;
        r[i]--;
        unite(l[i], r[i]);
        if(cur != cnt)
            used[i] = 1;
        else
            sz++;
    }
//    for(int i=0;i<m;i++)
//        cout<<used[i]<<" ";
    ans.resize(sz);
    lans.resize(sz - 1);
    rans.resize(sz - 1);
    a.resize(sz, -1);
    int cnt = 0;
    int cnt1 = 1;
    for(int i = 0; i < m; i++)
    {
        if(used[i] == 0)
            continue;
        int x = l[i];
        int y = r[i];
        if(a[x] == -1)
        {
            a[x] = cnt;
            cnt++;
        }
        if(a[y] == -1)
        {
            a[y] = cnt;
            cnt++;
        }
        x = a[x];
        y = a[y];
        lans[i] = x;
        rans[i] = y;
        if(ans[x] == 0)
        {
            ans[x] = cnt1;
            cnt1++;
        }
        if(ans[y] == 0)
        {
            ans[y] = cnt1;
            cnt1++;
        }
    }
    for(int i = 0; i < m; i++)
    {
        if(used[i] == 1)
            continue;
        int x = l[i];
        int y = cnt;
        if(a[x] == -1)
        {
            a[x] = cnt;
            cnt++;
        }
        a[y] = cnt;
        cnt++;
        x = a[x];
        y = a[y];
        lans[i] = x;
        rans[i] = y;
        if(ans[x] == 0)
        {
            ans[x] = cnt1;
            cnt1++;
        }
        ans[y] = ans[r[i]];
        if(ans[y] == 0)
        {
            ans[y] = cnt1;
            cnt1++;
        }
    }
    cout << sz << '\n';
    for(int i = 0; i < sz; i++)
        cout << ans[i] << " ";
    cout << '\n';
    for(int i = 0; i < sz - 1; i++)
        cout << lans[i] + 1 << " " << rans[i] + 1 << '\n';
    return 0;
}


/*
5 5
1 2
2 3
1 4
3 4
4 5
*/
