#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <queue>
#include <iomanip>
#include <cstdlib>
#include <fstream>

#define int long long

using namespace std;

vector < int > pred, l, r, ans, lans, rans;
vector < bool > used;
int cnt;

int find_set(int u)
{
    if(u == pred[u])
        return u;
    return pred[u] = find_set(pred[u]);
}

void unite(int u, int v)
{
    u = find_set(u);
    v = find_set(v);
    if(u != v)
    {
        pred[v] = u;
        cnt--;
    }
    return;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    used.resize(m);
    l.resize(m);
    r.resize(m);
    pred.resize(n);
    for(int i = 0; i < n; i++)
        pred[i] = i;
    for(int i = 0; i < m; i++)
        cin >> l[i] >> r[i];
    cnt = n;
    int sz = n;
    for(int i = 0; i < m; i++)
    {
        int cur = cnt;
        l[i]--;
        r[i]--;
        unite(l[i], r[i]);
        if(cur != cnt)
            used[i] = 1;
        else
            sz++;
    }
//    for(int i=0;i<m;i++)
//        cout<<used[i]<<" ";
    ans.resize(sz);
    for(int i = 0; i < n; i++)
        ans[i] = i + 1;
    for(int i = 0; i < m; i++)
    {
        if(!used[i])
            continue;
        lans.push_back(l[i] + 1);
        rans.push_back(r[i] + 1);
    }
    cnt = n;
    for(int i = 0; i < m; i++)
    {
        if(used[i] == 1)
            continue;
//        cout<<cnt;
        lans.push_back(l[i] + 1);
        rans.push_back(cnt + 1);
        ans[cnt] = ans[r[i]];
        cnt++;
    }
    cout << sz << '\n';
    for(int i = 0; i < sz; i++)
        cout << ans[i] << " ";
    cout << '\n';
    for(int i = 0; i < sz - 1; i++)
        cout << lans[i] << " " << rans[i] << '\n';
    return 0;
}


/*
5 5
1 2
2 3
1 4
3 4
4 5
*/
