#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;
const ll inf=1e9+5;
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);     
	int n,m;
	cin>>n>>m;
	vector<int>adj[n+1],adj2[n+1];
	map<int,bool>was;
	ll ans=0;
	while (m--) {
		int a,b;
		cin>>a>>b;
		adj[a].pb(b);
		adj[b].pb(a);
	}
	queue<int>q;
	vector<int>d(n+1,inf);
	d[1]=0;
	q.push(1);
	while (!q.empty()) {
		int x=q.front();
		q.pop();
		for (auto e:adj[x]) {
			if (d[e]>d[x]+1) {
				q.push(e);
				d[e]=d[x]+1;
			}
		}	
   	}
   	for (int i=1;i<=n;i++) {
   		for (auto e:adj[i]) {
   			if (d[i]==1) {
   				adj2[i].pb(e);
   				adj2[e].pb(i);
   			}
   		}
   	}
   	for (int i=1;i<=n;i++) {
   		if (d[i]==2) {
   			ans+=adj2[i].size()*1ll*(adj2[i].size()-1);;
   		}
   	}
   	cout<<ans;
	return 0;
}