#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

mt19937 gen(time(0));

//#define int ll
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)(x.size())
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int max_n = 1e5 + 2;
int n;
vector<int> gr[max_n];
vector<int> res1;
vector<pii> res2;
set<pii> a;
bool used[max_n];

void dfs(int v, int v1) {
  if (used[v]) return;
  used[v] = true;
  for(int i : gr[v]) {
    if (a.count(mp(i, v))) {
      res1.emplace_back(i);
      res2.emplace_back(size(res1) - 1, v1);
      a.erase(mp(i, v));
      a.erase(mp(v, i));
      dfs(i, size(res1) - 1);
    }
  }
}

void run() {
  int m;
  cin >> n >> m;
  for(int i = 0;i < m;i++) {
    int v1, v2;
    cin >> v1 >> v2;
    v1--; v2--;
    gr[v1].emplace_back(v2);
    gr[v2].emplace_back(v1);
    a.emplace(mp(v1, v2));
    a.emplace(mp(v2, v1));
  }
  res1.emplace_back(0);
  dfs(0, 0);

  cout << m + 1 << endl;

  for(int i : res1)
    cout << i + 1 << " ";
  cout << endl;
  for(pii i : res2)
    cout << i.first + 1 << " " << i.second + 1  << endl;
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  run();
}
