#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

mt19937 gen(time(0));

//#define int ll
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)(x.size())
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

const int N = 2e5 + 15;

int lol;

struct Seg {
  int cnt[4 * N], sum[4 * N];
  Seg() {
    fill(cnt, cnt + 4 * N, 0);
    fill(sum, sum + 4 * N, 0);
  }
  void upd(int v, int tl, int tr, int l, int r) {
    if (l >= r) return;
    if (tl == l && tr == r) {
      cnt[v]++;
      sum[v] += lol;
      return;
    }
    int tm = (tl + tr) / 2;
    upd(v * 2 + 1, tl, tm, l, min(r, tm));
    upd(v * 2 + 2, tm, tr, max(l, tm), r);
  }
  pair<int, int> get(int v, int tl, int tr, int pos) {
    if (tl + 1 == tr) {
      return {cnt[v], sum[v]};
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) {
      auto t = get(v * 2 + 1, tl, tm, pos);
      t.first += cnt[v];
      t.second += sum[v];
      return t;
    } else {
      auto t = get(v * 2 + 2, tm, tr, pos);
      t.first += cnt[v];
      t.second += sum[v];
      return t;
    }
  }
};

Seg ver, hor;

pair<int, int> get(int x) {
  auto v = ver.get(0, 0, N, x);
  auto h = hor.get(0, 0, N, x);
  pair<int, int> ret = {x, 0};
  ret.first += h.second - (h.first) * x;
  ret.second += h.first * x - h.second;
  ret.first += v.first * x - v.second;
  ret.second += v.second - v.first * x;
  return ret;
}

void run() {
  int n, q;
  cin >> n >> q;
  while (q--) {
    int t;
    cin >> t;
    if (t == 2) {
      int x;
      cin >> x;
      auto t = get(x);
      cout << t.first << ' ' << t.second << '\n';
      continue;
    }
    int l, r;
    cin >> l >> r;
    lol = l;
    if (l == r) continue;
    auto t1 = get(l);
    auto t2 = get(l + 1);
    if (t1.second == t2.second) {
      hor.upd(0, 0, N, l, r + 1);
    } else {
      ver.upd(0, 0, N, l, r + 1);
    }
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  run();
}
