#include <bits/stdc++.h>
using namespace std;
typedef long long s64;

template<typename T>
T epow(T a, T n){
    if(n == 0){
        return 1;
    }
    else{
        T z = epow(a, n / 2);
        z *= z;
        return n % 2 == 0 ? z : a * z;
    }
}

template<typename T>
T gcd(T a, T b){
    if(a > b){
        swap(a, b);
    }
    while(a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}

vector<vector<int>> G;
vector<bool> Vis;

vector<bool> isNeig;

s64 ans = 0;

void dfs(int v, int len){
    Vis[v] = true;
    if(len == 3){
        if(isNeig[v]){
            ans++;
        }
    }
    else{
        for(auto to : G[v]){
            if(!Vis[to]){
                dfs(to, len + 1);
            }
        }
    }
    Vis[v] = false;
}

int main() {
    //ifstream cin("input.txt");
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;
    G.resize(n);
    Vis.resize(n, false);
    isNeig.resize(n, false);
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--, v--;

        G[u].push_back(v);
        G[v].push_back(u);

        if(u == 0){
            isNeig[v] = true;
        }
        else if(v == 0){
            isNeig[u] = true;
        }
    }


    dfs(0, 0);

    cout << ans << "\n";

    /*s64 n, ans, a, b;
    cin >> n;
    ans = n;
    for(s64 h = 1; h * h <= n; h++){
        if(n % h == 0){
            s64 w = n / h;
            // relax
            ans = min(ans, abs(w-h));
        }
        // 2 case (h/2+1)*w
        s64 w = (2*n/(h*h+h));
        s64 w =
    }*/
    return 0;
}
