import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        long n=nextLong();
        long ans=1000000000;
        for (int i = 1; i <=Math.sqrt(n)+1; i++) {
            long b=n/i;
            while(b*i<n)b++;
            long z =b*i-n;
            if(i*b==n||z==i/2||z==(i+1)/2||z==b/2||z==(b+1)/2)
            ans=Math.min(ans, Math.abs(b-i));
        }
        out.print(ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader((new InputStreamReader(System.in)));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
