#include "bits/stdc++.h"

#define ios ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define ll long long
#define all(a) a.begin(),a.end()
#define sz(a) (int)a.size()
using namespace std;
int n, m;
vector<vector<int>> g;
unordered_set<int> us;
vector<bool> used;
int ans = 0;

void dfs(int x, int cnt) {
    if (cnt == 3) {
        if (us.find(x) != us.end())
            ++ans;
        return;
    }
    for (auto next: g[x])
        if (!used[next]) {
            used[next] = true;
            dfs(next, cnt + 1);
            used[next] = false;
        }
}

void solve() {
    cin >> n >> m;
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (auto next: g[0])
        us.insert(next);
    used[0] = true;
    dfs(0, 0);
    cout << ans;
}

int main() {
//    freopen("ff", "r", stdin);
//    freopen("gg", "w", stdout);
    ios;
//    int t;
//    cin>>t;
//    while (t--)j
    solve();
    return 0;
}
