/** @TeamKutbilim **/
#include <bits/stdc++.h>

using namespace std;

#define int long long

vector < pair < int, int > > edges;
int ans[1000000];

int par[100000];
int siz[100000];

int find_set(int v) {
  if (v == par[v]) return v;
  return par[v] = find_set(par[v]);
}

void unite(int a, int b) {
  a = find_set(a);
  b = find_set(b);
  if (a != b) {
    if (siz[a] < siz[b])
      swap(a, b);
    par[b] = a;
    siz[a] += siz[b];
  }
}

signed main(){
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; i++) {
    par[i] = i;
    siz[i] = 1;
  }
  for (int i = 0; i < m; i++) {
    int u, t;
    cin >> u >> t;
    u--; t--;
    //g[u].push_back(t);
    //g[t].push_back(u);
    edges.push_back(make_pair(u, t));
  }
  
  sort (edges.begin(), edges.end());
  
  vector < int > ans(n);
  vector < pair < int, int > > res;
  int chek = n, color = 1;
  
  for (int i = 0; i < m; i++) {
    int a = edges[i].first, b = edges[i].second;
    if (find_set(a) != find_set(b)) {
      unite(a, b);
      if (ans[a] == 0) {
        ans[a] = color;
        color++;
      }
      if (ans[b] == 0) {
        ans[b] = color;
        color++;
      }
      res.push_back(make_pair(a, b));
    } else {
      res.push_back(make_pair(a, chek));
      ans.push_back(ans[b]);
      chek++;
    }
  }
  cout << chek << '\n';
  for (int i = 0; i < chek; i++)
    cout << ans[i] << ' ';
  cout << '\n';
  for (int i = 0; i < res.size(); i++) {
    cout << res[i].first + 1 << ' ' << res[i].second + 1 << '\n';
  }
  /*
  dfs(0);
  */
  return 0;
}
