from math import sqrt

def suit(w, h, n):
    p = w * h
    return p == n or p - (h // 2) == n or p - ((h + 1) // 2) == n
def solve_fast(n):
    bw, bh = 1e9, 0
    s = int(sqrt(n))
    for w in range(max(0, s - 100), s + 100):
        for h in range(max(0, s - 100), s + 100):
            if suit(w,h, n):
                if abs(bw - bh) > abs(w - h):
                    bw = w
                    bh = h
    return abs(bw - bh)

print(solve_fast(int(input())))