#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

vector<vector<int>> g;
vector<bool> used;

int n, m;

vector<int> ans;
vector<pair<int, int>> t;
int c = 0;

void dfs(int u, int p){
    used[u] = true;
    int color = ++c;
    ans.push_back(color);
    int j = ans.size();

    if (p != -1)
        t.push_back({p, ans.size()});

    int cnt=  0;
    for (int v : g[u])
        if (!used[v]) {
            if (ans.back() != color){
                ans.push_back(color);
                t.push_back({ans.size(), ans.size() + 1});
            }
            dfs(v, j);
            ++cnt;
        }

}

signed main() {
    cin >> n >> m;
    g.resize(n + 1);
    used.resize(n + 1);
    for (int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1, -1);
    cout << ans.size() << "\n";
    for (int i : ans)
        cout << i << " ";
    cout << "\n";
    for (auto p : t)
        cout << p.first << " " << p.second << "\n";
}

