#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

bool used[100005];
bool uEdg[200005];
vector<vector<pair<ll, ll> > > g(100005);
vector<pair<ll, ll> > ans;
ll col[300005];
ll last_col = 0;

void dfs(ll v) {
    used[v] = true;
    col[v] = last_col;
    last_col++;
    for (auto to : g[v]) {
        if (!used[to.first]) {
            dfs(to.first);
            uEdg[to.second] = true;
            ans.emplace_back(v, to.first);
        }
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll> > Edges;
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        Edges.emplace_back(a, b);
    }
    dfs(0);

    for (int i = 0; i < m; i++) {
        if (!uEdg[i]) {
            ans.emplace_back(n, Edges[i].second);
            col[n] = col[Edges[i].first];
            n++;
        }
    }

    cout << n << '\n';
    for (int i = 0; i < n; i++) {
        cout << col[i] + 1 << ' ';
    }
    cout << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << '\n';
    }
    return 0;
}

