#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MAXN = 2 * 1e5;

vector<pair<int, int> > g[MAXN];
vector<bool> used(MAXN);
vector<int> c(MAXN * 10);
vector<bool> isInTree(MAXN * 10);

vector<pair<int, int> > ans;

void dfs(int v){
    used[v] = true;

    for(auto to : g[v]){
        if(!used[to.first]){
            dfs(to.first);
            isInTree[to.second] = true;
            ans.emplace_back(v, to.first);
        }
    }
}


signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int n, m;
    cin >> n >> m;

    vector<pair<int, int> > edges;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
        edges.emplace_back(u, v);
    }
    for(int i = 0; i < n; i++){
        c[i] = i;
    }

    dfs(0);

    for(int i = 0; i < m; i++){
        if(!isInTree[i]){
            int v = edges[i].first, to = edges[i].second;
            c[n] = c[v];
            ans.emplace_back(to, n);
            n++;
        }
    }
    cout << n << "\n";
    for(int i = 0; i < n; i++){
        cout << c[i] + 1 << " ";
    }
    cout << "\n";

    for(int i = 0; i < ans.size(); i++){
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << endl;
    }


    return 0;
}

