#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

std::map<int, std::vector<int>> res;

int Paths( int num = 1, int iter = 0, std::vector<int> crossed = { 1 } ) {
    if (iter == 3) {
        for (int i = 0; i < (int)res[num].size(); i++)
            if (res[num][i] == 1)
                return 1;       
        return 0;
    }

    int s = 0;
    for (int i = 0; i < (int)res[num].size(); i++) {
        bool ex = false; 
        for (int j = 0; j < (int)crossed.size(); j++) {
            if (res[num][i] == crossed[j])
                ex = true;
        }
        if (!ex) {
            std::vector<int> c = crossed;
            c.push_back(res[num][i]);
            s += Paths(res[num][i], iter + 1, c);
        }
    }

    return s;
}

int main() {
    int n, m, a, b, r;
    std::cin >> n >> m;
    for (int i = 0; i < m; i++) {
        std::cin >> a >> b;
        res[a].push_back(b);
        res[b].push_back(a);
    }

    r = Paths();

    return 0;
}