#include <bits/stdc++.h>

#define ll long long
#define ld double
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

using namespace std;
const ld eps = 1e-7;
const ll inf = (ll)1e18;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

ll gaziz(ll n, ll len, vector <ll> x) {
    ll lst = 0;
    for (ll i = 0; i < n; ++i) {
        ll tmp = x[i];
        x[i] -= lst;
        lst = tmp;
    }
    x[n] = len-lst;
    for (ll i = n; i < 2*n; ++i)
        x[i] += x[i-n];

    ll cnt = 1;
    ll r = 0;
    ll sum = x[0];
    ll ans = n*(n-1)*(n-2)/6;
    for (ll i = 0; i < n; ++i) {
        sum -= x[i];
        while (2*sum <= len && cnt < n) {
            ++r;
            ++cnt;
            sum += x[r];
        }
        if (2*sum > len) {
            ll xx = n - cnt;
            ans -= xx * (xx + 1) / 2;
        }
        --cnt;
    }
    return ans;
}

ll tup(ll n, ll len, vector <ll> x) {
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        for (ll j = i + 1; j < n; ++j) {
            for (ll k = j + 1; k < n; ++k) {
                if (2 * (x[j] - x[i]) <= len && 2 * (x[k] - x[j]) <= len && 2 * (len - (x[k] - x[i])) <= len) {
                    ++ans;
                }
            }
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    random_device rd;
    mt19937 rnd(time(0));
    uniform_int_distribution <ll> u1(0,20);
    uniform_int_distribution <ll> u(5,30);

    ll n , len;
    cin >> n >> len;
    vector <ll> x(2*n);
    for (ll i = 0; i < n; ++i)
        cin >> x[i];
    sort(x.begin(),x.begin()+n);
    cout << gaziz(n,len,x);


//    while (true) {
//        ll kol = u(rnd);
//        set <ll> s;
//        vector <ll> x;
//        for (ll i = 0; i < kol;++i)
//            s.insert(u1(rnd));
//        ll n = s.size();
//        if (n < 3)
//            continue;
//        x.resize(2*n);
//        ll lst = 0;
//        for (auto i: s) {
//            x[lst] = i;
//            ++lst;
//        }
//        uniform_int_distribution <ll> u2(x[n-1]+1,25);
//        ll len = u2(rnd);
//        ll an1 = gaziz(n,len,x);
//        ll an2 = tup(n,len,x);
//
//           if (an1 != an2) {
//            cout << n << ' ' << len << '\n';
//            for (auto i: x) {
//                cout << i << ' ';
//            }
//            cout << '\n';
//            cout << an1 << ' ' << an2;
//            break;
//        }
//    }
    return 0;
}