import math

n = int(input())
forces = list(map(int, input().split()))

possible_sums_set = {0}

for force in forces:
	for prev_force in possible_sums_set.copy():
		possible_sums_set.add(force + prev_force)

possible_sums = sorted(possible_sums_set)

dists = []
for i in range(1, len(possible_sums)):
	dists.append(possible_sums[i] - possible_sums[i - 1] - 1)

different_sums = len(possible_sums)

res = int(different_sums * (different_sums + 1) / 2)

for index, a_i in enumerate(dists):
	addition = 2 * (different_sums - index - 1) * a_i
	res += addition


print(res)
