import java.io.*;
import java.security.PrivilegedExceptionAction;
import java.util.*;


public class MainClass {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        StringTokenizer st = new StringTokenizer(reader.readLine());
        int n = Integer.parseInt(st.nextToken());
        long v = Integer.parseInt(st.nextToken());
        long u = Integer.parseInt(st.nextToken());
        ArrayList<Integer> arr = new ArrayList<>();
        st = new StringTokenizer(reader.readLine());
        long sum = 0;
        for (int i = 0; i < n; ++i) {
            arr.add(Integer.parseInt(st.nextToken()));
            sum += arr.get(arr.size() - 1);
        }
        double answer = 0;
        Collections.sort(arr);
        double l = 0;
        double r = sum;
        double ans = 0;
        while(l + 0.000000001 <= r){
            double mid = (l + r) / 2;
            double lost = 0;
            for(int i = 0; i < n; ++i){
                lost += Math.max(0, arr.get(i) - mid * v);
            }
            if(lost / u <= mid){
                ans = mid;
                r = mid - 0.000000001;
            }
            else{
                l = mid + 0.000000001;
            }
        }
        System.out.println(ans * u);
    }
}