#include <bits/stdc++.h>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;

vector <vector <int>> g;
vector <bool> visited;

void bfs(int u) {
    queue <int> q;
    q.push(u);
    visited[u] = 1;


    while(!q.empty()){
        int v = q.front();
        q.pop();

        for (int i = 0; i < g[v].size(); i++) {
            int to = g[v][i];

            if (!visited[to]) {
                visited[to] = 1;
                q.push(to);
            }
        }
    }
}

void dfs(int v) {
    visited[v] = 1;

    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i];

        if (!visited[to]) {
            dfs(to);
        }
    }
}

int gcd(int a, int b) {
    if (b == 0)
        return a;

    return gcd(b, a % b);
}




int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);


    ll k, n;
    cin >> k >> n;

    int p = n;
    int rounds = 0;
    for(int i = 0; i < k; i++) {
        int elem; cin >> elem;

        if(p - elem > 0) {
            p -= elem;
        }
        else if(p - elem == 0) {
            rounds++;
            p = n;
        }
    }

    cout << rounds << endl;
    cout << p << endl;

    return 0;
}

/*

4 3
1 2 4 1

*/
