#include <iostream>
#include <vector>
#include <algorithm>
#include <iterator>
#include <iomanip>
#include <set>
#include <cmath>
#include <queue>
#include <map>
#include <vector>
#include <stack>
#include <stdio.h>
#include <string.h>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#define double long double
#define ll long long
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define pii pair <int, int>
#define deb(a) cerr << #a << " = " << a << '\n';

using namespace std;
using namespace __gnu_pbds;

const ll INF = 1e18 + 7;
const int N = 2 * 1e5 + 15;
const double EPS = 1e-10;
const double PI = 3.14159265358979323846;

vector <int> g[N], tg[N];
int col = 0;
bool u[N];
pair <int, int> st[N];
int ans = 0;
int b[N], szb = 0;
map < pair <int, int>, bool> r;

void dfs (int v, int p = -1) {
    u[v] = 1;
    int sz = g[v].size();
    if (sz != 0 && p == -1) {
        col++;
        b[szb] = v + 1;
        szb++;
        tg[v].push_back(v + 1);
    }
    for (int i = 0; i < sz; i++) {
        int to = g[v][i];
        if (r[make_pair(min(to, v), max(to, v))]) {
            r[make_pair(min(to, v), max(to, v))] = 0;
            col++;
            //cout << v << ' ' << to << ' ' << col << '\n';
            tg[to].push_back(szb + 1);
            b[szb] = to + 1;
            szb++;
            st[ans] = (make_pair(tg[v][tg[v].size() - 1], szb));
            ans++;
        }
        if (!u[g[v][i]]) {
            dfs(g[v][i], v);
        }
    }
}

signed main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, x, y;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
        if (x > y)
            swap(x, y);
        r[make_pair(x, y)] = 1;
    }
    dfs(0);
    cout << col << '\n';
    for (int i = 0; i < szb; i++)
        cout << b[i] << ' ';
    cout << '\n';
    for (int i = 0; i < ans; i++) {
        cout << st[i].first << ' ' << st[i].second << '\n';
    }
    return 0;
}
