#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(0)

#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define sqr(a) ((a) * (a))
#define vout(v) cout << #v << ": " << (v) << '\n';

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = 0x7fffffff;
const ll MOD = (1 << 30) + 1;
const ld EPS = 1e-8;
const ld PI = 3.14159265358979323;
const int MAXN = 1e5 + 1000;

vector <vector <int>> g;
int used[MAXN];
vector <pii> r;
vector <int> b;


void dfs(int v, int prv) {
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++) {
        if (!used[g[v][i]]) {
            r.pb(mp(v, g[v][i]));
            dfs(g[v][i], v);
        } else if (prv != g[v][i] && prv != -1 && used[g[v][i]] != 2) {
            used[v] = 2;
            b.pb(g[v][i]);
            r.pb(mp(v, b.size()));
        }
    }
    used[v] = 2;
}

int main() {
	fast();
	int n, m;
	cin >> n >> m;
	g.resize(n + 1);
	for (int i = 1; i <= n; i++)
            b.pb(i);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
    }
    dfs(1, -1);
    cout << b.size() << '\n';
    for (int i = 0; i < b.size(); i++)
        cout << b[i] << ' ';
    cout << '\n';
    for (int i = 0; i < r.size(); i++)
        cout << r[i].ff << ' ' << r[i].ss << '\n';
    return 0;
}
