#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define deb(a) cerr << #a << " = " << a << '\n'
#define FIO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define deb2(a, b) cerr << #a << " = " << a << ", " << #b << " = " << b << '\n'

const ll INF = 1e18;
const int N = 1e2 + 100;
const ld EPS = 1e-12;
const int P = 239017;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<int> ver;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].pb(v);
        g[v].pb(u);
        if (!v)
            ver.pb(u);
        if (!u)
            ver.pb(v);
    }

    vector<ll> cnt(n);
    for (int i = 0; i < sz(ver); i++) {
        for (int j = 0; j < sz(g[ver[i]]); j++) {
            cnt[g[ver[i]][j]]++;
        }
    }

    ll ans = 0;
    for (int i = 1; i < n; i++)
        if (cnt[i]) {
            ans += cnt[i] * (cnt[i] - 1);
        }

    cout << ans;
}

int main() {
    FIO;
    int t = 1;
    //cin >> t;
    //cout << fixed << setprecision(0);
    while (t--) {
        solve();
    }
    return 0;
}
