#include<algorithm>
#include<iostream>
#include<vector>
#include<set>

#define int long long

using namespace std;

vector < vector < int > > graf(1, vector < int > (1));
vector < int > correct_finish;
vector < int > finish_links(100001, 0);
int cycle = 0;

int func(int n)
{
	return n * (n - 1);
}

signed main()
{
	int n, m;
	cin >> n >> m;
	
	graf.resize(n);
	
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		graf[a - 1].push_back(b - 1);
		graf[b - 1].push_back(a - 1);
		
		if (a == 1)
			correct_finish.push_back(b - 1);
		if (b == 1)
			correct_finish.push_back(a - 1);
	}	
	

	for (int i = 0; i < correct_finish.size(); i++)
		for (int j = 0; j < graf[correct_finish[i]].size(); j++)
			finish_links[graf[correct_finish[i]][j]] ++;
			
	for (int i = 1; i < finish_links.size(); i++)
	{
		if (finish_links[i] > 1){	
			cycle += func(finish_links[i]);
		}	
	}

	cout << cycle;	
	return 0;
}
