#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> a(n + 1);
    long long sum = 0;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    vector<vector<int>> dp(n + 1, vector<int> (sum + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= sum; ++j) {
            dp[i][j] = dp[i - 1][j];
            if (j - a[i] >= 0) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j - a[i]]);
            }
        }
    }
    long long answer = 0;
    long long yea = 0;
    for (int i = 0; i <= sum; ++i) {
        if (dp[n][i]) {
            answer += i + 1;
            yea++;
        }
    }
    answer *= 2;
    answer -= yea * (yea + 1) / 2;
    cout << answer;
    return 0;
}
