#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#define ll long long
#define ld long double

using namespace std;

const int N = 200200;
vector < ll > g[N];
int ans, pred[N];
bool check[N], check2[N];

void dfs(ll, ll, int);
int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;
    for(ll i = 0; i < m; i++){
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
        if(a == 0)
            check[b] = 1;
        else if(b == 0)
            check[a] = 1;
    }

    for(int i = 0; i < n; i++){
        if(check[i]){
            for(int j = 0; j < g[i].size(); j++){
                if(i != j && g[i][j] != 0){
                    check2[g[i][j]] = 1;
                    pred[g[i][j]] = i;
                }
            }
        }
    }
    for(int i = 0; i < n; i++){
        if(check2[i])
            for(int j = 0; j < g[i].size(); j++)
                if(check[g[i][j]] && pred[i] != g[i][j]){
                    ans++;
                }
    }
    cout << ans * 2 << '\n';
    return 0;
}

