#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
vector<ll> vec;
set<ll> st;

void func(ll n, ll w, vector<ll> used, ll s){
    w += vec[n];
    st.insert(w);
    used[n] = 1;

    for(ll i = 0; i < s; i++){
        if(!used[i])
            func(i, w, used, s);
    }
    return;
}

#define FAST ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MULTITEST ll t; cin >> t; while (t--)
#define all(a) a.begin(), a.end()
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define filer(s) freopen(s, "r", stdin)
#define filew(s) freopen(s, "w", stdout)


void solve() {
    ll n;
    cin >> n;
    vector<int> a(n + 1);
    vector<ll> used(1e3 + 1, 0);
    vec.resize(n);
    a[0] = 0;
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i + 1];
        vec[i] = a[i + 1];
        sum += a[i + 1];
    }
    /*for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < n + 1; j++) {
            if (i != j) {
                if (find(all(B), (a[i] + a[j])) == B.end()) {
                    B.push_back(a[i] + a[j]);
                }
            }
            sort(all(B));
        }
    }*/

    for(ll i = 0; i < n; i++){
        func(i, 0, used, n);
    }
    st.insert(0);
    ll k = st.size() - 2;
    ll sum2 = sum;
    for (int i = 0; i < sum + 1; i++) {
        if (find(all(st), i) == st.end()) {
            sum2 += k;
            if (k != 0)
                k--;
        } else
            sum2 += sum - i;
    }
    cout << sum2 + 1;
}

signed main() {
    solve();
}