#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
vector<ll> vec;
set<ll> st;

void func(ll n, ll w, vector<ll> used, ll s){
    w += vec[n];
    st.insert(w);
    used[n] = 1;

    for(ll i = 0; i < s; i++){
        if(!used[i])
            func(i, w, used, s);
    }
    return;
}

#define FAST ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MULTITEST ll t; cin >> t; while (t--)
#define all(a) a.begin(), a.end()
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define filer(s) freopen(s, "r", stdin)
#define filew(s) freopen(s, "w", stdout)


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n);
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    vector<ll> d(n,0);
    vector<bool> used(n,false);
    queue<ll> q;
    for(auto &i: a[0]){
        used[i] = true;
        q.push(i);
    }
    while(!q.empty()){
        ll u = q.front();
        q.pop();
        for(auto &i : a[u])
            if(!used[i])
                d[i]++;
    }
    ll ans = 0;
    for(ll i = 1; i < n; i++){
        if(d[i] > 1)
            ans += d[i];
    }
    cout << ans;
}

signed main() {
    solve();
}