#include <iostream>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
vector<ll> vec;
set<ll> st;

void func(ll n, ll w, vector<ll> used, ll s){
    w += vec[n];
    st.insert(w);
    used[n] = 1;

    for(ll i = 0; i < s; i++){
        if(!used[i])
            func(i, w, used, s);
    }
    return;
}

#define FAST ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MULTITEST ll t; cin >> t; while (t--)
#define all(a) a.begin(), a.end()
#define yes cout << "YES\n"
#define no cout << "NO\n"
#define filer(s) freopen(s, "r", stdin)
#define filew(s) freopen(s, "w", stdout)


/*void solve() {
    ll n;
    cin >> n;
    vector<int> a(n + 1);
    a[0] = 0;
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i + 1];
        sum += a[i + 1];
    }
    vector<ll> B;
    B.push_back(0);
    for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < n + 1; j++) {
            if (i != j) {
                if (find(all(B), (a[i] + a[j])) == B.end()) {
                    B.push_back(a[i] + a[j]);
                }
            }
            sort(all(B));
        }
    }
    ll k = B.size() - 1;
    ll sum2 = sum;
    for (int i = 0; i < sum + 1; i++) {
        if (find(all(B), i) == B.end()) {
            sum2 += k;
            if (k != 0)
                k--;
        } else
            sum2 += sum - i;
    }
    cout << sum2 + 1;
}*/

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n);
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    vector<ll> d(n,0);
    vector<bool> used(n,false);
    queue<ll> q;
    for(auto &i: a[0]){
        used[i] = true;
        q.push(i);
    }
    while(!q.empty()){
        ll u = q.front();
        q.pop();
        for(auto &i : a[u])
            if(!used[i])
                d[i]++;
    }
    ll ans = 0;
    for(ll i = 1; i < n; i++){
        if(d[i] == 2)
            ans += d[i];
        else if(d[i] > 1)
            ans += d[i] * 2;
    }
    cout << ans;
}

signed main() {
    solve();
}