#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()
#define int long long
struct Point{
    ld x, y;
    Point(int x, int y) : x(x), y(y) {}
    Point operator - (Point b)
    {
        return Point(x - b.x, y - b.y);
    }
};
ld dist(Point a, Point b)
{
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}
Point first(0, 0);
bool comp(Point &a, Point &b)
{
    Point delta1 = a - first;
    Point delta2 = b - first;
    if (delta1.x == 0 && delta2.x == 0) return dist(Point(0, 0), delta1) < dist(Point(0, 0), delta2);
    if (delta1.x == 0) return true;
    if (delta2.x == 0) return false;
    if (delta1.y / delta1.x == delta2.y / delta2.x)
        return dist(Point(0, 0), delta1) < dist(Point(0, 0), delta2);
    ld tg1 = delta1.y / delta1.x;
    ld tg2 = delta2.y / delta2.x;
    return tg1 > tg2;
}
ld crossProd(Point a, Point b){
    return a.x * b.y - a.y * b.x;
}
signed main() {
    int n;
    cin >> n;
    int l;
    cin >> l;
    vector <Point> polygon;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        polygon.push_back(Point(x + l, y));
        polygon.push_back(Point(x - l, y));
        polygon.push_back(Point(x, y + l));
        polygon.push_back(Point(x, y - l));
    }
    sort(all(polygon), [](Point a, Point b){
        if (a.x == b.x)
            return a.y < b.y;
        return a.x < b.x;
    });
    first = polygon[0];
    sort(all(polygon), comp);
    vector <Point> ans;
    ans.push_back(first);
    ans.push_back(polygon[1]);
    ans.push_back(polygon[2]);
    for (int i = 3; i < n * 4; i++)
    {
        if (polygon[i].x == polygon[i - 1].x && polygon[i].y == polygon[i - 1].y)
            continue;
        while (true)
        {
            if (sz(ans) == 2) break;
            Point vec1 = ans[sz(ans) - 1] - ans[sz(ans) - 2];
            Point vec2 = polygon[i] - ans[sz(ans) - 1];
            if (crossProd(vec1, vec2) > 0)
                ans.erase(prev(ans.end()));
            else
                break;
        }
        ans.push_back(polygon[i]);
    }
    ld perimeter = 0;
    for (int i = 0; i < sz(ans) - 1; i++)
        perimeter += dist(ans[i], ans[i + 1]);

    perimeter += dist(ans[0], ans[sz(ans) - 1]);

    cout << fixed << setprecision(10) << perimeter << endl;
    return 0;
}