#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef unsigned long long ull;

inline char min(char a, char b) {
    return (a < b) ? a : b;
}

int main() {
    ull n, m, a, b, _;
    cin >> n >> m;

    auto g = vector<set<ull>>(m);

    for (_ = 0; _ < m; _++) {
        cin >> a >> b;
        a--;
        b--;
        g[a].insert(b);
        g[b].insert(a);
    }

    auto pos = vector<char>(n, (char) 0);
    set<ull>::iterator h1, h2, h3;
    for (h1 = g[0].begin(); h1 != g[0].end(); h1++) {
        pos[*h1] = (char) 1;
        for (h2 = g[*h1].begin(); h2 != g[*h1].end(); h2++)
            pos[*h2] = min(2, pos[*h2]);
    }

    ull c = 0;

    for (h1 = g[0].begin(); h1 != g[0].end(); h1++) {
        for (h2 = g[*h1].begin(); h2 != g[*h1].end(); h2++) {
            if (*h2 == 0 || *h2 == *h1)
                continue;

            for (h3 = g[*h2].begin(); h3 != g[*h2].end(); h3++) {
                if (*h3 == 0 || *h3 == *h1 || *h3 == *h2)
                    continue;
                if (pos[*h3] == 1)
                    c++;
            }
        }
    }
    cout << c << endl;
}
