#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

const int K = 500;

vector<vector<int>> g;
vector<int> ht, h;
vector<pair<int, int>> ed;
map<map<int, bool>> mt;

int main()
{
  int n, m, u, v, w;
  cin >> n >> m;

  g.resize(n + 1);
  h.resize(n + 1);
  for (int i = 0; i < m; ++i) {
    cin >> u >> v;
    g[u].push_back(v);
    g[v].push_back(u);
    mt[u][v] = 1;
    mt[v][u] = 1;
    ed.push_back({u, v});
  }

  for (int i = 1; i <= n; ++i) 
    if (g[i].size() >= K) {
       h[i] = 1;
       ht.push_back(i);
    } 

  int res = 0;
  for (int i = 0; i < ht.size() - 2; ++i)
    for (int j = i + 1; j < ht.size() - 1; ++j)
      for (int k = j + 1; k < ht.size(); ++k) {
        u = ht[i], v = ht[j], w = ht[k];
        if (u == 1 || v == 1 || w == 1)
          continue;
        if (mt[u][v] && mt[v][w] && mt[w][u]) {
          int cnt = mt[u][1] + mt[v][1] + mt[w][1];
          if (cnt == 2) res += 2;
          else if (cnt == 3) res += 6;
        }
      }

  int c1 = 0, c2 = 0, c3 = 0;
  for (auto e : ed) {
    u = e.first, v = e.second;
    if (h[u] || h[v] || u == 1 || v == 1) continue;
    if (h[u] > h[v]) swap(u, v);
    if (h[v]) {
      for (auto to : g[u])
        if (to == 1) continue;
        else if (mt[to][v]) {
          if (h[to]) {
            int cnt = mt[u][1] + mt[v][1] + mt[to][1];
            if (cnt == 2) c2 += 2;
            else if (cnt == 3) c2 += 6;
          }
          else {
            int cnt = mt[u][1] + mt[v][1] + mt[to][1];
            if (cnt == 2) c3 += 2;
            else if (cnt == 3) c3 += 6;
          }
        }
    }
    else {
      for (auto to : g[u])
        if (to == 1 || h[to]) continue;
        else if (mt[to][v]) {
          int cnt = mt[u][1] + mt[v][1] + mt[to][1];
          if (cnt == 2) c1 += 2;
          else if (cnt == 3) c1 += 6;
        }
    }
  }

  cout << res + c1 / 3 + c2 / 2 + c3 / 2 << '\n';
}