#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

struct tr {
	vector<int> v;

	tr (int n) {
		v.resize(n + 2);
	}

	void add (int i, int a) {
		for (; i > 0; i -= i & (-i))
			v[i] += a;
	}

	void add (int l, int r, int a) {
		add(r - 1, a);
		add (l - 1, -a);
	}

	int get (int i) {
		int ans = 0;
		for (; i < v.size(); i += i & (-i))
			ans += v[i];
		return ans;
	}
};


int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, q;
	cin >> n >> q;

	tr tr1(n), tr2(n);

	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int l, r;
			cin >> l >> r;
			if (l == r)
				continue;
			++r;
			int l1 = tr1.get(l) + tr2.get(l) * l;
			int r1 = tr1.get(l + 1) + tr2.get(l + 1) * (l + 1);
			if (r1 == l1) {
				tr2.add(l, r, 1);
				tr1.add(l, r, -l);
			} else {
				assert(r1 == l1 + 1);
				tr2.add(l, r, -1);
				tr1.add(l, r, l);
			}
		} else {
			int ind;
			cin >> ind;
			int pos = tr1.get(ind) + tr2.get(ind) * ind;
			cout << ind - pos << ' ' << pos << '\n';
		}
	}


	return 0;
}


