#include<bits/stdc++.h>
#define ll long long
#define pb push_back
using namespace std;
int n, l, x, y;
struct pt
{
    double x, y;
};
bool cmp (pt a, pt b)
{
    return a.x < b.x || a.x == b.x && a.y < b.y;
}
bool cw (pt a, pt b, pt c)
{
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}
bool ccw (pt a, pt b, pt c)
{
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}
long double dist(pt a, pt b){
    return sqrt((a.x - b.x) * (a.x - b.x) + ((a.y - b.y)) * (a.y - b.y));
}
void convex_hull (vector<pt> & a)
{
    if (a.size() == 1)
        return;
    sort (a.begin(), a.end(), &cmp);
    pt p1 = a[0], p2 = a.back();
    vector<pt> up, down;
    up.push_back (p1);
    down.push_back (p1);
    for (size_t i=1; i<a.size(); ++i)
    {
        if (i==a.size()-1 || cw (p1, a[i], p2))
        {
            while (up.size()>=2 && !cw (up[up.size()-2], up[up. size()-1], a[i]))
                up.pop_back();
            up.push_back (a[i]);
        }
        if (i==a.size()-1 || ccw (p1, a[i], p2))
        {
            while (down.size()>=2 && !ccw (down[down.size()-2],
                                           down[down.size()-1], a[i]))
                down.pop_back();
            down.push_back (a[i]);
        }
    }
    a.clear();
    for (size_t i=0; i<up.size(); ++i)
        a.push_back (up[i]);
    for (size_t i=down.size()-2; i>0; --i)
        a.push_back (down[i]);
}
vector<pt>a;
int main()
{
    cin >> n >> l;
    for(int i = 1;i <= n;i++) {
        cin >> x >> y;
        a.pb({x - l, y});
        a.pb({x + l, y});
        a.pb({x, y - l});
        a.pb({x, y + l});
    }
    convex_hull(a);

    long double ans = 0;
    for(int i = 0;i < a.size() -1;i++) {
        cout<<a[i].x<<" "<<a[i].y<<endl;
        ans += dist(a[i], a[i + 1]);
    }
    ans += dist(a[0], a[a.size() - 1]);
    cout<<setprecision(9)<<ans;
}
