#include <iostream>
#include <algorithm>
#include <vector>
#include  <set>
using namespace std;
const int N = 1e5;
set<int> g[N + 1];
vector<int> used(N + 1);
int cnt = 0;
void dfs(int v, int dep){
    used[v] = 1;
    if(dep == 3){
        if(g[v].find(0) != g[v].end()){
            ++cnt;
        }
    }
    else{
        for(set <int> :: iterator it = g[v].begin(); it != g[v].end(); ++it){
            int u = *it;
            if(!used[u])
            dfs(u, dep + 1);
        }
    }
    used[v] = 0;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].insert(v);
        g[v].insert(u);
    }
    dfs(0, 0);
    cout << cnt;
}
