#pragma optimize("O2")
#pragma GCC optimization("O2")
#pragma unroll-loops
#pragma GCC optimization("unroll-loops")

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>
#include <sstream>

using namespace std;


#define int long long
#define ld long double
#define VI vector<int>
#define VVI vector<VI>
#define PAR pair<ld, int>
#define VP vector<PAR>
#define VB vector<bool>
#define VC vector<char>
#define SI set<int>
#define MII map<int ,int>
#define pb push_back
#define pp pop_back
#define x first
#define y second
#define VS vector<string>
#define endl '\n'
#define fori(i, n) for(int i=0;i<(n);++i)
#define foriab(i, a, b) for(int i=(a);i<(b);++i)

template<typename T> istream& operator>>(istream& in, vector<T>& v) {
    fori(i, v.size()) {
        in >> v[i];
    }
    return in;
}
       /*
template<typename T> ostream& operator<<(ostream& out, const PAR& v) {
    out<<'('<<v.x<<", "<<v.y<<')';
    return out;
}    */
template<typename T> ostream& operator<<(ostream& out, const vector<T>& v) {
    fori(i, v.size()) {
        out << v[i].x<<' '<<v[i].y << ' ';
    }
    return out;
}


#define all(v) v.begin(), v.end()
#define EPS 1e-8
bool isnul(ld x){
  return abs(x)<EPS;
}
VP compress(VP m){
  sort(all(m));
  VP nm;
  fori(i, m.size()){
    if(nm.empty()){
      nm.pb(m[i]);
      continue;
    }
    if(isnul(nm.back().x-m[i].x)){
      nm.back().y+=m[i].y;
      continue;
    }
    nm.pb(m[i]);
  }
  return nm;
}
VP clear(VP m){
  m=compress(m);
  VP nm;
  fori(i, m.size()){
    if(isnul(m[i].x)){
      continue;
    }
    if(m[i].y==0){
      continue;
    }
    nm.pb(m[i]);
  }
  return nm;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(ios_base::fixed);
    
    stringstream cin("2 1 1 30 20");   
    //stringstream cin2("5 6 1 2 2 3 2 4 1 5 4 5 3 5");
   
    int n;ld t, p;
    cin>>n>>t>>p;
    VI a(n);
    cin>>a;
    VP m;
    fori(i, n){
          m.pb(PAR(a[i], 1));
    }
    m=compress(m);

    ld eaten=0;
    while(true){
      m=clear(m);
      //cout<<m<<endl;
      if(m.size()==0){
        break;
      }
      if(m.size()==1){
        for(auto b:m){
          ld tau=b.x/(t*b.y+p);
          eaten+=tau*p*b.y;
        }
        break;
      }
      PAR bmin=m[0];
      PAR bmax=m[m.size()-1];
      PAR bbmax=m[m.size()-2];
      
      ld taum=bmin.x/t;
      ld taue=((bmax.x-bbmax.x)*((ld)bmax.y))/p;
      ld tau=min(taum, taue);
      eaten+=tau*p;
      m[m.size()-1].x-=tau*p/((ld)bmax.y);
      fori(i, m.size()){
        m[i].x-=tau*t;
      }
    }



    int c=0;
    int aa=eaten;
    while(aa){
      aa/=10;
      ++c;
    }
    if(c==0){
      c=1;
    }
     cout<<setprecision(6+c)<<eaten<<endl;
    return 0;
}
