#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <queue>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>
#include <chrono>
#include <list>
using namespace std;

//#define int ll

typedef long long ll;
typedef long double ld;
typedef pair <int , int> pii;


#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto xxxxxxxxx : (x)) cout << "{" << xxxxxxxxx.ff << ", " << xxxxxxxxx.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod=1e9+7;
const ll inf=2e18+5;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random(ll l, ll r){ return uniform_int_distribution<ll>(l, r)(rng);}

vector <int> st;
vector <pii> ans;
vector <bool> was , wase;
vector<vector<pii>> graf;

void dfs(int v , int id , int p = -1) {
    was[v] = true;
    for (auto to : graf[v]) {
        if (wase[to.second])
            continue;
        wase[to.second] = true;

        //cout << v << ' ' << to.first << ' ' << id << ' ' << int(st.size()) << '\n';

        st.push_back(to.first);
        ans.emplace_back(id , int(st.size()) - 1);

        if (!was[to.first]) {
            dfs(to.first, int(st.size()) - 1 , v);
        }
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    graf = vector<vector<pii>> (n);
    was.resize(n , false);
    wase.resize(m , false);
    vector<pair<int, int>> edges;
    for(int i=0;i<m;i++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        edges.emplace_back(x, y);
        graf[x].emplace_back(y , i);
        graf[y].emplace_back(x , i);
    }
    st = {0};
    dfs(0 , 0);
    cout << m + 1 << '\n';
    for (auto x : st) {
        cout << x + 1 << ' ';
    } cout << '\n';
    for (auto x : ans) {
        cout << x.first + 1 << ' ' << x.second + 1 << '\n';
    }

}
/*
3 2
1 2
2 3

5 5
1 2
2 3
1 4
3 4
4 5

5 6
1 2
2 3
1 3
2 4
4 5
3 5

 */
signed main() {
    IO
    //freopen(".in" , "r" , stdin);freopen(".out" , "w" , stdout);
    int t=1;
    //cin >> t;
    while(t--) solve();
}