#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <string>
#include <set>
#include <deque>
#include <map>

using namespace std;

typedef long long ll;

int n, m;
vector<vector<bool>> v(0);
vector<vector<int>> rer(0);
vector<bool> used(0);
vector<int> q(0);
vector<pair<int, int>> p(0);

void df(int now, int last) {
	used[now] = true;
	for (int i = 0; i < rer[now].size(); ++i) {

		if (rer[now][i] != last && v[now][rer[now][i]] == true) {
			pair<int, int> w;
			w.first = now + 1;
			if (used[rer[now][i]] == true) {
				q.push_back(rer[now][i] + 1);
				w.second = (int) q.size();
				v[now][rer[now][i]] = false;
				v[rer[now][i]][now] = false;
			}
			else{
				w.second = rer[now][i] + 1;
				df(rer[now][i], now);
			}
			p.push_back(w);
		}
	}
}


int main() {
	cin >> n >> m;

	rer.resize(n, vector<int>(0));
	v.resize(n, vector<bool>(n, false));
	used.resize(n, false);
	q.resize(n, 0);
	for (int i = 0; i < n; ++i) q[i] = i + 1;


	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		v[a][b] = true;
		v[b][a] = true;
		rer[a].push_back(b);
		rer[b].push_back(a);
	}
	df(0, -1);

	cout << q.size() << "\n";
	for (int i = 0; i < (int) q.size(); ++i) {
		cout << q[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < (int)p.size(); ++i) {
		cout << p[i].first << " " << p[i].second << "\n";
	}
}