#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <string>
#include <set>
#include <deque>
#include <map>

using namespace std;

typedef long long ll;

long double min(long double a, ll n) {
	if (a > n) return n;
	return a;
}
long double summ(long double t, ll n, ll v, ll u, vector<ll>& a) {
	long double res = t * u,k=t*v;
//	ll l = 0, r = n-1;
//	while (r - l > 1) {
//		ll m = (r + l) / 2;
//		if (a[m] < k) l = m;
	//	else r = m;
	//}
//	res += (n - r) * k;
	for (int i = 0; i < n; i++) res += min(k, a[i]);
	return res;
}

int main() {
	cout.precision(20);
	ll n, v, u;
	cin >> n >> v >> u;
	vector<ll> a(n);
	ll m = 0;
	long double l = 0, r = 1e18;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		m += a[i];
	}
	sort(a.begin(), a.end());
	while (r - l > 1e-9) {
		long double mid = (r + l) / 2,b=summ(mid,n,v,u,a);
	//	cout << mid << " " << b << " " << l << " " << r << endl;
		if (abs(m - b) <= 0.000001) {
			cout << mid * u;
			return 0;
		}
		if (m-b > 0 && abs(m-b)>0.0000001) l = mid;
		else r = mid;
	}
	cout << r * u;
}