#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <deque>
#include <random>
#include <string>
#include <stack>
          
using namespace std;
           
typedef long long ll;

int sum(set<ll>& result, const vector<ll>& v, ll index, ll curSum)
{
    if (index < v.size())
    {
        curSum += v[index];
        for (int i = index + 1; i < v.size(); ++i)
        {
            int res = sum(result, v, i, curSum);
            result.insert(res);
        }
    }
    return curSum;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    setlocale(LC_ALL, "ru");
    srand(time(NULL));

    ll n; cin >> n;
    vector<ll>a(n), l(1e6 + 10, 0);
    vector<bool>b(1e6 + 10, false);
    ll sm = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sm += a[i];
    }
    sort(a.begin(), a.end());
    set<ll>result;
    for (int i = 0; i < a.size(); i++) {
        ll res = sum(result, a, i, 0);
        result.insert(res);
    }
    for (auto to: result)
        b[to] = true;
    b[0] = true;
    l[0] = 1;
    for (int i = 1; i <= sm; i++){
        l[i] = l[i - 1];
        if (b[i])  
            l[i]++;
    }
    //for (int i = 0; i <= sm; i++)
      //  cout << l[i] << endl;

    ll ans = 0, k = 0;
    for (int i = 0; i <= sm; i++) 
        if (b[i])
            ans += sm - i + 1, k += (l[i]);
    //cout << ans << " " << k << endl;
    cout << ans + ans - k << endl;
}