#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int n, m;
vector < vector < int > > graf;
set <int> s;
int ANS = 0;
vector <int > used(1e5 + 113, 0);

void dfs(int v, int d) {
	used[v] = 1;

	if (d == 3) {
		if (s.count(v) == 1) {
			++ANS;
		}
		used[v] = 0;
		return;
	}

	for (auto e : graf[v]) {
		if (!used[e])
			dfs(e, d + 1);
	}

	used[v] = 0;
	return;

}

signed main() {
	
	cin >> n >> m;

	graf.resize(n + 1);

	for (int i = 0; i < m; ++i) {
		int t1, t2;
		cin >> t1 >> t2;

		graf[t1].push_back(t2);
		graf[t2].push_back(t1);
	}

	for (int i = 0; i < graf[1].size(); ++i)
		s.insert(graf[1][i]);

	dfs(1, 0);

	cout << ANS;

	return 0;
}