#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <queue>
#include <deque>
#include <tuple>
#include <cassert>
#include <cstring>

using namespace std;

#define fi first
#define se second
#define int long long


template <typename T,typename S>
istream& operator >>(istream& in, pair<T,S> &m) {
    in >> m.fi >> m.se;
    return in;
}

template <typename T>
istream& operator >>(istream& in, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        in >> m[i];
    return in;
}

template <typename T,typename S>
ostream& operator <<(ostream& out, pair<T,S> &m) {
    out << m.fi << ' ' << m.se;
    return out;
}

template <typename T>
ostream& operator <<(ostream& out, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        out << m[i] << ' ';
    return out;
}

vector<set<int>> gr;
vector<int> used, res, clr;
int last, cnt = 0;

void dfs(int v, int p = -1) {
    cnt++;
    if (cnt > 1e6) assert(0);
    if (gr.size() <= v) return;
    used[v] = 1;
    for (int i : gr[v]) {
        if (gr.size() <= i) continue;
        if (used[i] == 1 && i!=p) {
            res[last] = clr[i];
            if(gr[v].count(i)) gr[v].erase(i);
            gr[v].insert(last);
            if(gr[i].count(v)) gr[i].erase(v);
            last++;
        } else
        if (used[i] == 0) {
            dfs(i, v);
        }
    }
    used[v] = 2;
}

void solution()
{
    int n, m;
    cin >> n >> m;
    last = n;
    used.resize(1000000, 0);
    gr.resize(1000000);
    clr.resize(1000000);
    for (int i = 0; i < n; ++i) clr[i] = i+1;
    res.resize(1000000, -1);
    for (int i = 0; i < n; ++i)
        res[i] = i+1;
    for (int i = 0; i < m; ++i) {
        int u ,v;
        cin >> u >> v;
        u--; v--;
        gr[u].insert(v);
        gr[v].insert(u);
    }
    dfs(0);
    int sz = 0;
    for (int i = 0;i<res.size() && res[i] != -1; ++i) {
        sz = i+1;
    }
    cout << sz << endl;
    for (int i = 0; i < sz; ++i) cout << res[i] << ' ';
    cout << endl;
    set<pair<int,int>> usedd;
    for (int i = 0; i < n; ++i) {
        for (int j : gr[i]) {
            if (!usedd.count({max(i,j), min(i,j)})) {
                cout << i+1 << ' ' << j+1 << '\n';
                usedd.insert({max(i,j), min(i,j)});
            }
        }
    }
}

int32_t main()
{
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solution();
}



