#include <bits/stdc++.h>
#include <math.h>
using namespace std;
#define int long long

bool is_integer(double x) {
    if (x < 0)
        return false;
    double y = floor(x);
    return x == y;
}

inline long long get_sqrt(long long x) {
    long long l = -1, r = x + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (m * m <= x)
            l = m;
        else
            r = m;
    }
    if(l * l == x)
        return l;
    else
        return -1;
}


bool check_eq(int a, int b, int c) {
    long long sq = get_sqrt(b * b - 4 * a * c);
    if (sq == -1)
        return false;
    long long s = -b + sq;
    return s % (2 * a) == 0;
}


bool check(int d, int n)
{
    if (check_eq(1, d, -n)) {
        //cout << d << ' ' << 1 << '\n';
        return true;
    }
    if (check_eq(2, 2 * d - 1, - 2 * n)) {
        return true;
    }
    if (check_eq(2, 2 * d - 1, - 2 * n - 1)) {
        return true;
    }
    if (check_eq(2, 2 * d - 1, - 2 * n + 1)) {
        return true;
    }

    return false;
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for (int d = 0; ; d++) {
        if (check(d, n) || check(-d, n)) {
            cout << d;
            return 0;
        }
    }


    return 0;
}
