//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#define _CRT_SECURE_NO_WARNINGS
#define watch(x) cout << (#x) << " is " << (x) << endl;
#define pow2(x) ((x)*(x))
#define mod(x, m) ((((x) % (m)) + (m)) % (m))
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define wv(a) {cout << (#a) << " is "; for (auto i : a) cout << (i) << ' '; cout << endl;}
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <string>
#include <iomanip>
#include <deque>
#include <random>
#include <ctime>
using namespace std;
typedef long long ll;
typedef pair<int, int> ii;
typedef pair<int, ii> iii;
typedef vector<int> vi;
typedef vector <vi> vvi;
typedef vector<ii> vii;
typedef vector<iii> viii;
typedef unsigned long long ull;

const int INF = 2e9;
FILE* stream;
mt19937 rng(1337);

void solve()
{
    std::cout<<setprecision(15);
    ll a, b, c;
    cin >> a >> b >> c;
    ll sum = 0;
    vector<ll> ice;
    for (int i = 0; i<a; ++i){
        ll d;
        cin  >> d;
        ice.push_back(d);
        sum = sum+d;
    }
    double low = 0;
    double high = (double)sum/c;
    double med = (low+high)/2;
    while (high-med>0.000000001){
        double req = 0;
        for (int i = 0; i<ice.size(); ++i) {
            if (ice[i] > med * b) {
                req = req + ice[i] - med * b;
            }
        }
        double ttime = req/c;
        if (ttime>med)
            low = med;
        else high = med;
        med = (low+high)/2;



    }
    cout << high*c;


    return;
}

void solve1()
{
    ll N;
    ll ans = INF;
    cin >> N;
    ll i = 1;
    while (i * i <= N)
    {
        if (N % i == 0)
            ans = min(ans, abs(i - (N/i)));
        i++;
    }
    i = 1;
    while (i * i <= N)
    {
        if ((N- i/2)%i==0)
        {
            ll m = (N-i/2)/i;
            ans = min(ans, abs(i-m));
        }
        if ((N-(i+1)/2)%i==0)
        {
            ll m = (N-(i+1)/2)/ i;
            ans = min(ans, abs(i-m));
        }
        i++;
    }
    cout << ans << endl;
}

ll ans = 0;

void dfs(int i, vvi & g, int k, vi & used)
{
    if (k == 0)
    {
        for (auto j : g[i])
        {
            if (j == 0)
            {
                ans++;
                return;
            }
        }
        return;
    }
    used[i] = 1;
    for (auto j : g[i])
    {
        if (!used[j])
        {
            dfs(j, g, k-1, used);
        }
    }
    used[i] = 0;
}

void solveI()
{
    int n, m;
    cin >> n >> m;
    vvi g(n);
    forn(i, m)
    {
        int a, b;
        cin >> a >> b; a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vi used(n);
    vi cringe(n);
    for (auto i : g[0])
        cringe[i] = 1;
    vi d1(n,INF), d2(n,INF), d3(n), cl(n);
    d1[0] = 1;
    for (int _ = 0; _ < 3; _++)
    {
        for (int i = 0; i < n; i++)
        {
            if (d1[i] != INF && d1[i] != 0)
            {
                for (auto j : g[i])
                {
                    if (d2[j] == INF)
                        d2[j] = 0;
                    d2[j] += d1[i];
                    d3[i]--;
                }
            }
        }
        for (int i = 0; i < n; i++)
        {
            d1[i] = d2[i];
            d2[i] = d3[i];
            d3[i] = cl[i];
        }
    }
    for (auto i : g[0])
    {
        ans += d1[i];
    }
    cout << ans << endl;
}

void solveA()
{
    int a;
    cin >> a;
    vector<int> b;
    ll sum1 = 0;
    for (int i = 0; i<a; ++i){
        int k;
        cin >> k;
        b.push_back(k);
        sum1 = sum1 + k;
    }
    sort (b.begin(), b.end());
    set<int> nums;
    nums.insert(0);
    for (int i = 0; i<a; ++i){
        int neo = b[i];
        set<int> temp;
        for (auto elem: nums){
            temp.insert(elem + neo);
        }
        for (auto elem: temp){
            nums.insert(elem);
        }


    }
    long long sum = 0;
    for (auto elem: nums)
        sum = sum+elem;
    long long ans = sum * 2;
    ++ans;
    nums.erase(0);
    nums.erase(sum1);
    int sz = nums.size();
    ans = ans - sz*(sz+1)/2;

    cout << ans;

}

signed main()
{
    //freopen_s(&stream, "input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solveA();

    return 0;
}

