//#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
        
#define ll long long
#define ull unsigned ll
#define vi vector<ll>
#define vvi vector<vi>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ld long double
#define pll pair<ll, ll>
#define mt make_tuple
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define base complex<ld>

using namespace std;
const ll INF = (ll)2e9;
const ll inf = (ll)4e18;
const ld eps = (ld)1e-9;
const ll mod = (ll)1e9 + 7; 
const ll mod2 = (ll)1e9 + 9;
const ll MAXN = (ll)1e7 + 11;
const ll MAXC = (ll)1e6 + 10;
const ll MAXE = (ll)1000;
const ll MAXLOG = (ll)19;
const ll maxlen = (ll)1e5;
const ll asci = (ll)256;
const ll block = 512;
const ld PI = acos(-1LL);
const ld e = 2.7182818284;
        
/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<
pii,
null_type,
less<pii>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;*/
        
template <class T>
istream& operator >>(istream &in, vector<T> &arr){
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


struct point {
    ll x, y;
};


point operator-(point a, point b) {
    return {b.x -a.x, b.y - a.y};
}


ll cross(point a, point b) {
    return a.x * b.y - b.x * a.y;
}


ld dist(point a, point b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}


bool operator<(point a, point b) {
    return mp(a.x, a.y) < mp(b.x, b.y);
}


void solve() {
    set<point> pkk;
    ll n, l;
    cin >> n >> l;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        pkk.insert({x + l, y});
        pkk.insert({x - l, y});
        pkk.insert({x, y + l});
        pkk.insert({x, y - l});
    }
    vector<point> ps[2];
    vector<point> p;
    while (!pkk.empty()) {
        p.pb(*pkk.begin());
        pkk.erase(pkk.begin());
    }

    for (int it = 0; it < 2; it++) {
        auto &res = ps[it];
        res.pb(p[0]);
        res.pb(p[1]);
        for (int i = 2; i < p.size(); i++) {
            while (res.size() > 1) {
                auto p1 = res.back(), p2 = res[res.size() - 2];
                if (cross(p1 - p2, p[i] - p2) > 0) {
                    break;
                }
                res.pop_back();
            }
            res.pb(p[i]);
        }
        reverse(all(p));
    }
    vector<point> ans;
    for (int i = 1; i < ps[0].size(); i++) {
        ans.pb(ps[0][i]);
    }
    for (int i = 1; i < ps[1].size(); i++) {
        ans.pb(ps[1][i]);
    }
    ld len = 0;
    ans.pb(ans[0]);
    for (int i = 1; i < ans.size(); i++) {
        len += dist(ans[i], ans[i - 1]);
    }
    cout << len;
}
 
signed main() {
    srand(time(0LL));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr); 
#endif
    cout.precision(30);
    
    solve();
 
    return 0LL;
}