#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define f first
#define s second
#define forn(j, i, n) for(int i = j; i <= n; ++i)
#define all(vec) vec.begin(), vec.end()
#define ld long double
#define int ll

int const maxn = 2e5+100;

#define pii pair <int, int>


struct dot
{
    ld x, y;
};

dot operator - (dot a, dot b)
{
    return {a.x - b.x, a.y - b.y};
}

int n, l;
ld ans;
vector <dot> vec, low, up;

bool comp(dot a, dot b)
{
    if(a.x == b.x)
    {
        return a.y < b.y;
    }
    return a.x < b.x;
}

ld vecprod(dot a, dot b)
{
    return a.x*b.y - a.y*b.x;
}

ld dist(dot a ,dot b)
{
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

main()
{
    cin >> n >> l;
    forn(1, i, n)
    {
        int x, y;
        cin >> x >> y;
        vec.pb({x - l, y});
        vec.pb({x + l, y});
        vec.pb({x, y - l});
        vec.pb({x, y + l});
    }
    sort(vec.begin(), vec.end(),  comp);
    dot ldot = vec[0];
    dot udot = vec.back();
    forn(0, i, vec.size() - 1)
    {
        if(i > 0 && vec[i - 1].x == vec[i].x && vec[i - 1].y == vec[i].y) continue;
        if(vecprod(udot - ldot, vec[i]) <= 0)
        {
            while(low.size() >= 2 && vecprod(low[low.size() - 1] - low[low.size() - 2], vec[i] - low[low.size() - 2]) <= 0)
            {
                low.pop_back();
            }
            low.pb(vec[i]);
        }
        if(vecprod(udot - ldot, vec[i]) >= 0)
        {
            while(up.size() >= 2 && vecprod(up[up.size() - 1] - up[up.size() - 2], vec[i] - up[up.size() - 2]) >= 0)
            {
                up.pop_back();
            }
            up.pb(vec[i]);
        }
    }
    vec.clear();
    forn(0, i, low.size() - 1)
    {
        vec.pb(low[i]);
    }
    for(int i = up.size() - 1; i >= 0; i--)
    {
        vec.pb(up[i]);
    }
    cout << setprecision(10) << fixed;
    forn(1, i, vec.size() - 1)
    {
        ans += dist(vec[i - 1], vec[i]);
    }
    ans += dist(vec.back(), vec[0]);
    cout << ans;
}
