#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <set>
#include <iomanip>
#include <queue>

using namespace std;

#define all(x) x.begin(), x.end()
#define int long long
#define ff first
#define ss second

const int INF = 1e18;

///mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
struct st
{
	int i, v, p;
	st(int i, int v, int p) : i(i), v(v), p(p) {};
};
signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int n, m; 
	cin >> n >> m;

	vector < vector < int > > q(n); 
	vector < vector <int> > w(n, vector< int > (4, 0));
	for (int i = 0; i < m; ++i)
	{
		int a, b;cin >> a >> b;a--;b--;
		q[a].push_back(b);
		q[b].push_back(a);
	}

	queue <st> d;
	d.push({ 0, 0, -1});
	while (!d.empty())
	{
		st t = d.front();d.pop();
		int i = t.i, v = t.v, p = t.p;
		if (i > 2)
		{
			continue;
		}

		for (auto u : q[v])
		{
			if (u == p)
			{
				continue;
			}
			if (i != 2) { d.push({ i + 1, u, v }); }
			w[u][i + 1]++;
		}
	}
	int k = 0;
	for (auto u : q[0])
	{
		k += w[u][3];
	}
	cout << k << "\n";




}