﻿﻿#include <cassert>
#include <cmath>
#include <ccomplex>
#include <functional>
#include <fstream>
#include <numeric>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <stack>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>
#include <ostream>
#include <sstream>
#include <random>
#include <type_traits>
using namespace std;
using ll = long long;
vector<vector<int>> graph(100006);
vector<int> used(100006, 0);
int ans = 0;
vector<vector<int>> businki(1000000);
vector<int> color;
int n, m, m1;
vector<pair<int, int>> vershini_rebra;
vector<int> cut_rebra;

void dfs(int vertex, int parent) {
    used[vertex] = 1;
    for (auto u : graph[vertex]) {
        int i = u, v1 = vershini_rebra[u].first, u1 = vershini_rebra[u].second;
        if (v1 == vertex) u = u1;
        else u = v1;
        if (u == parent || cut_rebra[i]) { continue; }
        if (used[u]) {
            businki[m1].push_back(vertex);
            m1++;
            color.push_back(u);
            cut_rebra[i] = 1;
        }
        else {
            color[u] = u;
            businki[vertex].push_back(u);
            dfs(u, vertex);
        }
    }
}


int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int v, u;
    cin >> n >> m;
    m1 = n + 1;
    vershini_rebra.resize(m + 1);
    color.resize(n + 1);
    cut_rebra.resize(m + 1);
    for (int i = 0; i < m; i++) {
        cin >> v >> u;
        graph[v].push_back(i);
        graph[u].push_back(i);
        vershini_rebra[i] = { v, u };
    }
    color[1] = 1;
    dfs(1, -1);
    cout << color.size() - 1 << endl;
    for (int i = 1; i < color.size(); i++) cout << color[i] << " ";
    cout << endl;
    for (int i = 1; i < color.size(); i++) {
        for (int j = 0; j < businki[i].size(); j++) {
            cout << i << " " << businki[i][j] << endl;
        }
    }
}