#include <iostream>
#include <vector>

using namespace std;

int main() {
	int n, q;
	cin >> n >> q;
	vector<int[2]> a(n + 1);
	for (int i = 1; i <= n; i++) {
		a[i][0] = i;
		a[i][1] = 0;
	}
	for (int z = 0; z < q; z++) {
		int type;
		cin >> type;
		if (type == 1) {
			int l, r;
			cin >> l >> r;
			if (a[l][1] == a[r][1]) { // horizontal
				for (int i = l; i <= r; i++) {
					a[i][0] = a[l][0];
					a[i][1] = a[l][1] + i - l;
				}
			}
			else if (a[l][0] == a[r][0]) { //vertical
				for (int i = l; i <= r; i++) {
					a[i][0] = a[l][0] + i - l;
					a[i][1] = a[l][1];
				}
			}
		}
		else if (type == 2) {
			int j;
			cin >> j;
			cout << a[j][0] << " " << a[j][1] << "\n";
		}
	}
}