#include <cstring>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <queue>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <iterator>

#define ios ios_base::sync_with_stdio(0), cout.tie(0), cin.tie(0);
#define S second
#define F first
#define pb push_back
#define nl '\n'
#define NL cout << '\n';
#define EX exit(0)
#define all(s) s.begin(), s.end()
#define no_answer {cout << "NO"; exit(0);}
#define FOR(i, start, finish, k) for(llong i = start; i <= finish; i += k)

const long long MXN = 1e5 + 100;
const long long MNN = 1e2 + 1;
const long long MOD = 1e9 + 7;
const long long INF = 1e18;
const long long OO = 1e9;

typedef long long llong;
typedef unsigned long long ullong;

using namespace std;

int n, m, dp[MXN][10];
vector<int> g[MXN];
bool used[MXN];

void bfs(){
    queue<pair<int, int> > q;
    q.push({1, 0});
    while(q.size() != 0){
        pair<int, int> t = q.front();
        cout << t.F << ' ' << t.S << nl;
        q.pop();
        for(int i = 0; i < g[t.F].size(); i++){
            int to = g[t.F][i];
            if(t.S + 1 <= 3){
                dp[to][t.S + 1] += dp[t.F][t.S];
                q.push({to, t.S + 1});
            }
        }
    }
}

int main() {
    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        used[i] = false;
    }
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(int i = 0; i < g[1].size(); i++){
        int to = g[1][i];
        used[to] = true;
    }
    int ans = 0;
    for(int i = 2; i <= n; i++){
        int cnt = 0;
        for(int j = 0; j < g[i].size(); j++){
            if(used[g[i][j]] == 1){
                cnt++;
            }
        }
        ans += cnt * (cnt - 1);
    }
    cout << ans;
}
