#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

int cnt = 0;
map<int, set<int>> g;
vector<int> used;

void dfs(int v, int l) {
	used[v] = 1;
	for (auto to : g[v]) {
		if (used[to] == 0) {
			dfs(to, l + 1);
		}
		else if (used[to] == 1 && l == 4) {
			cnt++;
		}
	}
	used[v] = 2;
}

int main()
{
	int n, m;
	cin >> n >> m;
	used.resize(n);
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].insert(v);
		g[v].insert(u);
	}
	dfs(0, 0);
	cout << cnt;
	return 0;
}