//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt")
//#pragma GCC target("avx,avx2")
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<unordered_set>
#include<unordered_map>
#include<algorithm>
#include<iostream>
#include<string.h>
#include<iomanip>
#include<cstring>
#include<fstream>
#include<vector>
#include<string>
#include<memory>
#include<chrono>
#include<random>
#include<cmath>
#include<ctime>
#include<queue>
#include<stack>
#include<map>
#include<set>
using namespace std;
//no more #define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for(int i = 0; i < (n); i++)
#define cmn(a, b) (a) = min((a), (b))
#define cmx(a, b) (a) = max((a), (b))
typedef long long ll;
typedef long double ld;
void Start() {
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
}
bool endline = false;
bool endlineA = false;
template<class T>
istream& operator >> (istream& in, vector<T>& v) {
    for (auto& i : v) {
        in >> i;
    }
    return in;
}
template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto i : v) {
        out << i;
        if (!endline) {
            out << ' ';
        }
        else {
            out << '\n';
        }
    }
    if (!endline && endlineA) {
        out << '\n';
    }
    return out;
}
template<class T, class U>
istream& operator >> (istream& in, pair<T, U>& p) {
    in >> p.first >> p.second;
    return in;
}
template<class T, class U>
ostream& operator<<(ostream& out, const pair<T, U>& p) {
    out << p.first << ' ' << p.second;
    return out;
}
long long gettime() {
    return chrono::high_resolution_clock::now().time_since_epoch().count() / 1000000;
}
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
long long randnum(long long l, long long r) {
    return l + rnd() % (r - l + 1);
}
struct point {
    ll x, y;
    point() {}
    point(ll _x, ll _y) :x(_x), y(_y) {}
    point operator-(const point& p)const {
        return point(x - p.x, y - p.y);
    }
    ll operator%(const point& p)const {
        return x * p.y - y * p.x;
    }
    bool operator<(const point& p)const {
        return x < p.x || x == p.x && y < p.y;
    }
    bool operator==(const point& p)const {
        return !(*this < p) && !(p < *this);
    }
};
vector<point>convex_hull_not_trick(vector<point> v) {
    sort(all(v));
    v.erase(unique(all(v)), v.end());
    vector<point>up, down;
    point a = v[0], b = v.back();
    up.push_back(a);
    down.push_back(a);
    for (int z = 1; z < v.size(); z++) {
        point i = v[z];
        if (z == v.size() - 1 || (b - a) % (i - a) > 0) {
            while (up.size() >= 2 && (i - up.back()) % (up.back() - up[up.size() - 2]) < 0)up.pop_back();
            up.push_back(i);
        }
        if ((b - a) % (i - a) < 0) {
            while (down.size() >= 2 && (i - down.back()) % (down.back() - down[down.size() - 2]) > 0)down.pop_back();
            down.push_back(i);
        }
    }
    up.push_back(b);
    reverse(all(down));
    down.pop_back();
    for (auto i : down)up.push_back(i);
    return up;
}
ld dist(point a, point b) {
    ld dx = a.x - b.x, dy = a.y - b.y;
    return sqrt(dx * dx + dy * dy);
}
signed main() {
    Start();
    cout << setprecision(10) << fixed;
    int n, l;
    cin >> n >> l;
    vector<point>v;
    forn(i, n) {
        ld x, y;
        cin >> x >> y;
        v.push_back(point(x - l, y));
        v.push_back(point(x + l, y));
        v.push_back(point(x, y - l));
        v.push_back(point(x, y + l));
    }
    auto res = convex_hull_not_trick(v);
    ld ans = 0;
    forn(i, res.size()) {
        ans += dist(res[i], res[(i + 1) % res.size()]);
    }
    cout << ans;
    return 0;
}