 #pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
 #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt")
 #pragma GCC target("avx,avx2")
// #define INTER

#include <bits/stdc++.h>

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef std::pair<ll, ll> pll;
typedef std::pair<int, int> pii;

std::random_device rd;
std::mt19937 Random(rd());
const int inf = 0x3f3f3f3f;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ld eps = 1e-15;
const ll mod = 998244353;

//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0), std::cerr.tie(0);
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define PROBLEM "task"
#define mp std::make_pair

template<typename T, typename T1>
inline T mx(T &a, T1 b) { return (a > b ? a : a = b); }
template<typename T, typename T1>
inline T mn(T &a, T1 b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------

using namespace std;

const int MAXN = 105;
const int MAXM = 1e6 + 10;
bool dp[MAXN][MAXM];

int32_t main() {
#ifndef DEBUG
    #ifndef INTER
    fast_io;
#endif
#else
    freopen(PROBLEM".in", "r", stdin);
#endif

    std::cout << std::setprecision(15) << std::fixed;
    std::cerr << std::setprecision(15) << std::fixed;
    long double START_TIME = clock();

    int n;
    std::cin >> n;
    int a[n];
    for(int i = 0; i < n; i++) std::cin >> a[i];
    dp[0][a[0]] = true;
    dp[0][0] = true;
    for(int i = 1; i < n; i++) {
        for(int sum = 0; sum < MAXM; sum++) dp[i][sum] = dp[i - 1][sum];
        for(int sum = a[i]; sum < MAXM; sum++) dp[i][sum] |= dp[i - 1][sum - a[i]];
    }
    std::vector<ll> can;
    ll ans = 0;
    for(int i = 1; i < MAXM; i++) if(dp[n - 1][i]) can.push_back(i), ans += 2 * i;
    for(int i = 0; i < can.size(); i++) {
        ans -= i;
    }
    std::cout << ans + 1 << '\n';

    std::cerr << '\n';
    long double TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    // debug(TIME);
    return 0;
}