// #pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
// #pragma GCC target("avx,avx2")
// #define INTER

#include <bits/stdc++.h>

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef std::pair<ll, ll> pll;
typedef std::pair<int, int> pii;

std::random_device rd;
std::mt19937 Random(rd());
const int inf = 0x3f3f3f3f;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ld eps = 1e-15;
const ll mod = 998244353;

//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0), std::cerr.tie(0);
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define PROBLEM "task"
#define mp std::make_pair

template<typename T, typename T1>
inline T mx(T &a, T1 b) { return (a > b ? a : a = b); }
template<typename T, typename T1>
inline T mn(T &a, T1 b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------
using namespace std;
int32_t main() {
#ifndef DEBUG
    #ifndef INTER
    fast_io;
#endif
#else
    freopen(PROBLEM".in", "r", stdin);
#endif

    std::cout << std::setprecision(15) << std::fixed;
    std::cerr << std::setprecision(10) << std::fixed;
    long double START_TIME = clock();

    ll n, L;
    std::cin >> n >> L;
    ll a[n];
    for(int i = 0; i < n; i++) std::cin >> a[i];
    std::sort(a, a + n);
    ll ans = n * (n - 1) * (n - 2) / 6;
    ll minus = 0;
    for(int i = 0; i < n; i++) {
        ll otherside = (a[i] + (L + 1) / 2);
        // debug(otherside);
        if(otherside < L) {
            ll cntBetween = std::lower_bound(a, a + n, otherside) - a;
            if(cntBetween == n) cntBetween = n - i - 1;
            else cntBetween = cntBetween - i - 1;
            minus += cntBetween * (cntBetween - 1) / 2;
            if(L % 2 == 0) cntBetween = i + (n - (std::upper_bound(a, a + n, otherside) - a));
            else cntBetween = i + (n - (std::upper_bound(a, a + n, otherside - 1) - a));
            minus += cntBetween * (cntBetween - 1) / 2;
            continue;
        }
        otherside %= L;
        ll cntBetween = i - (std::lower_bound(a, a + n, otherside) - a) - 1;
        minus += cntBetween * (cntBetween - 1) / 2;
        cntBetween = n - i - 1 + (std::lower_bound(a, a + n, otherside) - a);
        minus += cntBetween * (cntBetween - 1) / 2;
    }
    // debug(minus);
    std::cout << ans - minus / 2 << '\n';

    std::cerr << '\n';
    long double TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    // debug(TIME);
    return 0;
}