#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <string>
#include <vector>
#include <bitset>
#include <cmath>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <ctime>

using namespace std;
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
 
/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> ii;
typedef pair <ll, ll> dl;
typedef vector <vector <int> > graph;

#define p_b push_back
#define e_b emplace_back 
#define m_p make_pair
#define ff first
#define ss second
#define watch(x) cout << (#x) << "-" << x << '\n'
const int INF = INT_MAX;
const ld EPS = 1e-8;
const ld PI = 3.14159265358979323;
const ll M = 1e9 + 7;
const int MAXN = 2e5 + 100;
#define speed(){ \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
}
#define op(){\
	freopen("input.txt", "r", stdin);\
    freopen("output.txt", "w", stdout);\
}

ll n, a[MAXN], k, k1, used[MAXN], col[MAXN];
graph g;

void dfs(int v, int x){
	used[v] = 1;
	if (x == 3){
		col[v]++;  
		//cout << v << ' ' << x << '\n';
		used[v] = 0;
		return;
	}
	for (int i = 0; i < g[v].size(); i++){
		if (!used[g[v][i]]) 
			dfs(g[v][i], x + 1);
	}
	used[v] = 0;
	return;
}

int main() {
    //clock_t Tsart = clock();
    speed();
    //op();
    int m, x, y;
    cin >> n >> m;
    g.resize(n + 10);
    for (int i = 0; i < m; i++){
    	cin >> x >> y;
    	x--, y--;
    	g[x].p_b(y);
    	g[y].p_b(x);
    }
    dfs(0, 0);
    ll c = 0;
    for (int i = 0; i < g[0].size(); i++){
    	c += col[g[0][i]];
    }
    cout << c << '\n';
    //cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    return 0;
}