#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <climits>
#include <map>
#include <iomanip>
#include <queue>
#include <random>
#include <ctime>

using namespace std;

#pragma warning (disable: 4996)

bool b[101][(long long)1e6 + 100];

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    long long n;
    cin >> n;
    vector<long long> v(n);
    long long sum = 0;
    for (long long i = 0; i < n; i++)
        cin >> v[i], sum += v[i];
    b[0][0] = 1;
    for (long long i = 1; i <= n; i++)
    {
        for (long long s = 0; s <= (long long)1e6; s++)
        {
            b[i][s] = b[i - 1][s];
            if (s >= v[i - 1])
                b[i][s] |= b[i - 1][s - v[i - 1]];
        }
    }
    vector<bool> posb(1e6 + 1, 0);
    long long ans = (1e6 + 1) * (1e6 + 1);
    vector<long long> q1(1e6 + 1, 0);
    for (long long s = 0; s <= 1e6; s++)
        posb[s] = b[n][s], q1[s] = q1[max(0, s - 1)] + posb[s];
    for (long long i = 0; i <= 1e6; i++)
    {
        if (i > sum)
            ans -= 1e6 + 1;
        else if (posb[i])
            ans -= 1e6 - sum + i;
        else
            ans -= 1e6 + 1, ans += q1[sum - i];
    }
    cout << ans;
}