#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <climits>
#include <map>
#include <iomanip>
#include <queue>
#include <random>
#include <ctime>

using namespace std;

#pragma warning (disable: 4996)

const long double EPS = 1e-9;

bool Less(long double d1, long double d2)
{
    return d1 + EPS < d2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    long long n, ans = 1e10;
    cin >> n;

    for (int i = 1; i < sqrt(10 * n); ++i) {
        if (!(n % i)) ans = min(ans, abs(n / i - i));
        if (!(n % (2 * i + 1))) ans = min(ans, abs(n / (2 * i + 1) * 2 - i - 1));
        if (!((n - i) % (2 * i + 1))) ans = min(ans, abs((n - i) / (2 * i + 1) * 2 - i));
        if (!((n - i - 1) % (2 * i + 1))) ans = min(ans, abs((n - i - 1) / (2 * i + 1) * 2 - i));
    }
    cout << ans;
}