#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <deque>
#include <algorithm>
#include <set>
#include <map>
using namespace std;
const int N = 1e5, M = 1e9 + 7;
vector <int> g[N];
set <int> f;
long long ans = 0;
void dfs(int v, int p = -1, int d = 0)
{
	if (d == 3 && v)
	{
		ans += f.count(v);
		return;
	}
	for (auto r : g[v])
		if (r != p && r)
			dfs(r, v, d + 1);
	return;
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[b].push_back(a);
		g[a].push_back(b);
	}
	for (auto r : g[0])
		f.insert(r);
	dfs(0);
	cout << ans;
}