#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;

const int N = 300101;
const double e = 1e-6;

ll x[N];

vector < ll > a, b, c;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ll n, l;
    cin >> n >> l;
    l *= 2;
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
        x[i] *= 2;
    }

    sort(x, x + n);

    for (int i = 0; i < n; ++i) {
        if (x[i] * 2 < l) {
            a.push_back(x[i]);
        }
        else {
            b.push_back(x[i]);
        }
    }

    for (int i = 0; i < a.size(); ++i) {
        c.push_back(a[i] + l / 2);
    }

    sort(c.begin(), c.end());

    ll k = 0, i = 0;

    ll ans = 0;

    while (k + 1 < c.size() && i < b.size()) {
        while (b[i] < c[k] && i + 1 < b.size())
            ++i;
        if (b[i] < c[k])
            break;
        if (b[i] > c[k + 1]) {
            ++k;
            continue;
        }
        if (b[i] == c[k + 1]) {
            ans += (ll)(i + 1) * (ll)((ll)c.size() - i - 1);
            ans += (ll)(i + 2) * (ll)((ll)c.size() - i - 2);
        }
        ans += (ll)(i + 1) * (ll)((ll)c.size() - i - 1);
        ++i;
    }

    swap(a, b);
    c.clear();

   

    for (int i = 0; i < a.size(); ++i) {
        c.push_back(a[i] + l / 2);
    }

    sort(c.begin(), c.end());

    k = 0, i = 0;

    while (k + 1 < c.size() && i < b.size()) {
        while (b[i] < c[k] && i + 1 < b.size())
            ++i;
        if (b[i] < c[k])
            break;
        if (b[i] > c[k + 1]) {
            ++k;
            continue;
        }
        if (b[i] == c[k + 1]) {
            ans += (ll)(i + 1) * (ll)((ll)c.size() - i - 1);
            ans += (ll)(i + 2) * (ll)((ll)c.size() - i - 2);
        }
        ans += (ll)(i + 1) * (ll)((ll)c.size() - i - 1);
        ++i;
    }

    cout << ans;

}