#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef int ll;

const int N = 300001;

vector <pair <ll, ll>> e[2000];
string w[2000];
ll dp[10000][10000];

bool used[2000];

pair < ll, ll > d[2000];
int p[2000];

vector < string > ans;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	string t, s;
	cin >> s >> t;
	ll n;
	cin >> n;
	for (ll i = 0; i < n; i++) {
		cin >> w[i];
	}
	w[n] = s;
	w[n + 1] = t;
	for (ll i = 0; i < n + 2; i++) {
		for (ll j = i + 1; j < n + 2; j++) {
			if (i == n && j == n + 1) {
				continue;
			}
			for (ll h = 0; h < w[i].length(); h++) {
				dp[h][0] = h;
			}
			for (ll h = 0; h < w[j].length(); h++) {
				dp[h][0] = h;
			}
			for (ll k1 = 1; k1 <= w[i].length; k1++) {
				for (ll k2 = 1; k2 <= w[j].length(); k2++) {
					if (k1 == 0 && k2 == 0) {
						continue;
					}
					if (w[i][k1 - 1] == w[j][k2 - 1]) {
						dp[k1][k2] = min(dp[k1][k2], dp[k1 - 1][k2 - 1]);
					}
					dp[k1][k2] = min(dp[k1][k2], dp[k1 - 1][k2]);
					dp[k1][k2] = min(dp[k1][k2], dp[k1][k2 - 1]);
					dp[k1][k2] = min(dp[k1][k2], dp[k1 - 1][k2 - 1] + 1);
				}
			}
			e[i].push_back(make_pair(j, dp[w[i].length()][w[j].length()]));
			e[j].push_back(make_pair(i, dp[w[i].length()][w[j].length()]));
			for (ll k1 = 1; k1 <= w[i].length; k1++) {
				for (ll k2 = 1; k2 <= w[j].length(); k2++) {
					dp[k1][k2] = 1e9;
				}
			}
		}
	} 
	for (int i = 0; i < n + 2; ++i) {
		d[i] = { 1e9 + 10, 1e9 + 10 };
	}
	d[n] = { 0, 0 };
	p[n] = -1;
	for (int it = 0; it < n + 2; ++it) {
		pair < pair < int, int >, int > Min = { {1e9 + 10, 1e9 + 10}, -1 };
		for (int i = 0; i < n + 2; ++i) {
			if (Min.first > d[i]) {
				Min = { d[i], i };
			}
		}
		used[Min.second] = true;
		int v = Min.second;
		for (int i = 0; i < e[v].size(); ++i) {
			if (d[e[v][i].first] > make_pair( d[v].first + e[v][i].second, d[v].second - 1 ))
				d[e[v][i].first] = min(d[e[v][i].first], { d[v].first + e[v][i].second, d[v].second - 1 }), p[e[v][i].first] = v;
		}
	}
	int v = n + 1;
	cout << d[n + 1].first << ' ' << d[n + 1].second << '\n';
	while (v != n) {
		ans.push_back(w[v]);
		v = p[v];
	}
	for (auto& v : ans) {
		cout << v << '\n';
	}
}