#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>

#define eps 1e-8

using namespace std;

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    
    int n;
    
    cin >> n;
    
    double v, u;
    vector <double> a(n);
    
    cin >> v >> u;
    
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());
    
    cout << '\n';
    
    double ts = 0.0;
    
    for (int i = 0; i < n - 1; ++i) {
        a[i + 1] -= ts * v;
        a[i + 1] = max(a[i + 1], 0.0);
        
        double d = a[i] - a[i + 1];
        double te = d / (u / (i + 1));
        
        double ty = a[i] / (v + u / (i + 1));
        
        te = min(te, ty);
        
        ts += te;
        
        a[i] -= te * (v + u / (i + 1));
        a[i] = max(a[i], 0.0);
        
        a[i + 1] -= te * v;
        a[i + 1] = max(a[i], 0.0);
        
        if (a[0] < eps) {
            break;
            return 0;
        }
    }
    
    double ta = a[n - 1] / (v + u / n);
    
    printf("%.8lf", (ts + ta) * u);
    
    return 0;
}

