#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()

const int N = 1e6 + 5;
const ll X = 1e12 + 5;

bool check(ll m, ll a, ll b)
{
    if (2 * a * m - a - m > b)
    {
        return false;
    }
    else
    {
        return true;
    }
}

ll findp(ll a, ll b)
{
    ll L = 0, R = X;
    while (R - 1 > L)
    {
        ll m = (L + R) / 2;
        if (check(m, a, b))
        {
            L = m;
        }
        else
        {
            R = m;
        }
    }
    if (2 * L * a - a - L != b)
    {
        return X;
    }
    return L;
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll a;
    ll ans = X;
    cin >> a;
    for (ll i = 1; i * i <= a; i++)
    {
        if (a % i == 0)
        {
            ans = min(ans, a / i - i);
            if ((a / i) % 2 == 1)
            {
                ans = min(ans, abs(2 * i - ((a / i) / 2 + 1)));
            }
            if (i % 2 == 1)
            {
                ans = min(ans, abs(2 * (a / i) - ((i) / 2 + 1)));
            }
        }

    }
    for (ll i = 1; i * i <= a; i++)
    {
        ll x = findp(i, a - 1);
        ans = min(ans, abs(i - (2 * x - 1)));
        ans = min(ans, abs(x - (2 * i - 1)));
        ll x1 = findp(i, a);
        ans = min(ans, abs(i - (2 * x1 - 1)));
        ans = min(ans, abs(x1 - (2 * i - 1)));
    }
    cout << ans;
}