#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()

const ll N = 1e5 + 500;

vector<int> e[N];
vector<int> v;
vector<int> ne[N];

bool used[N];

void dfs(int i = 0, int p = -1)
{
	used[i] = true;
	for (int j : e[i])
	{
		if (!used[j])
		{
			ne[i].push_back(j);
			dfs(j, i);
		}
		else if (j != p && i < j)
		{
			ne[i].push_back(v.size());
			v.push_back(j);
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		v.push_back(i);
	}
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		e[a].push_back(b);
		e[b].push_back(a);
	}
	dfs();
	cout << v.size() << endl;
	for (int i : v)
	{
		cout << i + 1 << " ";
	}
	cout << endl;
	for (int i = 0; i < n; i++)
	{
		for (int j : ne[i])
		{
			cout << i + 1 << " " << j + 1 << endl;
		}
	}
	return 0;
}