#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()

const int N = 5e5;

long double a[N];

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    long double v, u;
    cin >> n >> v >> u;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    long double l = 0;
    long double r = 1e9 + 3;
    while (r - l >= 5e-8)
    {
        long double m = (l + r) / 2.0;
        long double s1 = 0.0;
        for (int i = 0; i < n; i++)
        {
            s1 += max(0.0L, a[i] - m);
        }
        if ((s1 / m) < (u / v))
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    long double s = 0.0L;
    for (int i = 0; i < n; i++)
    {
        s += max(0.0L, a[i] - l);
    }
    cout << fixed << setprecision(7) << s;
}