#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()

const int N = 4e5;

double a[N];

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    double v, u;
    cin >> n >> v >> u;
    double sum = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        sum += a[i];
    }
    sort(a, a + n);
    double l = 0;
    double r = sum;
    double t = 0, k = 0;
    int cnt = 0;
    while (cnt++ < 600)
    {
        double s = (l + r) / 2.0;
        double m;
        double nt = t;
        double nk = k;
        double s1 = s - t;
        for (int i = k; i < n; i++)
        {
            if (s1 / (n - i) <= a[i])
            {
                m = s1 / (n - i);
                break;
            }
            else
            {
                s1 -= a[i];
                nt += a[i];
                nk++;
            }
        }
        if ((sum - s) / m >= u / v)
        {
            l = s;
            t = nt;
            k = nk;
        }
        else
        {
            r = s;
        }
    }
    cout << fixed << setprecision(7) << (sum - l);
}