#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> road(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        road[a].push_back(b);
        road[b].push_back(a);
    }

    vector<int> w(n);
    for (int i = 0; i < road[0].size(); i++) {
        for (int j = 0; j < road[road[0][i]].size(); j++) {
            if (road[road[0][i]][j] != 0) w[road[road[0][i]][j]]++;
        }
    }

    //for (int i = 0; i < n; i++) cout << w[i] << " ";
    long long cnt;
    for (int i = 0; i < n; i++)
        if (w[i] > 0) cnt += w[i] - 1;

    cout << 2 * cnt;

    return 0;
}