//Team: Bermud
//Coder: Emin

#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define pii pair <int, int>
#define pb push_back
#define F first
#define S second
#define ll long long
#define io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define M_PI 3.14159265358979323846

const int N = 200005;
const int mod = 1e9 + 7;

ll n, m;
vector <ll> a[N];
ll len[N], par[N];
queue <ll> q;

void BFS(ll node){
    par[node] = 1;
    q.push(node);
    while(!q.empty()){
        ll s = q.front();
        q.pop();
       // if(len[s] == 2) continue;
        for(ll i : a[s]){
            if(par[i] == 0){
                par[i] = s;
                len[i] = len[s] + 1;
                q.push(i);
            }
        }
    }
}

int main() {
    io;
    cin >> n >> m;
    for(ll i = 0; i < m; i++){
        ll x, y;
        cin >> x >> y;
        a[x].pb(y);
        a[y].pb(x);
    }
    BFS(1);
    ll ans = 0;
    for(ll i = 1; i <= n; i++){
        if(len[i] != 2) continue;
        ll cnt = 0;
        for(ll j : a[i]){
            if(len[j] == 1){
                cnt++;
                //cout << j << " ";
            }
        }
        ans += cnt * (cnt - 1);
    }
    cout << ans;
}
/*
10 14
1 5
2 5
5 6
2 3
1 3
2 4
4 6
1 6
1 7
7 8
8 1
1 10
9 10
9 8
*/
