# include <bits/stdc++.h>
# define FILE
# define parameters ( pair<int,int>p1, pair<int,int>p2, pair<int,int>p3 )
using namespace std;

int n, l;
vector < pair < int, int > > points;

bool okUp parameters{
    if( p1.second >= p2.second && p2.second <= p3.second)return true;
    if( p1.first == p2.first && p2.first == p3.first)return true;
    return false;
}
bool okDown parameters{
    if( p1.second <= p2.second && p2.second >= p3.second)return true;
    if( p1.first == p2.first && p2.first == p3.first)return true;
    return false;
}
long double get( pair <int,int>p1, pair<int,int>p2){
    return sqrt(1.0*(p1.first-p2.first)*1ll*(p1.first-p2.first) + 1.0*(p1.second-p2.second)*1ll*(p1.second-p2.second));
}
vector < pair < int, int > > process( bool(*ok)parameters ){
    vector < pair < int, int > > ver;
    ver.push_back( points[0] );
    ver.push_back( points[1]);
    for( int i = 2; i < n; i ++ ){
        while( ver.size() >= 2 && ok( ver[ver.size()-2], ver[ver.size()-1], points[i] ) ){
            ver.pop_back();
        }
        ver.push_back(points[i]);
    }
    return ver;
}

int main(){
    # ifdef FILEs
        freopen( "input.txt", "r", stdin );
        freopen( "output.txt", "w", stdout );
    # endif
    ios_base::sync_with_stdio(false);
    cin >> n >> l;
    for( int i = 0; i < n; i ++ ){
        int a, b;
        cin >> a >> b;
        points.push_back({a,b});
    }
    sort(points.begin(), points.end() );
    vector < pair <int, int> > up = process(okUp);
    vector < pair <int, int> > down = process(okDown);

    vector < pair < int, int > > upup;
    vector < pair < int, int > > downdown;
    upup.push_back({up[0].first-l, up[0].second});
    if( up[0].first == up[1].first ){
        upup.push_back({up[1].first-l, up[1].second});
    }
    for( size_t i = (up[0].first == up[1].first); i < up.size(); i ++ ){
        upup.push_back( {up[i].first, up[i].second+l});
    }
    upup.push_back({up.back().first+l, up.back().second});


    downdown.push_back({down[0].first-l, down[0].second});
    for( size_t i = 0; i < down.size() - (down[down.size()-1].first == down[down.size()-2].first); i ++ ){
        downdown.push_back({down[i].first, down[i].second-l});
    }
    if( down[down.size()-2].first == down[down.size()-1].first ){
        downdown.push_back({down[down.size()-2].first+l, down[down.size()-2].second});
    }
    downdown.push_back({down.back().first+l, down.back().second});

    long double dist = 0;
    for( size_t i = 0; i < upup.size()-1; i ++ ) dist+=get(upup[i], upup[i+1]);
    for( size_t i = 0; i < downdown.size()-1; i ++ ) dist+=get(downdown[i], downdown[i+1]);
    cout << fixed << setprecision(10) << dist << endl;
}
