﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <iomanip>
#include <string>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define pint pair<int, int>
#define pll pair<ll, ll>

const ll inf = 1e9;
const ll INF = 1e18;
const ll M = 998244353;

#define int ll

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n;
    cin >> n;
    vector <int> a(n);
    int sum = 1;
    for (auto& x : a) {
        cin >> x;
        sum += x;
    }
    vector <int> dp(sum);
    dp[0] = 1;
    for (auto& x : a) {
        for (int i = sum - x - 1; i >= 0; i--) {
            if (dp[i]) {
                dp[i + x] = 1;
            }
        }
    }
    vector <int> good;
    for (int i = 0; i < sum; ++i) {
        if (dp[i]) {
            good.push_back(i);
        }
    }
    int ans = sum;
    for (int i = 1; i < good.size(); ++i) {
        ans += (sum - good[i]) + (good.size() - i) * (good[i] - good[i - 1] - 1);
    }
    cout << ans;
    return 0;
}