﻿#include <algorithm>
#include <iostream>
#include <vector>
#include <iomanip>
#include <string>
#include <queue>
#include <cmath>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define pint pair<int, int>
#define pll pair<ll, ll>

const ll inf = 1e9;
const ll INF = 1e18;
const ll M = 998244353;
const double eps = 1e-10;

#define int ll

struct v
{
    int x, y;
    v(int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    v()
    {
        x = 0;
        y = 0;
    }
};
v operator+ (v a, v b)
{
    v vv;
    vv.x = a.x + b.x;
    vv.y = a.y + b.y;
    return vv;
}
v operator- (v a, v b)
{
    v vv;
    vv.x = a.x - b.x;
    vv.y = a.y - b.y;
    return vv;
}
ll operator* (v a, v b)
{
    return (a.x * b.x) + (a.y * b.y);
}
ll operator^ (v a, v b)
{
    return (a.x * b.y) - (a.y * b.x);
}
ll len(v a, v b)
{
    return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}
v xx;
bool cmp(v a, v b)
{
    v p = v(xx.x + 1, xx.y);
    if (((a - xx) ^ (b - xx)) == 0)
    {
        return (len(a, xx) < len(b, xx));
    }
    return (((a - xx) ^ (b - xx)) > 0);
}
void pp(vector<v> a)
{
    cout << "----\n";
    for (int i = 0; i < a.size(); ++i)
        cout << a[i].x << ' ' << a[i].y << '\n';
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    
    double n, l; cin >> n >> l;
    vector<v> ps(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> ps[i].x >> ps[i].y;
    }
    vector<v> a;
    for (int i = 0; i < n; ++i)
    {
        v pp = ps[i];
        pp.x += l;
        a.push_back(pp);
        pp = ps[i];
        pp.y += l;
        a.push_back(pp);
        pp = ps[i];
        pp.y -= l;
        a.push_back(pp);
        pp = ps[i];
        pp.x -= l;
        a.push_back(pp);
    }
    pair<v, int> x = { v(INF, INF), -1 };
    for (int i = 0; i < n; ++i)
    {
        if (a[i].y < x.first.y)
        {
            x = { a[i], i };
        }
        if (a[i].y == x.first.y && a[i].x < x.first.x)
        {
            x = { a[i], i };
        }
    }
    xx = x.first;
    swap(a[0], a[x.second]);
    //a.resize(unique(a.begin(), a.end()) - a.begin());
    sort(a.begin() + 1, a.end(), cmp);
    a.push_back(xx);
    vector<v> g{a[0], a[1]};
    for (int i = 2; i < a.size(); ++i)
    {
        v x = a[i];
        while (g.size() >= 2)
        {
            v p1 = g[g.size() - 2];
            v p2 = g[g.size() - 1];
            if (((p2 - p1) ^ (x - p1)) <= 0 || (x.x == p2.x && x.y == p2.y))
            {
                g.pop_back();
            }
            else
                break;
        }
        g.push_back(x);
    }
    double ans = 0.0;
    for (int i = 1; i < g.size(); ++i)
    {
        ans += sqrt(len(g[i], g[i - 1]));
    }
    cout << fixed << setprecision(10) << ans << '\n';
}